DROP TABLE IF EXISTS skynet_rates;
CREATE TABLE skynet_rates (
  service char(2) NOT NULL default '',
  band tinyint(3) unsigned NOT NULL default '0',
  basic float NOT NULL default '0',
  per_kg float NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

DROP TABLE IF EXISTS skynet_zones_postcodes;
CREATE TABLE skynet_zones_postcodes (
  zone char(3) NOT NULL default '',
  postcode_start varchar(4) NOT NULL default '',
  postcode_end varchar(4) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

DROP TABLE IF EXISTS skynet_zones_bands;
CREATE TABLE skynet_zones_bands (
  zone_from char(3) NOT NULL default '',
  zone_to char(3) NOT NULL default '',
  band tinyint(3) unsigned NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

INSERT INTO `skynet_rates` VALUES ('DP', 1, 13, 0.7);
INSERT INTO `skynet_rates` VALUES ('DP', 2, 21, 5.7);
INSERT INTO `skynet_rates` VALUES ('DP', 3, 25, 10.3);
INSERT INTO `skynet_rates` VALUES ('DP', 4, 29, 13.7);
INSERT INTO `skynet_rates` VALUES ('DP', 5, 29, 21);
INSERT INTO `skynet_rates` VALUES ('DP', 6, 34, 25);
INSERT INTO `skynet_rates` VALUES ('DP', 7, 40, 34);
INSERT INTO `skynet_rates` VALUES ('DS', 1, 13, 0.7);
INSERT INTO `skynet_rates` VALUES ('DS', 2, 17, 2.3);
INSERT INTO `skynet_rates` VALUES ('DS', 3, 21, 3.4);
INSERT INTO `skynet_rates` VALUES ('DS', 4, 21, 4.5);
INSERT INTO `skynet_rates` VALUES ('DS', 5, 23, 5.7);
INSERT INTO `skynet_rates` VALUES ('DS', 6, 29, 6.8);
INSERT INTO `skynet_rates` VALUES ('DS', 7, 34, 8);

INSERT INTO `skynet_zones_postcodes` VALUES ('AC1', '2900', '2914');
INSERT INTO `skynet_zones_postcodes` VALUES ('AC1', '2600', '2620');
INSERT INTO `skynet_zones_postcodes` VALUES ('NS1', '2535', '2551');
INSERT INTO `skynet_zones_postcodes` VALUES ('NS1', '2000', '2234');
INSERT INTO `skynet_zones_postcodes` VALUES ('NS2', '2250', '2339');
INSERT INTO `skynet_zones_postcodes` VALUES ('NS2', '2500', '2534');
INSERT INTO `skynet_zones_postcodes` VALUES ('NS2', '2558', '2577');
INSERT INTO `skynet_zones_postcodes` VALUES ('NS2', '2745', '2786');
INSERT INTO `skynet_zones_postcodes` VALUES ('NS3', '2578', '2594');
INSERT INTO `skynet_zones_postcodes` VALUES ('NS3', '2787', '2899');
INSERT INTO `skynet_zones_postcodes` VALUES ('NS3', '2340', '2490');
INSERT INTO `skynet_zones_postcodes` VALUES ('NS3', '2621', '2739');
INSERT INTO `skynet_zones_postcodes` VALUES ('NT1', '0800', '0820');
INSERT INTO `skynet_zones_postcodes` VALUES ('NT1', '0828', '0836');
INSERT INTO `skynet_zones_postcodes` VALUES ('NT1', '0870', '0870');
INSERT INTO `skynet_zones_postcodes` VALUES ('NT2', '0822', '0822');
INSERT INTO `skynet_zones_postcodes` VALUES ('NT2', '0872', '0886');
INSERT INTO `skynet_zones_postcodes` VALUES ('NT2', '0837', '0862');
INSERT INTO `skynet_zones_postcodes` VALUES ('QL1', '4000', '4209');
INSERT INTO `skynet_zones_postcodes` VALUES ('QL2', '4500', '4521');
INSERT INTO `skynet_zones_postcodes` VALUES ('QL2', '4351', '4498');
INSERT INTO `skynet_zones_postcodes` VALUES ('QL2', '4210', '4350');
INSERT INTO `skynet_zones_postcodes` VALUES ('QL3', '4694', '4805');
INSERT INTO `skynet_zones_postcodes` VALUES ('QL3', '4605', '4680');
INSERT INTO `skynet_zones_postcodes` VALUES ('QL3', '4825', '4830');
INSERT INTO `skynet_zones_postcodes` VALUES ('QL3', '4550', '4601');
INSERT INTO `skynet_zones_postcodes` VALUES ('QL4', '4806', '4824');
INSERT INTO `skynet_zones_postcodes` VALUES ('QL4', '4849', '4891');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA1', '5160', '5169');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA1', '5950', '5950');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA1', '5000', '5049');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA2', '5170', '5214');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA2', '5050', '5159');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA2', '5350', '5373');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA2', '5460', '5460');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA2', '5400', '5412');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA2', '5265', '5267');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA2', '5231', '5260');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA2', '5501', '5502');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA3', '5510', '5734');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA3', '5461', '5495');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA3', '5413', '5455');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA3', '5220', '5223');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA3', '5261', '5263');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA3', '5374', '5381');
INSERT INTO `skynet_zones_postcodes` VALUES ('SA3', '5268', '5346');
INSERT INTO `skynet_zones_postcodes` VALUES ('TA1', '7000', '7470');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC1', '3000', '3207');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC2', '3427', '3442');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC2', '3750', '3810');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC2', '3211', '3228');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC2', '3910', '3920');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC2', '3335', '3341');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC2', '3975', '3978');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC2', '3980', '3981');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC2', '3926', '3944');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC3', '3984', '3996');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC3', '3979', '3979');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC3', '3230', '3334');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC3', '3342', '3424');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC3', '3921', '3925');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC3', '3812', '3909');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC3', '3444', '3749');
INSERT INTO `skynet_zones_postcodes` VALUES ('VC3', '3945', '3971');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA1', '6147', '6160');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA1', '6162', '6172');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA1', '6000', '6032');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA1', '6817', '6987');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA1', '6050', '6083');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA1', '6090', '6112');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA2', '6438', '6438');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA2', '6443', '6445');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA2', '6033', '6044');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA2', '6173', '6428');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA2', '6084', '6084');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA2', '6161', '6161');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA2', '6121', '6126');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA2', '6173', '6428');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA3', '6428', '6437');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA3', '6446', '6799');
INSERT INTO `skynet_zones_postcodes` VALUES ('WA3', '6439', '6442');

INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'AC1', 1);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'AC1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'AC1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'AC1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'AC1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'AC1', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'AC1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'AC1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'AC1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'AC1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'AC1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'AC1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'AC1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'AC1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'AC1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'AC1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'AC1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'AC1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'AC1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'AC1', 7);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'NS1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'NS1', 1);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'NS1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'NS1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'NS1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'NS1', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'NS1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'NS1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'NS1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'NS1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'NS1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'NS1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'NS1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'NS1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'NS1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'NS1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'NS1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'NS1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'NS1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'NS1', 7);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'NS2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'NS2', 2);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'NS2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'NS2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'NS2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'NS2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'NS2', 2);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'NS2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'NS2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'NS2', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'NS2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'NS2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'NS2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'NS2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'NS2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'NS2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'NS2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'NS2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'NS2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'NS2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'NS3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'NS3', 2);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'NS3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'NS3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'NS3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'NS3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'NS3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'NS3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'NS3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'NS3', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'NS3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'NS3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'NS3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'NS3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'NS3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'NS3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'NS3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'NS3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'NS3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'NS3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'NT1', 7);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'NT1', 7);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'NT1', 1);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'NT1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'NT1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'NT1', 7);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'NT1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'NT2', 5);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'NT2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'NT2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'QL1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'QL1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'QL1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'QL1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'QL1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'QL1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'QL1', 1);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'QL1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'QL1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'QL1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'QL1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'QL1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'QL1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'QL1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'QL1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'QL1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'QL1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'QL1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'QL1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'QL1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'QL2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'QL2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'QL2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'QL2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'QL2', 5);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'QL2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'QL2', 2);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'QL2', 2);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'QL2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'QL2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'QL2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'QL2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'QL2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'QL2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'QL2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'QL2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'QL2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'QL2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'QL2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'QL2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'QL3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'QL3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'QL3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'QL3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'QL3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'QL3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'QL3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'QL3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'QL3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'QL3', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'QL3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'QL3', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'QL3', 5);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'QL3', 5);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'QL3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'QL3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'QL3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'QL3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'QL3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'QL3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'QL4', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'QL4', 5);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'QL4', 5);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'QL4', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'QL4', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'QL4', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'QL4', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'QL4', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'QL4', 5);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'QL4', 6);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'QL4', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'QL4', 6);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'QL4', 6);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'QL4', 5);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'QL4', 5);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'QL4', 5);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'QL4', 5);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'QL4', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'QL4', 7);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'QL4', 7);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'SA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'SA1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'SA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'SA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'SA1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'SA1', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'SA1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'SA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'SA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'SA1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'SA1', 1);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'SA1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'SA1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'SA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'SA1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'SA1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'SA1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'SA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'SA1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'SA1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'SA2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'SA2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'SA2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'SA2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'SA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'SA2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'SA2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'SA2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'SA2', 5);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'SA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'SA2', 2);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'SA2', 2);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'SA2', 2);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'SA2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'SA2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'SA2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'SA2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'SA2', 5);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'SA2', 5);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'SA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'SA3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'SA3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'SA3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'SA3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'SA3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'SA3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'SA3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'SA3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'SA3', 5);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'SA3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'SA3', 2);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'SA3', 2);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'SA3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'SA3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'SA3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'SA3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'SA3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'SA3', 5);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'SA3', 5);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'SA3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'TA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'TA1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'TA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'TA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'TA1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'TA1', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'TA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'TA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'TA1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'TA1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'TA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'TA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'TA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'TA1', 1);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'TA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'TA1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'TA1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'TA1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'TA1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'TA1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'VC1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'VC1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'VC1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'VC1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'VC1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'VC1', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'VC1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'VC1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'VC1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'VC1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'VC1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'VC1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'VC1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'VC1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'VC1', 1);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'VC1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'VC1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'VC1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'VC1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'VC1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'VC2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'VC2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'VC2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'VC2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'VC2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'VC2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'VC2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'VC2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'VC2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'VC2', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'VC2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'VC2', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'VC2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'VC2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'VC2', 2);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'VC2', 2);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'VC2', 2);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'VC2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'VC2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'VC2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'VC3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'VC3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'VC3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'VC3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'VC3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'VC3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'VC3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'VC3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'VC3', 4);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'VC3', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'VC3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'VC3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'VC3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'VC3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'VC3', 2);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'VC3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'VC3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'VC3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'VC3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'VC3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'WA1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'WA1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'WA1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'WA1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'WA1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'WA1', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'WA1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'WA1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'WA1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'WA1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'WA1', 4);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'WA1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'WA1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'WA1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'WA1', 5);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'WA1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'WA1', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'WA1', 1);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'WA1', 2);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'WA1', 3);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'WA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'WA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'WA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'WA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'WA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'WA2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'WA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'WA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'WA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'WA2', 7);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'WA2', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'WA2', 5);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'WA2', 5);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'WA2', 5);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'WA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'WA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'WA2', 6);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'WA2', 2);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'WA2', 2);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'WA2', 3);
INSERT INTO `skynet_zones_bands` VALUES ('AC1', 'WA3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('NS1', 'WA3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('NS2', 'WA3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('NS3', 'WA3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('NT1', 'WA3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('NT2', 'WA3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL1', 'WA3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL2', 'WA3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL3', 'WA3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('QL4', 'WA3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('SA1', 'WA3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('SA2', 'WA3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('SA3', 'WA3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('TA1', 'WA3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('VC1', 'WA3', 6);
INSERT INTO `skynet_zones_bands` VALUES ('VC2', 'WA3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('VC3', 'WA3', 7);
INSERT INTO `skynet_zones_bands` VALUES ('WA1', 'WA3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('WA2', 'WA3', 3);
INSERT INTO `skynet_zones_bands` VALUES ('WA3', 'WA3', 3);

INSERT into sql_queries values('freeway_v1_1_5.sql',now()); 
