

#
# Structure for the `address_book` table : 
#
DROP TABLE IF EXISTS `address_book`;
CREATE TABLE `address_book` (
  `address_book_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `entry_gender` char(1) NOT NULL default '',
  `entry_company` varchar(32) default NULL,
  `entry_firstname` varchar(32) NOT NULL default '',
  `entry_lastname` varchar(32) NOT NULL default '',
  `entry_street_address` varchar(64) NOT NULL default '',
  `entry_suburb` varchar(32) default NULL,
  `entry_postcode` varchar(10) NOT NULL default '',
  `entry_city` varchar(32) NOT NULL default '',
  `entry_state` varchar(32) default NULL,
  `entry_country_id` int(11) NOT NULL default '0',
  `entry_zone_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`address_book_id`),
  KEY `idx_address_book_customers_id` (`customers_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `address_format` table : 
#
DROP TABLE IF EXISTS `address_format`;
CREATE TABLE `address_format` (
  `address_format_id` int(11) NOT NULL auto_increment,
  `address_format` varchar(128) NOT NULL default '',
  `address_summary` varchar(48) NOT NULL default '',
  PRIMARY KEY  (`address_format_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `admin` table : 
#
DROP TABLE IF EXISTS `admin`;
CREATE TABLE `admin` (
  `admin_id` int(11) NOT NULL auto_increment,
  `admin_groups_id` int(11) default '0',
  `admin_firstname` varchar(32) NOT NULL default '',
  `admin_lastname` varchar(32) default NULL,
  `admin_email_address` varchar(96) NOT NULL default '',
  `admin_password` varchar(40) NOT NULL default '',
  `admin_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `admin_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `admin_logdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `admin_lognum` int(11) NOT NULL default '0',
  `admin_hide_backend` char(1) default 'N',
  `encryption_style` varchar(1) NOT NULL default 'O',
  PRIMARY KEY  (`admin_id`),
  UNIQUE KEY `admin_email_address` (`admin_email_address`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `admin_files` table : 
#
DROP TABLE IF EXISTS `admin_files`;
CREATE TABLE `admin_files` (
  `admin_files_id` int(11) NOT NULL auto_increment,
  `admin_files_name` varchar(64) NOT NULL default '',
  `admin_files_is_boxes` tinyint(5) NOT NULL default '0',
  `admin_files_to_boxes` int(11) NOT NULL default '0',
  `admin_groups_id` varchar(255) NOT NULL default '1',
  `admin_files_type` varchar(1) NOT NULL default 'D',
  `admin_files_help_id` varchar(1) NOT NULL default 'D',
  `admin_new_group_id` int(11) default NULL,
  PRIMARY KEY  (`admin_files_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `admin_files_groups` table : 
#
DROP TABLE IF EXISTS `admin_files_groups`;
CREATE TABLE `admin_files_groups` (
  `admin_files_groups_id` int(11) default NULL,
  `admin_files_groups_name` varchar(40) default NULL,
  `admin_files_groups_desc` text,
  `admin_groups_id` varchar(255) NOT NULL default '1'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `admin_groups` table : 
#
DROP TABLE IF EXISTS `admin_groups`;
CREATE TABLE `admin_groups` (
  `admin_groups_id` int(11) NOT NULL auto_increment,
  `admin_groups_name` varchar(64) default NULL,
  `admin_groups_type` varchar(1) NOT NULL default 'D',
  PRIMARY KEY  (`admin_groups_id`),
  UNIQUE KEY `admin_groups_name` (`admin_groups_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `affiliate_affiliate` table : 
#
DROP TABLE IF EXISTS `affiliate_affiliate`;
CREATE TABLE `affiliate_affiliate` (
  `affiliate_id` int(11) NOT NULL auto_increment,
  `affiliate_gender` char(1) NOT NULL default '',
  `affiliate_firstname` varchar(32) NOT NULL default '',
  `affiliate_lastname` varchar(32) NOT NULL default '',
  `affiliate_dob` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_email_address` varchar(96) NOT NULL default '',
  `affiliate_telephone` varchar(32) NOT NULL default '',
  `affiliate_fax` varchar(32) NOT NULL default '',
  `affiliate_password` varchar(40) NOT NULL default '',
  `affiliate_homepage` varchar(96) NOT NULL default '',
  `affiliate_street_address` varchar(64) NOT NULL default '',
  `affiliate_suburb` varchar(64) NOT NULL default '',
  `affiliate_city` varchar(32) NOT NULL default '',
  `affiliate_postcode` varchar(10) NOT NULL default '',
  `affiliate_state` varchar(32) NOT NULL default '',
  `affiliate_country_id` int(11) NOT NULL default '0',
  `affiliate_zone_id` int(11) NOT NULL default '0',
  `affiliate_agb` tinyint(4) NOT NULL default '0',
  `affiliate_company` varchar(60) NOT NULL default '',
  `affiliate_company_taxid` varchar(64) NOT NULL default '',
  `affiliate_commission_percent` decimal(4,2) NOT NULL default '0.00',
  `affiliate_payment_check` varchar(100) NOT NULL default '',
  `affiliate_payment_paypal` varchar(64) NOT NULL default '',
  `affiliate_payment_bank_name` varchar(64) NOT NULL default '',
  `affiliate_payment_bank_branch_number` varchar(64) NOT NULL default '',
  `affiliate_payment_bank_swift_code` varchar(64) NOT NULL default '',
  `affiliate_payment_bank_account_name` varchar(64) NOT NULL default '',
  `affiliate_payment_bank_account_number` varchar(64) NOT NULL default '',
  `affiliate_date_of_last_logon` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_number_of_logons` int(11) NOT NULL default '0',
  `affiliate_date_account_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_date_account_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_lft` int(11) NOT NULL default '0',
  `affiliate_rgt` int(11) NOT NULL default '0',
  `affiliate_root` int(11) NOT NULL default '0',
  `encryption_style` char(1) NOT NULL default 'O',
  PRIMARY KEY  (`affiliate_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `affiliate_banners` table : 
#
DROP TABLE IF EXISTS `affiliate_banners`;
CREATE TABLE `affiliate_banners` (
  `affiliate_banners_id` int(11) NOT NULL auto_increment,
  `affiliate_banners_title` varchar(64) NOT NULL default '',
  `affiliate_products_id` int(11) NOT NULL default '0',
  `affiliate_banners_image` varchar(64) NOT NULL default '',
  `affiliate_banners_group` varchar(10) NOT NULL default '',
  `affiliate_banners_html_text` text,
  `affiliate_expires_impressions` int(7) default '0',
  `affiliate_expires_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_date_scheduled` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_date_status_change` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_status` int(1) NOT NULL default '1',
  PRIMARY KEY  (`affiliate_banners_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `affiliate_banners_history` table : 
#
DROP TABLE IF EXISTS `affiliate_banners_history`;
CREATE TABLE `affiliate_banners_history` (
  `affiliate_banners_history_id` int(11) NOT NULL auto_increment,
  `affiliate_banners_products_id` int(11) NOT NULL default '0',
  `affiliate_banners_id` int(11) NOT NULL default '0',
  `affiliate_banners_affiliate_id` int(11) NOT NULL default '0',
  `affiliate_banners_shown` int(11) NOT NULL default '0',
  `affiliate_banners_clicks` tinyint(4) NOT NULL default '0',
  `affiliate_banners_history_date` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`affiliate_banners_history_id`,`affiliate_banners_products_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `affiliate_clickthroughs` table : 
#
DROP TABLE IF EXISTS `affiliate_clickthroughs`;
CREATE TABLE `affiliate_clickthroughs` (
  `affiliate_clickthrough_id` int(11) NOT NULL auto_increment,
  `affiliate_id` int(11) NOT NULL default '0',
  `affiliate_clientdate` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_clientbrowser` varchar(200) default 'Could Not Find This Data',
  `affiliate_clientip` varchar(50) default 'Could Not Find This Data',
  `affiliate_clientreferer` varchar(200) default 'none detected (maybe a direct link)',
  `affiliate_products_id` int(11) default '0',
  `affiliate_banner_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`affiliate_clickthrough_id`),
  KEY `refid` (`affiliate_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `affiliate_payment` table : 
#
DROP TABLE IF EXISTS `affiliate_payment`;
CREATE TABLE `affiliate_payment` (
  `affiliate_payment_id` int(11) NOT NULL auto_increment,
  `affiliate_id` int(11) NOT NULL default '0',
  `affiliate_payment` decimal(15,2) NOT NULL default '0.00',
  `affiliate_payment_tax` decimal(15,2) NOT NULL default '0.00',
  `affiliate_payment_total` decimal(15,2) NOT NULL default '0.00',
  `affiliate_payment_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_payment_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_payment_status` int(5) NOT NULL default '0',
  `affiliate_firstname` varchar(32) NOT NULL default '',
  `affiliate_lastname` varchar(32) NOT NULL default '',
  `affiliate_street_address` varchar(64) NOT NULL default '',
  `affiliate_suburb` varchar(64) NOT NULL default '',
  `affiliate_city` varchar(32) NOT NULL default '',
  `affiliate_postcode` varchar(10) NOT NULL default '',
  `affiliate_country` varchar(32) NOT NULL default '0',
  `affiliate_company` varchar(60) NOT NULL default '',
  `affiliate_state` varchar(32) NOT NULL default '0',
  `affiliate_address_format_id` int(5) NOT NULL default '0',
  `affiliate_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`affiliate_payment_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `affiliate_payment_status` table : 
#

DROP TABLE IF EXISTS `affiliate_payment_status`;
CREATE TABLE `affiliate_payment_status` (
  `affiliate_payment_status_id` int(11) NOT NULL default '0',
  `affiliate_language_id` int(11) NOT NULL default '1',
  `affiliate_payment_status_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`affiliate_payment_status_id`,`affiliate_language_id`),
  KEY `idx_affiliate_payment_status_name` (`affiliate_payment_status_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `affiliate_payment_status_history` table : 
#

DROP TABLE IF EXISTS `affiliate_payment_status_history`;
CREATE TABLE `affiliate_payment_status_history` (
  `affiliate_status_history_id` int(11) NOT NULL auto_increment,
  `affiliate_payment_id` int(11) NOT NULL default '0',
  `affiliate_new_value` int(5) NOT NULL default '0',
  `affiliate_old_value` int(5) default '0',
  `affiliate_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_notified` int(1) default '0',
  PRIMARY KEY  (`affiliate_status_history_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `affiliate_sales` table : 
#
DROP TABLE IF EXISTS `affiliate_sales`;
CREATE TABLE `affiliate_sales` (
  `affiliate_id` int(11) NOT NULL default '0',
  `affiliate_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_browser` varchar(100) NOT NULL default '',
  `affiliate_ipaddress` varchar(20) NOT NULL default '',
  `affiliate_orders_id` int(11) NOT NULL default '0',
  `affiliate_value` decimal(15,2) NOT NULL default '0.00',
  `affiliate_payment` decimal(15,2) NOT NULL default '0.00',
  `affiliate_clickthroughs_id` int(11) NOT NULL default '0',
  `affiliate_billing_status` int(5) NOT NULL default '0',
  `affiliate_payment_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `affiliate_payment_id` int(11) NOT NULL default '0',
  `affiliate_percent` decimal(4,2) NOT NULL default '0.00',
  `affiliate_salesman` int(11) NOT NULL default '0',
  PRIMARY KEY  (`affiliate_orders_id`,`affiliate_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `banners` table : 
#
DROP TABLE IF EXISTS `banners`;
CREATE TABLE `banners` (
  `banners_id` int(11) NOT NULL auto_increment,
  `banners_title` varchar(64) NOT NULL default '',

  `banners_url` varchar(255) NOT NULL default '',
  `banners_image` varchar(64) NOT NULL default '',
  `banners_group` varchar(10) NOT NULL default '',
  `banners_html_text` text,
  `expires_impressions` int(7) default '0',
  `expires_date` datetime default '0000-00-00 00:00:00',
  `date_scheduled` datetime default '0000-00-00 00:00:00',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_status_change` datetime NOT NULL default '0000-00-00 00:00:00',
  `status` int(1) NOT NULL default '1',
  PRIMARY KEY  (`banners_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `banners_history` table : 
#
DROP TABLE IF EXISTS `banners_history`;
CREATE TABLE `banners_history` (
  `banners_history_id` int(11) NOT NULL auto_increment,
  `banners_id` int(11) NOT NULL default '0',
  `banners_shown` int(5) NOT NULL default '0',
  `banners_clicked` int(5) NOT NULL default '0',
  `banners_history_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`banners_history_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `categories` table : 
#
DROP TABLE IF EXISTS `categories`;
CREATE TABLE `categories` (
  `categories_id` int(11) NOT NULL auto_increment,
  `categories_image` varchar(64) default '',
  `parent_id` int(11) NOT NULL default '0',
  `sort_order` int(3) default '0',
  `date_added` datetime default '0000-00-00 00:00:00',
  `last_modified` datetime default '0000-00-00 00:00:00',
  PRIMARY KEY  (`categories_id`),
  KEY `idx_categories_parent_id` (`parent_id`)
) ENGINE=MyISAM AUTO_INCREMENT=5 DEFAULT CHARSET=latin1;

#
# Structure for the `categories_description` table : 
#
DROP TABLE IF EXISTS `categories_description`;
CREATE TABLE `categories_description` (
  `categories_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `categories_name` varchar(32) NOT NULL default '',
  `categories_heading_title` varchar(64) default '',
  `categories_description` text,
  PRIMARY KEY  (`categories_id`,`language_id`),
  KEY `idx_categories_name` (`categories_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `configuration` table : 
#
DROP TABLE IF EXISTS `configuration`;
CREATE TABLE `configuration` (
  `configuration_id` int(11) NOT NULL auto_increment,
  `configuration_title` varchar(64) NOT NULL default '',
  `configuration_key` varchar(64) NOT NULL default '',
  `configuration_value` varchar(255) NOT NULL default '',
  `configuration_description` varchar(255) NOT NULL default '',
  `configuration_group_id` int(11) NOT NULL default '0',
  `sort_order` int(5) NOT NULL default '0',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `use_function` varchar(255) default NULL,
  `set_function` varchar(255) default NULL,
  PRIMARY KEY  (`configuration_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `configuration_group` table : 
#
DROP TABLE IF EXISTS `configuration_group`;
CREATE TABLE `configuration_group` (
  `configuration_group_id` int(11) NOT NULL auto_increment,
  `configuration_group_title` varchar(64) NOT NULL default '',
  `configuration_group_description` varchar(255) NOT NULL default '',
  `sort_order` int(5) NOT NULL default '0',
  `visible` int(1) default '1',
  `configuration_access_key` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`configuration_group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `conversion` table : 
#
DROP TABLE IF EXISTS `conversion`;
CREATE TABLE `conversion` (
  `conversion_id` int(3) unsigned NOT NULL auto_increment,
  `conversion_key` varchar(50) default NULL,
  `conversion_value` text,
  PRIMARY KEY  (`conversion_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `counter` table : 
#
DROP TABLE IF EXISTS `counter`;
CREATE TABLE `counter` (
  `startdate` char(8) default NULL,
  `counter` int(12) default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `counter_history` table : 
#
DROP TABLE IF EXISTS `counter_history`;
CREATE TABLE `counter_history` (
  `month` char(8) default NULL,
  `counter` int(12) default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `countries` table : 
#
DROP TABLE IF EXISTS `countries`;
CREATE TABLE `countries` (
  `countries_id` int(11) NOT NULL auto_increment,
  `countries_name` varchar(64) NOT NULL default '',
  `countries_iso_code_2` char(2) NOT NULL default '',
  `countries_iso_code_3` char(3) NOT NULL default '',
  `address_format_id` int(11) NOT NULL default '0',
  `country_code` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`countries_id`),
  KEY `IDX_COUNTRIES_NAME` (`countries_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `coupon_email_track` table : 
#
DROP TABLE IF EXISTS `coupon_email_track`;
CREATE TABLE `coupon_email_track` (
  `unique_id` int(11) NOT NULL auto_increment,
  `coupon_id` int(11) NOT NULL default '0',
  `customer_id_sent` int(11) NOT NULL default '0',
  `sent_firstname` varchar(32) default NULL,
  `sent_lastname` varchar(32) default NULL,
  `emailed_to` varchar(32) default NULL,
  `date_sent` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`unique_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `coupon_gv_customer` table : 
#
DROP TABLE IF EXISTS `coupon_gv_customer`;
CREATE TABLE `coupon_gv_customer` (
  `customer_id` int(5) NOT NULL default '0',
  `amount` decimal(8,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`customer_id`),
  KEY `customer_id` (`customer_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `coupon_gv_queue` table : 
#
DROP TABLE IF EXISTS `coupon_gv_queue`;
CREATE TABLE `coupon_gv_queue` (
  `unique_id` int(5) NOT NULL auto_increment,
  `customer_id` int(5) NOT NULL default '0',
  `order_id` int(5) NOT NULL default '0',
  `amount` decimal(8,4) NOT NULL default '0.0000',
  `date_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `ipaddr` varchar(32) NOT NULL default '',
  `release_flag` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`unique_id`),
  KEY `uid` (`unique_id`,`customer_id`,`order_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `coupon_redeem_track` table : 
#
DROP TABLE IF EXISTS `coupon_redeem_track`;
CREATE TABLE `coupon_redeem_track` (
  `unique_id` int(11) NOT NULL auto_increment,
  `coupon_id` int(11) NOT NULL default '0',
  `customer_id` int(11) NOT NULL default '0',
  `redeem_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `redeem_ip` varchar(32) NOT NULL default '',
  `order_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`unique_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `coupons` table : 
#
DROP TABLE IF EXISTS `coupons`;
CREATE TABLE `coupons` (
  `coupon_id` int(11) NOT NULL auto_increment,
  `coupon_type` char(1) NOT NULL default 'F',
  `coupon_code` varchar(32) NOT NULL default '',
  `coupon_amount` decimal(8,4) NOT NULL default '0.0000',
  `coupon_minimum_order` decimal(8,4) NOT NULL default '0.0000',
  `coupon_start_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `coupon_expire_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `uses_per_coupon` int(5) NOT NULL default '1',
  `uses_per_user` int(5) NOT NULL default '0',
  `restrict_to_products` varchar(255) default NULL,
  `restrict_to_categories` varchar(255) default NULL,
  `restrict_to_customers` text,
  `coupon_active` char(1) NOT NULL default 'Y',
  `date_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `restrict_to_events` varchar(255) default NULL,
  `restrict_to_subscription` varchar(255) default NULL,
  `coupon_tax_class_id` int(11) NOT NULL default '0',
  `restrict_to_service_categories` varchar(255) default NULL,
  `restrict_to_event_categories` varchar(255) default NULL,
  `restrict_to_sub_categories` varchar(255) default NULL,
  `restrict_to_service` varchar(255) default NULL,
  PRIMARY KEY  (`coupon_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `coupons_description` table : 
#
DROP TABLE IF EXISTS `coupons_description`;
CREATE TABLE `coupons_description` (
  `coupon_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '0',
  `coupon_name` varchar(32) NOT NULL default '',
  `coupon_description` text,
  KEY `coupon_id` (`coupon_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `currencies` table : 
#
DROP TABLE IF EXISTS `currencies`;
CREATE TABLE `currencies` (
  `currencies_id` int(11) NOT NULL auto_increment,
  `title` varchar(32) NOT NULL default '',
  `code` char(3) NOT NULL default '',
  `symbol_left` varchar(12) default NULL,
  `symbol_right` varchar(12) default NULL,
  `decimal_point` char(1) default NULL,
  `thousands_point` char(1) default NULL,
  `decimal_places` char(1) default NULL,
  `value` float(13,8) default '0.00000000',
  `last_updated` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`currencies_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `currency_update_history` table : 
#
DROP TABLE IF EXISTS `currency_update_history`;
CREATE TABLE `currency_update_history` (
  `update_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `update_status` char(1) default NULL
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `customer_options` table : 
#
DROP TABLE IF EXISTS `customer_options`;
CREATE TABLE `customer_options` (
  `options_id` tinyint(3) NOT NULL auto_increment,
  `options_name` varchar(255) NOT NULL default '',
  `options_type` char(1) NOT NULL default 'O',
  PRIMARY KEY  (`options_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `customers` table : 
#
DROP TABLE IF EXISTS `customers`;
CREATE TABLE `customers` (
  `customers_id` int(11) NOT NULL auto_increment,
  `customers_gender` char(1) NOT NULL default '',
  `customers_firstname` varchar(32) NOT NULL default '',
  `customers_lastname` varchar(32) NOT NULL default '',
  `customers_dob` datetime NOT NULL default '0000-00-00 00:00:00',
  `customers_email_address` varchar(96) NOT NULL default '',
  `customers_default_address_id` int(11) NOT NULL default '0',
  `customers_telephone` varchar(32) NOT NULL default '',
  `customers_fax` varchar(32) default NULL,
  `customers_password` varchar(40) NOT NULL default '',
  `customers_newsletter` char(1) default NULL,
  `customers_selected_template` varchar(20) NOT NULL default '',
  `customers_second_email_address` varchar(96) NOT NULL default '',
  `customers_second_telephone` varchar(32) NOT NULL default '',
  `customers_reserve_newsletter` char(1) default NULL,
  `customers_subscription_newsletter` char(1) default NULL,
  `customers_type` varchar(1) NOT NULL default 'D',
  `idcards_printed` char(1) NOT NULL default 'N',
  `customers_discount` decimal(8,2) NOT NULL default '0.00',
  `customers_groups_id` int(11) NOT NULL default '1',
  `customers_username` varchar(64) default NULL,
  `customers_occupation` int(11) NOT NULL default '0',
  `customers_interest` int(11) NOT NULL default '0',
  `encryption_style` varchar(1) NOT NULL default 'O',
  `admin_groups_id` int(11) unsigned NOT NULL default '0',
  `resume_from` date NOT NULL default '0000-00-00',
  `suspend_from` date NOT NULL default '0000-00-00',
  `is_blocked` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`customers_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `customers_basket` table : 
#
DROP TABLE IF EXISTS `customers_basket`;
CREATE TABLE `customers_basket` (
  `customers_basket_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `customers_basket_quantity` int(2) NOT NULL default '0',
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `customers_basket_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `products_type` char(1) NOT NULL default 'P',
  `old_orders_id` int(11) unsigned NOT NULL default '0',
  `answer_type` varchar(1) default NULL,
  `answer_value` varchar(255) default NULL,
  `question_id` int(11) unsigned NOT NULL default '0',
  `forced_id` text,
  `subscription_start_date` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`customers_basket_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `customers_basket_attendees` table : 
#
DROP TABLE IF EXISTS `customers_basket_attendees`;
CREATE TABLE `customers_basket_attendees` (
  `customers_id` int(11) unsigned NOT NULL default '0',
  `first_name` varchar(32) NOT NULL default '',
  `last_name` varchar(32) NOT NULL default '',
  `email_address` varchar(32) NOT NULL default '',
  `street_address` varchar(64) NOT NULL default '',
  `city` varchar(32) NOT NULL default '',
  `postcode` varchar(32) NOT NULL default '',
  `state` varchar(100) NOT NULL default '',
  `country` int(6) unsigned NOT NULL default '0',
  `attendee` int(1) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `customers_basket_attributes` table : 
#
DROP TABLE IF EXISTS `customers_basket_attributes`;
CREATE TABLE `customers_basket_attributes` (
  `customers_basket_attributes_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `products_options_id` int(11) NOT NULL default '0',
  `products_options_value_id` int(11) NOT NULL default '0',
  `products_type` char(1) NOT NULL default 'P',
  PRIMARY KEY  (`customers_basket_attributes_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `customers_basket_services` table : 
#
DROP TABLE IF EXISTS `customers_basket_services`;
CREATE TABLE `customers_basket_services` (
  `customers_id` int(11) unsigned NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `start_date` date NOT NULL default '0000-00-00',
  `end_date` date NOT NULL default '0000-00-00',
  `start_time` time NOT NULL default '00:00:00',
  `end_time` time NOT NULL default '00:00:00',
  `resource_id` int(11) unsigned NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `customers_basket_sessions` table : 
#
DROP TABLE IF EXISTS `customers_basket_sessions`;
CREATE TABLE `customers_basket_sessions` (
  `customers_basket_sessions_id` int(11) unsigned NOT NULL auto_increment,
  `customers_id` int(11) unsigned NOT NULL default '0',
  `products_id` int(11) unsigned NOT NULL default '0',
  `session_id` int(11) unsigned NOT NULL default '0',
  `session_type` char(1) NOT NULL default 'R',
  `session_group` char(1) NOT NULL default '',
  `session_date` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`customers_basket_sessions_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `customers_groups` table : 
#
DROP TABLE IF EXISTS `customers_groups`;
CREATE TABLE `customers_groups` (
  `customers_groups_id` int(11) NOT NULL auto_increment,
  `customers_groups_name` varchar(32) NOT NULL default '',
  `customers_groups_discount` decimal(8,2) NOT NULL default '0.00',
  PRIMARY KEY  (`customers_groups_id`)
) ENGINE=MyISAM AUTO_INCREMENT=3 DEFAULT CHARSET=latin1;

#
# Structure for the `customers_info` table : 
#
DROP TABLE IF EXISTS `customers_info`;
CREATE TABLE `customers_info` (
  `customers_info_id` int(11) NOT NULL default '0',
  `customers_info_date_of_last_logon` datetime NOT NULL default '0000-00-00 00:00:00',
  `customers_info_number_of_logons` int(5) default NULL,
  `customers_info_date_account_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `customers_info_date_account_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `global_product_notifications` int(1) default '0',
  `customers_info_source_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`customers_info_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `customers_temp_basket` table : 
#
DROP TABLE IF EXISTS `customers_temp_basket`;
CREATE TABLE `customers_temp_basket` (
  `customers_basket_id` int(11) NOT NULL auto_increment,
  `customers_id` varchar(40) default NULL,
  `products_id` tinytext NOT NULL,
  `customers_basket_quantity` int(2) NOT NULL default '0',
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `customers_basket_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `products_type` char(1) NOT NULL default 'P',
  `old_orders_id` int(11) unsigned NOT NULL default '0',
  `answer_type` char(1) default NULL,
  `answer_value` varchar(255) default NULL,
  `question_id` int(11) unsigned NOT NULL default '0',
  `forced_id` text,
  `subscription_start_date` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`customers_basket_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `customers_temp_basket_attributes` table : 
#
DROP TABLE IF EXISTS `customers_temp_basket_attributes`;
CREATE TABLE `customers_temp_basket_attributes` (
  `customers_basket_attributes_id` int(11) NOT NULL auto_increment,
  `customers_id` varchar(40) NOT NULL default '0',
  `products_id` tinytext NOT NULL,
  `products_options_id` int(11) NOT NULL default '0',
  `products_options_value_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`customers_basket_attributes_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `customers_temp_basket_sessions` table : 
#
DROP TABLE IF EXISTS `customers_temp_basket_sessions`;
CREATE TABLE `customers_temp_basket_sessions` (
  `customers_basket_sessions_id` int(11) NOT NULL auto_increment,
  `customers_id` varchar(40) NOT NULL default '0',
  `products_id` int(11) unsigned NOT NULL default '0',
  `session_id` int(11) unsigned NOT NULL default '0',
  `session_type` char(1) NOT NULL default 'R',
  `session_group` char(1) NOT NULL default '',
  `session_date` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`customers_basket_sessions_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `customers_to_customers` table : 
#
DROP TABLE IF EXISTS `customers_to_customers`;
CREATE TABLE `customers_to_customers` (
  `group_customer_id` int(11) NOT NULL default '0',
  `customer_id` int(11) NOT NULL default '0',
  `orders_id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `email_messages` table : 
#
DROP TABLE IF EXISTS `email_messages`;
CREATE TABLE `email_messages` (
  `message_id` int(11) NOT NULL auto_increment,
  `message_send` char(3) default '',
  `message_subject` varchar(100) default '',
  `message_reply_to` varchar(64) default '',
  `message_text` longtext NOT NULL,
  `message_format` char(1) NOT NULL default 'T',
  `message_type` char(3) NOT NULL default '',
  PRIMARY KEY  (`message_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events` table : 
#
DROP TABLE IF EXISTS `events`;
CREATE TABLE `events` (
  `events_id` int(11) NOT NULL auto_increment,
  `events_image` varchar(64) default NULL,
  `events_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `events_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `events_date_available` datetime NOT NULL default '0000-00-00 00:00:00',
  `events_status` tinyint(1) NOT NULL default '0',
  `sessions_start_date` date NOT NULL default '0000-00-00',
  `sessions_end_date` date NOT NULL default '0000-00-00',
  `events_tax_class_id` int(11) NOT NULL default '0',
  `events_max_reserve` int(11) unsigned NOT NULL default '20',
  `events_fees` decimal(15,4) NOT NULL default '0.0000',
  `events_start_time` time NOT NULL default '00:00:00',
  `events_end_time` time NOT NULL default '00:00:00',
  `events_instructor` int(11) NOT NULL default '0',
  `events_backup_instructor` int(11) NOT NULL default '0',
  `events_location` int(11) NOT NULL default '0',
  `events_payment` varchar(64) NOT NULL default '',
  `refund_percentage1` int(10) unsigned NOT NULL default '100',
  `refund_percentage2` int(10) unsigned NOT NULL default '75',
  `refund_percentage3` tinyint(3) unsigned NOT NULL default '50',
  `events_wait_list` char(1) NOT NULL default 'Y',
  `priority_vip` tinyint(3) unsigned NOT NULL default '1',
  `priority_firstcome` tinyint(3) unsigned NOT NULL default '2',
  `priority_custom` tinyint(3) unsigned NOT NULL default '3',
  `priority_question` tinyint(3) unsigned NOT NULL default '1',
  `sessions_select_count` int(5) unsigned NOT NULL default '1',
  `sessions_select_interval` int(5) unsigned NOT NULL default '1',
  `sessions_date_count` int(5) unsigned NOT NULL default '1',
  `waitsize_vip` int(11) unsigned NOT NULL default '0',
  `waitsize_firstcome` int(11) unsigned NOT NULL default '0',
  `waitsize_custom` int(11) unsigned NOT NULL default '0',
  `events_conditions` longtext,
  `waitfee_vip` decimal(15,0) NOT NULL default '0',
  `waitfee_firstcome` decimal(15,0) NOT NULL default '0',
  `waitfee_custom` decimal(15,0) NOT NULL default '0',
  `events_forward_period` char(1) NOT NULL default 'N',
  `events_forward_length` int(11) unsigned NOT NULL default '0',
  `events_pending_period` int(11) unsigned NOT NULL default '0',
  `events_renewal_start` char(3) NOT NULL default 'FLS',
  `events_renewal_end` int(11) NOT NULL default '0',
  `session_gaps` char(1) NOT NULL default 'N',
  `session_reduction` char(1) NOT NULL default 'N',
  `session_style` char(1) NOT NULL default 'S',
  `instructors_rate_type` char(2) NOT NULL default 'GP',
  `instructors_rate` decimal(15,4) NOT NULL default '0.0000',
  `instructors_base_rate` decimal(15,4) NOT NULL default '0.0000',
  `events_overbook_reserve` int(11) unsigned default '0',
  `subscription_overbook_reserve` int(11) unsigned NOT NULL default '0',
  `events_group_bookings` char(1) default 'N',
  `events_group_min` int(6) NOT NULL default '0',
  `events_group_max` int(6) unsigned NOT NULL default '0',
  `link_service` char(1) NOT NULL default 'L',
  `service_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`events_id`),
  KEY `idx_Events_date_added` (`events_date_added`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_admin_messages` table : 
#
DROP TABLE IF EXISTS `events_admin_messages`;
CREATE TABLE `events_admin_messages` (
  `message_id` int(11) unsigned NOT NULL auto_increment,
  `message_from` varchar(40) NOT NULL default '',
  `message_to` varchar(40) NOT NULL default '',
  `message_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `message_subject` varchar(60) NOT NULL default '',
  `message_text` text,
  `message_unread` char(1) NOT NULL default 'Y',
  PRIMARY KEY  (`message_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_attendees` table : 
#
DROP TABLE IF EXISTS `events_attendees`;
CREATE TABLE `events_attendees` (
  `entry_id` int(11) unsigned NOT NULL auto_increment,
  `sessions_id` int(11) unsigned NOT NULL default '0',
  `events_id` int(11) unsigned NOT NULL default '0',
  `customers_id` int(11) unsigned NOT NULL default '0',
  `customers_firstname` varchar(60) NOT NULL default '',
  `customers_lastname` varchar(60) NOT NULL default '',
  `customers_telephone` varchar(15) NOT NULL default '',
  `customers_second_telephone` varchar(15) NOT NULL default '',
  `customers_age` int(5) unsigned NOT NULL default '0',
  `customers_street_address` varchar(64) NOT NULL default '',
  `customers_suburb` varchar(64) NOT NULL default '',
  `customers_postal_code` varchar(10) NOT NULL default '',
  `customers_city` varchar(32) NOT NULL default '',
  `customers_state` varchar(32) NOT NULL default '',
  `customers_country` int(11) NOT NULL default '0',
  `customers_amount` varchar(32) NOT NULL default '',
  `customers_emailaddress` varchar(96) NOT NULL default '',
  `customers_second_emailaddress` varchar(96) NOT NULL default '',
  `customers_query` text,
  `customers_attend` char(1) NOT NULL default 'N',
  `customers_paid` char(1) NOT NULL default 'N',
  `customers_paid_type` varchar(25) NOT NULL default '',
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `paid` char(1) NOT NULL default 'N',
  `queried` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_attendees_confirm` table : 
#
DROP TABLE IF EXISTS `events_attendees_confirm`;
CREATE TABLE `events_attendees_confirm` (
  `entry_id` int(11) unsigned NOT NULL auto_increment,
  `sessions_id` int(11) unsigned NOT NULL default '0',
  `events_id` int(11) unsigned NOT NULL default '0',
  `customers_id` int(11) unsigned NOT NULL default '0',
  `customers_firstname` varchar(60) NOT NULL default '',
  `customers_lastname` varchar(60) NOT NULL default '',
  `customers_telephone` varchar(15) NOT NULL default '',
  `customers_second_telephone` varchar(15) NOT NULL default '',
  `customers_age` int(5) unsigned NOT NULL default '0',
  `customers_street_address` varchar(64) NOT NULL default '',
  `customers_suburb` varchar(64) NOT NULL default '',
  `customers_postal_code` varchar(10) NOT NULL default '',
  `customers_city` varchar(32) NOT NULL default '',
  `customers_state` varchar(32) NOT NULL default '',
  `customers_country` int(11) NOT NULL default '0',
  `customers_amount` varchar(32) NOT NULL default '',
  `customers_emailaddress` varchar(96) NOT NULL default '',
  `customers_second_emailaddress` varchar(96) NOT NULL default '',
  `customers_query` text,
  `customers_attend` char(1) NOT NULL default 'N',
  `customers_paid` char(1) NOT NULL default 'N',
  `customers_paid_type` varchar(64) NOT NULL default '',
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `paid` char(1) NOT NULL default 'N',
  `queried` char(1) default 'N',
  `attendees_type` char(1) default 'E',
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_attendees_query` table : 
#
DROP TABLE IF EXISTS `events_attendees_query`;
CREATE TABLE `events_attendees_query` (
  `query_id` int(11) unsigned NOT NULL auto_increment,
  `attendees_id` int(11) unsigned NOT NULL default '0',
  `query_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `query_text` text NOT NULL,
  `attendees_type` char(1) NOT NULL default 'A',
  PRIMARY KEY  (`query_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_categories` table : 
#
DROP TABLE IF EXISTS `events_categories`;
CREATE TABLE `events_categories` (
  `events_categories_id` int(11) NOT NULL auto_increment,
  `events_categories_image` varchar(64) default NULL,
  `parent_id` int(11) NOT NULL default '0',
  `sort_order` int(3) default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`events_categories_id`),
  KEY `idx_events_categories_parent_id` (`parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_categories_description` table : 
#
DROP TABLE IF EXISTS `events_categories_description`;
CREATE TABLE `events_categories_description` (
  `events_categories_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `events_categories_name` varchar(32) NOT NULL default '',
  `events_categories_heading_title` varchar(64) default NULL,
  `events_categories_description` text,
  PRIMARY KEY  (`events_categories_id`,`language_id`),
  KEY `idx_events_categories_name` (`events_categories_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_description` table : 
#
DROP TABLE IF EXISTS `events_description`;
CREATE TABLE `events_description` (
  `events_id` int(11) NOT NULL auto_increment,
  `language_id` int(11) NOT NULL default '1',
  `events_name` varchar(64) NOT NULL default '',
  `events_description` text,
  `events_url` varchar(255) default NULL,
  `events_viewed` int(5) default '0',
  `events_teaser_text` varchar(250) default NULL,
  PRIMARY KEY  (`events_id`,`language_id`),
  KEY `Events_name` (`events_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_discounts` table : 
#
DROP TABLE IF EXISTS `events_discounts`;
CREATE TABLE `events_discounts` (
  `discount_id` int(11) unsigned NOT NULL auto_increment,
  `discount_start_date` date NOT NULL default '0000-00-00',
  `discount_end_date` date NOT NULL default '0000-00-00',
  `discount_value` decimal(8,2) NOT NULL default '0.00',
  `discount_type` char(1) NOT NULL default 'A',
  `events_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`discount_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_instructor_payments` table : 
#
DROP TABLE IF EXISTS `events_instructor_payments`;
CREATE TABLE `events_instructor_payments` (
  `entry_id` int(11) unsigned NOT NULL auto_increment,
  `sessions_id` int(11) unsigned NOT NULL default '0',
  `events_id` int(11) unsigned NOT NULL default '0',
  `instructor_id` int(11) unsigned NOT NULL default '0',
  `invoice_no` varchar(15) default NULL,
  `total_amount` decimal(15,4) NOT NULL default '0.0000',
  `payment_type` varchar(20) NOT NULL default '',
  `payment_date` date NOT NULL default '0000-00-00',
  `paid` char(1) NOT NULL default 'N',
  PRIMARY KEY  (`entry_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_instructors` table : 
#
DROP TABLE IF EXISTS `events_instructors`;
CREATE TABLE `events_instructors` (
  `instructors_id` int(11) NOT NULL auto_increment,
  `admin_id` int(11) unsigned NOT NULL default '0',
  `instructors_gender` char(1) NOT NULL default '',
  `instructors_dob` datetime NOT NULL default '0000-00-00 00:00:00',
  `instructors_street_address` varchar(64) NOT NULL default '',
  `instructors_suburb` varchar(32) default NULL,
  `instructors_postcode` varchar(10) NOT NULL default '',
  `instructors_city` varchar(32) NOT NULL default '',
  `instructors_state` varchar(32) NOT NULL default '',
  `instructors_country` varchar(32) NOT NULL default '',
  `instructors_telephone` varchar(32) default NULL,
  `instructors_fax` varchar(32) default NULL,
  `instructors_department` varchar(32) NOT NULL default '',
  `instructors_position` varchar(32) NOT NULL default '',
  `instructors_description` varchar(200) default NULL,
  `instructors_qualifications` varchar(100) NOT NULL default '',
  `instructors_payment` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`instructors_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_instructors_options` table : 
#
DROP TABLE IF EXISTS `events_instructors_options`;
CREATE TABLE `events_instructors_options` (
  `options_id` int(11) unsigned NOT NULL auto_increment,
  `options_name` varchar(32) NOT NULL default '',
  `options_key` char(2) NOT NULL default 'DE',
  PRIMARY KEY  (`options_id`),
  UNIQUE KEY `options_name` (`options_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_instructors_options_values` table : 
#
DROP TABLE IF EXISTS `events_instructors_options_values`;
CREATE TABLE `events_instructors_options_values` (
  `options_values_id` int(11) unsigned NOT NULL auto_increment,
  `options_key` char(2) NOT NULL default 'DE',
  `options_values_text` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`options_values_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_locations` table : 
#
DROP TABLE IF EXISTS `events_locations`;
CREATE TABLE `events_locations` (
  `location_id` int(11) unsigned NOT NULL auto_increment,
  `location_name` varchar(100) NOT NULL default '',
  `location_details` text,
  `location_travel_directions` text,
  `location_equipment` varchar(64) default NULL,
  `location_contact_person` varchar(64) default NULL,
  `location_seats` int(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (`location_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_locations_options` table : 
#
DROP TABLE IF EXISTS `events_locations_options`;
CREATE TABLE `events_locations_options` (
  `equipment_name` varchar(64) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_messages` table : 
#
DROP TABLE IF EXISTS `events_messages`;
CREATE TABLE `events_messages` (
  `events_message_id` int(8) unsigned NOT NULL auto_increment,
  `message_send` char(3) NOT NULL default 'FLS',
  `message_subject` varchar(100) NOT NULL default '',
  `message_reply_to` varchar(64) NOT NULL default '',
  `message_text` longtext NOT NULL,
  `message_format` char(1) NOT NULL default 'T',
  `events_id` int(11) unsigned NOT NULL default '0',
  `message_type` char(3) NOT NULL default 'RCF',
  PRIMARY KEY  (`events_message_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_messages_history` table : 
#
DROP TABLE IF EXISTS `events_messages_history`;
CREATE TABLE `events_messages_history` (
  `message_history_id` int(11) unsigned NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `events_id` tinyint(11) unsigned NOT NULL default '0',
  `message_type` char(3) NOT NULL default '',
  `message_mode` char(1) NOT NULL default 'E',
  `customers_id` int(11) unsigned NOT NULL default '0',
  `email_address` varchar(64) default NULL,
  `send_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`message_history_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_pop_questions` table : 
#
DROP TABLE IF EXISTS `events_pop_questions`;
CREATE TABLE `events_pop_questions` (
  `question_title` varchar(255) default NULL,
  `question_description` mediumtext NOT NULL,
  `answer_type` char(1) NOT NULL default 'T',
  `question_id` int(11) unsigned NOT NULL auto_increment,
  `option_date` varchar(15) default NULL,
  `option_length` int(11) unsigned default '0',
  PRIMARY KEY  (`question_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_recursive_sessions` table : 
#
DROP TABLE IF EXISTS `events_recursive_sessions`;
CREATE TABLE `events_recursive_sessions` (
  `recursive_sessions_id` int(11) NOT NULL auto_increment,
  `events_id` int(11) NOT NULL default '0',
  `sessions_start_date` date NOT NULL default '0000-00-00',
  `sessions_end_date` date NOT NULL default '0000-00-00',
  `sessions_type` char(1) NOT NULL default 'S',
  `sessions_type_option` char(2) NOT NULL default 'DD',
  `sessions_type_daily_days` int(10) unsigned NOT NULL default '1',
  `sessions_type_weekly_weeks` int(10) unsigned NOT NULL default '1',
  `sessions_type_weekly_days` varchar(7) NOT NULL default '0000000',
  `sessions_type_monthly_days` int(10) unsigned NOT NULL default '1',
  `sessions_type_monthly_months` int(10) unsigned NOT NULL default '1',
  `sessions_type_monthly_weeks` tinyint(1) unsigned NOT NULL default '1',
  `sessions_type_monthly_weekdays` tinyint(1) unsigned NOT NULL default '1',
  `sessions_type_monthly_weekmonths` int(10) unsigned NOT NULL default '1',
  `sessions_type_yearly_months` tinyint(1) NOT NULL default '1',
  `sessions_type_yearly_monthdays` int(10) unsigned NOT NULL default '1',
  `sessions_type_yearly_weeks` tinyint(1) NOT NULL default '1',
  `sessions_type_yearly_weekdays` tinyint(1) unsigned NOT NULL default '1',
  `sessions_type_yearly_weekmonths` tinyint(1) unsigned NOT NULL default '1',
  PRIMARY KEY  (`recursive_sessions_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_refund_reservation` table : 
#
DROP TABLE IF EXISTS `events_refund_reservation`;
CREATE TABLE `events_refund_reservation` (
  `refund_id` int(11) unsigned NOT NULL auto_increment,
  `refund_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `orders_id` int(11) unsigned NOT NULL default '0',
  `amount` decimal(15,4) NOT NULL default '0.0000',
  `payment_method` text,
  `session_ids` varchar(250) NOT NULL default '',
  PRIMARY KEY  (`refund_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_sessions` table : 
#
DROP TABLE IF EXISTS `events_sessions`;
CREATE TABLE `events_sessions` (
  `sessions_id` int(11) unsigned NOT NULL auto_increment,
  `events_id` int(11) unsigned NOT NULL default '0',
  `start_date` date NOT NULL default '0000-00-00',
  `sessions_type` char(1) NOT NULL default 'S',
  `recursive_sessions_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`sessions_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_sms_messages` table : 
#
DROP TABLE IF EXISTS `events_sms_messages`;
CREATE TABLE `events_sms_messages` (
  `events_sms_message_id` int(8) unsigned NOT NULL auto_increment,
  `message_send` char(3) NOT NULL default 'FLS',
  `message_subject` varchar(100) NOT NULL default '',
  `message_text` longtext NOT NULL,
  `events_id` int(11) unsigned NOT NULL default '0',
  `message_type` char(3) NOT NULL default 'RCF',
  PRIMARY KEY  (`events_sms_message_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_surveys` table : 
#
DROP TABLE IF EXISTS `events_surveys`;
CREATE TABLE `events_surveys` (
  `survey_id` int(11) unsigned NOT NULL auto_increment,
  `survey_name` varchar(100) NOT NULL default '',
  `survey_desc` text,
  `survey_time_period` smallint(6) unsigned NOT NULL default '0',
  `survey_expiration_date` date NOT NULL default '0000-00-00',
  `survey_visibility_flag` tinyint(1) unsigned NOT NULL default '0',
  `events_id` int(11) unsigned NOT NULL default '0',
  `survey_type` char(3) NOT NULL default '',
  PRIMARY KEY  (`survey_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_surveys_answer` table : 
#
DROP TABLE IF EXISTS `events_surveys_answer`;
CREATE TABLE `events_surveys_answer` (
  `answer_id` int(11) unsigned NOT NULL auto_increment,
  `survey_flag_id` int(11) unsigned NOT NULL default '0',
  `question_id` int(11) unsigned NOT NULL default '0',
  `choice_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`answer_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_surveys_choice` table : 
#
DROP TABLE IF EXISTS `events_surveys_choice`;
CREATE TABLE `events_surveys_choice` (
  `choice_id` int(11) unsigned NOT NULL auto_increment,
  `choice_text` text,
  `question_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`choice_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_surveys_flag` table : 
#
DROP TABLE IF EXISTS `events_surveys_flag`;
CREATE TABLE `events_surveys_flag` (
  `survey_flag_id` int(11) unsigned NOT NULL auto_increment,
  `survey_flag_email` varchar(100) NOT NULL default '',
  `survey_flag_date` date NOT NULL default '0000-00-00',
  `survey_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`survey_flag_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_surveys_question` table : 
#
DROP TABLE IF EXISTS `events_surveys_question`;
CREATE TABLE `events_surveys_question` (
  `question_id` int(11) unsigned NOT NULL auto_increment,
  `question_text` text,
  `question_type` smallint(6) NOT NULL default '0',
  `question_required` tinyint(1) NOT NULL default '0',
  `survey_id` int(11) unsigned NOT NULL default '0',
  `sort_order` mediumint(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (`question_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_surveys_text` table : 
#
DROP TABLE IF EXISTS `events_surveys_text`;
CREATE TABLE `events_surveys_text` (
  `text_answer_id` int(11) unsigned NOT NULL auto_increment,
  `answer_text` text NOT NULL,
  `survey_flag_id` int(11) unsigned NOT NULL default '0',
  `question_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`text_answer_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_to_events_categories` table : 
#
DROP TABLE IF EXISTS `events_to_events_categories`;
CREATE TABLE `events_to_events_categories` (
  `events_id` int(11) NOT NULL default '0',
  `events_categories_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`events_id`,`events_categories_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `events_to_subscriptions` table : 
#
DROP TABLE IF EXISTS `events_to_subscriptions`;
CREATE TABLE `events_to_subscriptions` (
  `events_id` int(11) NOT NULL default '0',
  `subscription_id` int(11) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `faqdesk` table : 
#
DROP TABLE IF EXISTS `faqdesk`;
CREATE TABLE `faqdesk` (
  `faqdesk_id` int(11) NOT NULL auto_increment,
  `faqdesk_image` varchar(64) default '',
  `faqdesk_image_two` varchar(64) default '',
  `faqdesk_image_three` varchar(64) default '',
  `faqdesk_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `faqdesk_last_modified` datetime default '0000-00-00 00:00:00',
  `faqdesk_date_available` datetime default '0000-00-00 00:00:00',
  `faqdesk_status` tinyint(1) NOT NULL default '0',
  `faqdesk_sticky` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`faqdesk_id`),
  KEY `idx_faqdesk_date_added` (`faqdesk_date_added`)
) ENGINE=MyISAM AUTO_INCREMENT=6 DEFAULT CHARSET=latin1;

#
# Structure for the `faqdesk_categories` table : 
#
DROP TABLE IF EXISTS `faqdesk_categories`;
CREATE TABLE `faqdesk_categories` (
  `categories_id` int(11) NOT NULL auto_increment,
  `categories_image` varchar(64) default NULL,
  `parent_id` int(11) NOT NULL default '0',
  `sort_order` int(3) default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `catagory_status` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`categories_id`),
  KEY `idx_categories_parent_id` (`parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `faqdesk_categories_description` table : 
#
DROP TABLE IF EXISTS `faqdesk_categories_description`;
CREATE TABLE `faqdesk_categories_description` (
  `categories_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `categories_name` varchar(32) NOT NULL default '',
  `categories_heading_title` varchar(64) default NULL,
  `categories_description` text,
  PRIMARY KEY  (`categories_id`,`language_id`),
  KEY `idx_categories_name` (`categories_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `faqdesk_configuration` table : 
#
DROP TABLE IF EXISTS `faqdesk_configuration`;
CREATE TABLE `faqdesk_configuration` (
  `configuration_id` int(11) NOT NULL auto_increment,
  `configuration_title` varchar(64) NOT NULL default '',
  `configuration_key` varchar(64) NOT NULL default '',
  `configuration_value` varchar(255) NOT NULL default '',
  `configuration_description` varchar(255) NOT NULL default '',
  `configuration_group_id` int(11) NOT NULL default '0',
  `sort_order` int(5) default '0',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `use_function` varchar(255) default NULL,
  `set_function` varchar(255) default NULL,
  PRIMARY KEY  (`configuration_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `faqdesk_configuration_group` table : 
#
DROP TABLE IF EXISTS `faqdesk_configuration_group`;
CREATE TABLE `faqdesk_configuration_group` (
  `configuration_group_id` int(11) NOT NULL auto_increment,
  `configuration_group_title` varchar(64) NOT NULL default '',
  `configuration_group_description` varchar(255) NOT NULL default '',
  `sort_order` int(5) default '0',
  `visible` int(1) default '1',
  PRIMARY KEY  (`configuration_group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `faqdesk_description` table : 
#
DROP TABLE IF EXISTS `faqdesk_description`;
CREATE TABLE `faqdesk_description` (
  `faqdesk_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `faqdesk_question` varchar(64) NOT NULL default '',
  `faqdesk_answer_long` text,
  `faqdesk_answer_short` text,
  `faqdesk_extra_url` varchar(255) default '',
  `faqdesk_extra_url_name` varchar(255) default '',
  `faqdesk_extra_viewed` int(5) default '0',
  `faqdesk_image_text` text,
  `faqdesk_image_text_two` text,
  `faqdesk_image_text_three` text,
  PRIMARY KEY  (`faqdesk_id`,`language_id`),
  KEY `faqdesk_question` (`faqdesk_question`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `faqdesk_reviews` table : 
#
DROP TABLE IF EXISTS `faqdesk_reviews`;
CREATE TABLE `faqdesk_reviews` (
  `reviews_id` int(11) NOT NULL auto_increment,
  `faqdesk_id` int(11) NOT NULL default '0',
  `customers_id` int(11) default '0',
  `customers_name` varchar(64) NOT NULL default '',
  `reviews_rating` int(1) default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `reviews_read` int(5) NOT NULL default '0',
  `approved` tinyint(3) unsigned default '0',
  PRIMARY KEY  (`reviews_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `faqdesk_reviews_description` table : 
#
DROP TABLE IF EXISTS `faqdesk_reviews_description`;
CREATE TABLE `faqdesk_reviews_description` (
  `reviews_id` int(11) NOT NULL default '0',
  `languages_id` int(11) NOT NULL default '0',
  `reviews_text` text NOT NULL,
  PRIMARY KEY  (`reviews_id`,`languages_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `faqdesk_to_categories` table : 
#
DROP TABLE IF EXISTS `faqdesk_to_categories`;
CREATE TABLE `faqdesk_to_categories` (
  `faqdesk_id` int(11) NOT NULL default '0',
  `categories_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`faqdesk_id`,`categories_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `featured` table : 
#
DROP TABLE IF EXISTS `featured`;
CREATE TABLE `featured` (
  `featured_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `featured_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `featured_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `expires_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_status_change` datetime NOT NULL default '0000-00-00 00:00:00',
  `status` int(1) default '1',
  PRIMARY KEY  (`featured_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `general_templates` table : 
#
DROP TABLE IF EXISTS `general_templates`;
CREATE TABLE `general_templates` (
  `template_id` int(11) NOT NULL auto_increment,
  `template_type` varchar(4) default 'TICE',
  `template_width` decimal(6,4) default '0.0000',
  `template_height` decimal(6,4) default '0.0000',
  `template_content` text,
  PRIMARY KEY  (`template_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `geo_zones` table : 
#
DROP TABLE IF EXISTS `geo_zones`;
CREATE TABLE `geo_zones` (
  `geo_zone_id` int(11) NOT NULL auto_increment,
  `geo_zone_name` varchar(32) NOT NULL default '',
  `geo_zone_description` varchar(255) NOT NULL default '',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`geo_zone_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `infobox_configuration` table : 
#
DROP TABLE IF EXISTS `infobox_configuration`;
CREATE TABLE `infobox_configuration` (
  `template_id` int(3) unsigned default NULL,
  `infobox_id` int(11) NOT NULL auto_increment,
  `infobox_file_name` varchar(64) NOT NULL default '',
  `infobox_define` varchar(64) NOT NULL default 'BOX_HEADING_',
  `infobox_display` varchar(255) NOT NULL default '',
  `display_in_column` varchar(64) NOT NULL default 'left',
  `location` int(3) NOT NULL default '0',
  `sort_order` int(5) default '0',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `box_heading` varchar(64) NOT NULL default '',
  `box_template` varchar(64) NOT NULL default 'infobox',
  `box_heading_font_color` varchar(10) NOT NULL default '#000000',
  PRIMARY KEY  (`infobox_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `languages` table : 
#
DROP TABLE IF EXISTS `languages`;
CREATE TABLE `languages` (
  `languages_id` int(11) NOT NULL auto_increment,
  `name` varchar(32) NOT NULL default '',
  `code` char(2) NOT NULL default '',
  `image` varchar(64) default NULL,
  `directory` varchar(32) default NULL,
  `sort_order` int(3) default '0',
  PRIMARY KEY  (`languages_id`),
  KEY `IDX_LANGUAGES_NAME` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `latest_news` table : 
#
DROP TABLE IF EXISTS `latest_news`;
CREATE TABLE `latest_news` (
  `news_id` int(11) NOT NULL auto_increment,
  `headline` varchar(255) NOT NULL default '',
  `content` text NOT NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `status` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`news_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `main_page_description` table : 
#
DROP TABLE IF EXISTS `main_page_description`;
CREATE TABLE `main_page_description` (
  `page_id` int(11) unsigned NOT NULL default '0',
  `page_name` varchar(250) NOT NULL default '',
  `description` text NOT NULL,
  `language_id` int(11) unsigned NOT NULL default '1',
  PRIMARY KEY  (`page_id`,`language_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `main_pages` table : 
#
DROP TABLE IF EXISTS `main_pages`;
CREATE TABLE `main_pages` (
  `page_id` int(11) unsigned NOT NULL auto_increment,
  `parent_id` int(11) unsigned NOT NULL default '0',
  `date_created` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `sort_order` int(11) NOT NULL default '0',
  `page_status` tinyint(1) NOT NULL default '0',
  PRIMARY KEY  (`page_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `manufacturers` table : 
#
DROP TABLE IF EXISTS `manufacturers`;
CREATE TABLE `manufacturers` (
  `manufacturers_id` int(11) NOT NULL auto_increment,
  `manufacturers_name` varchar(32) NOT NULL default '',
  `manufacturers_image` varchar(64) default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`manufacturers_id`),
  KEY `IDX_MANUFACTURERS_NAME` (`manufacturers_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `manufacturers_info` table : 
#
DROP TABLE IF EXISTS `manufacturers_info`;
CREATE TABLE `manufacturers_info` (
  `manufacturers_id` int(11) NOT NULL default '0',
  `languages_id` int(11) NOT NULL default '0',
  `manufacturers_url` varchar(255) NOT NULL default '',
  `url_clicked` int(5) NOT NULL default '0',
  `date_last_click` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`manufacturers_id`,`languages_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `meta_tags` table : 
#
DROP TABLE IF EXISTS `meta_tags`;
CREATE TABLE `meta_tags` (
  `filename` varchar(255) NOT NULL default '',
  `date_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `title` tinytext,
  `description` text,
  `keywords` text,
  `tag_id` int(11) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (`tag_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `newsdesk` table : 
#
DROP TABLE IF EXISTS `newsdesk`;
CREATE TABLE `newsdesk` (
  `newsdesk_id` int(11) NOT NULL auto_increment,
  `newsdesk_image` varchar(64) default NULL,
  `newsdesk_image_two` varchar(64) default NULL,
  `newsdesk_image_three` varchar(64) default NULL,
  `newsdesk_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `newsdesk_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `newsdesk_date_available` datetime NOT NULL default '0000-00-00 00:00:00',
  `newsdesk_status` tinyint(1) NOT NULL default '0',
  `newsdesk_sticky` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`newsdesk_id`),
  KEY `idx_newsdesk_date_added` (`newsdesk_date_added`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `newsdesk_categories` table : 
#
DROP TABLE IF EXISTS `newsdesk_categories`;
CREATE TABLE `newsdesk_categories` (
  `categories_id` int(11) NOT NULL auto_increment,
  `categories_image` varchar(64) default NULL,
  `parent_id` int(11) NOT NULL default '0',
  `sort_order` int(3) default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `catagory_status` tinyint(1) NOT NULL default '1',
  PRIMARY KEY  (`categories_id`),
  KEY `idx_categories_parent_id` (`parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `newsdesk_categories_description` table : 
#
DROP TABLE IF EXISTS `newsdesk_categories_description`;
CREATE TABLE `newsdesk_categories_description` (
  `categories_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `categories_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`categories_id`,`language_id`),
  KEY `idx_categories_name` (`categories_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `newsdesk_configuration` table : 
#
DROP TABLE IF EXISTS `newsdesk_configuration`;
CREATE TABLE `newsdesk_configuration` (
  `configuration_id` int(11) NOT NULL auto_increment,
  `configuration_title` varchar(64) NOT NULL default '',
  `configuration_key` varchar(64) NOT NULL default '',
  `configuration_value` varchar(255) NOT NULL default '',
  `configuration_description` varchar(255) NOT NULL default '',
  `configuration_group_id` int(11) NOT NULL default '0',
  `sort_order` int(5) default '0',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `use_function` varchar(255) default NULL,
  `set_function` varchar(255) default NULL,
  PRIMARY KEY  (`configuration_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `newsdesk_configuration_group` table : 
#
DROP TABLE IF EXISTS `newsdesk_configuration_group`;
CREATE TABLE `newsdesk_configuration_group` (
  `configuration_group_id` int(11) NOT NULL auto_increment,
  `configuration_group_title` varchar(64) NOT NULL default '',
  `configuration_group_description` varchar(255) NOT NULL default '',
  `sort_order` int(5) default '0',
  `visible` int(1) default '1',
  PRIMARY KEY  (`configuration_group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `newsdesk_description` table : 
#
DROP TABLE IF EXISTS `newsdesk_description`;
CREATE TABLE `newsdesk_description` (
  `newsdesk_id` int(11) NOT NULL auto_increment,
  `language_id` int(11) NOT NULL default '1',
  `newsdesk_article_name` varchar(64) NOT NULL default '',
  `newsdesk_article_description` text,
  `newsdesk_article_shorttext` text,
  `newsdesk_article_url` varchar(255) default NULL,
  `newsdesk_article_viewed` int(5) default '0',
  `newsdesk_image_text` text,
  `newsdesk_image_text_two` text,
  `newsdesk_image_text_three` text,
  PRIMARY KEY  (`newsdesk_id`,`language_id`),
  KEY `newsdesk_article_name` (`newsdesk_article_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `newsdesk_reviews` table : 
#
DROP TABLE IF EXISTS `newsdesk_reviews`;
CREATE TABLE `newsdesk_reviews` (
  `reviews_id` int(11) NOT NULL auto_increment,
  `newsdesk_id` int(11) NOT NULL default '0',
  `customers_id` int(11) default '0',
  `customers_name` varchar(64) NOT NULL default '',
  `reviews_rating` int(1) default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `reviews_read` int(5) NOT NULL default '0',
  `approved` tinyint(3) unsigned default '0',
  PRIMARY KEY  (`reviews_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `newsdesk_reviews_description` table : 
#
DROP TABLE IF EXISTS `newsdesk_reviews_description`;
CREATE TABLE `newsdesk_reviews_description` (
  `reviews_id` int(11) NOT NULL default '0',
  `languages_id` int(11) NOT NULL default '0',
  `reviews_text` text NOT NULL,
  PRIMARY KEY  (`reviews_id`,`languages_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `newsdesk_to_categories` table : 
#
DROP TABLE IF EXISTS `newsdesk_to_categories`;
CREATE TABLE `newsdesk_to_categories` (
  `newsdesk_id` int(11) NOT NULL default '0',
  `categories_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`newsdesk_id`,`categories_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `newsletters` table : 
#
DROP TABLE IF EXISTS `newsletters`;
CREATE TABLE `newsletters` (
  `newsletters_id` int(11) NOT NULL auto_increment,
  `title` varchar(255) NOT NULL default '',
  `content` text NOT NULL,
  `module` varchar(255) NOT NULL default '',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_sent` datetime NOT NULL default '0000-00-00 00:00:00',
  `status` int(1) default '0',
  `locked` int(1) default '0',
  PRIMARY KEY  (`newsletters_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders` table : 
#
DROP TABLE IF EXISTS `orders`;
CREATE TABLE `orders` (
  `orders_id` int(11) NOT NULL auto_increment,
  `customers_id` int(11) NOT NULL default '0',
  `customers_name` varchar(64) NOT NULL default '',
  `customers_company` varchar(32) default NULL,
  `customers_street_address` varchar(64) NOT NULL default '',
  `customers_suburb` varchar(32) default NULL,
  `customers_city` varchar(32) NOT NULL default '',
  `customers_postcode` varchar(10) NOT NULL default '',
  `customers_state` varchar(32) default NULL,
  `customers_country` varchar(32) NOT NULL default '',
  `customers_telephone` varchar(32) NOT NULL default '',
  `customers_email_address` varchar(96) NOT NULL default '',
  `customers_address_format_id` int(5) NOT NULL default '0',
  `delivery_name` varchar(64) NOT NULL default '',
  `delivery_company` varchar(32) default NULL,
  `delivery_street_address` varchar(64) NOT NULL default '',
  `delivery_suburb` varchar(32) default NULL,
  `delivery_city` varchar(32) NOT NULL default '',
  `delivery_postcode` varchar(10) NOT NULL default '',
  `delivery_state` varchar(32) default NULL,
  `delivery_country` varchar(32) NOT NULL default '',
  `delivery_address_format_id` int(5) NOT NULL default '0',
  `billing_name` varchar(64) NOT NULL default '',
  `billing_company` varchar(32) default NULL,
  `billing_street_address` varchar(64) NOT NULL default '',
  `billing_suburb` varchar(32) default NULL,
  `billing_city` varchar(32) NOT NULL default '',
  `billing_postcode` varchar(10) NOT NULL default '',
  `billing_state` varchar(32) default NULL,
  `billing_country` varchar(32) NOT NULL default '',
  `billing_address_format_id` int(5) NOT NULL default '0',
  `payment_method` text,
  `cc_type` varchar(20) default NULL,
  `cc_owner` varchar(64) default NULL,
  `cc_number` varchar(32) default NULL,
  `cc_expires` varchar(4) default NULL,
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_purchased` datetime NOT NULL default '0000-00-00 00:00:00',
  `orders_status` int(5) NOT NULL default '0',
  `orders_date_finished` datetime NOT NULL default '0000-00-00 00:00:00',
  `currency` char(3) default NULL,
  `currency_value` decimal(14,6) default '0.000000',
  `payment_info` text,
  `cc_cvv_number` varchar(32) NOT NULL default '',
  `customers_second_telephone` varchar(32) default NULL,
  `customers_second_email_address` varchar(96) default NULL,
  `customers_fax` varchar(32) default NULL,
  `question_value_date` date default '0000-00-00',
  `question_value_text` varchar(100) default NULL,
  `question_value_number` decimal(15,4) default '0.0000',
  `ticket_printed` char(1) NOT NULL default 'N',
  `reference_id` varchar(32) NOT NULL default '',
  `payment_return1` varchar(64) NOT NULL default '',
  `payment_return2` varchar(64) NOT NULL default '',
  `fulfiller_status` varchar(32) default '',
  `owd_cost` decimal(15,4) NOT NULL default '0.0000',
  `shipping_method` varchar(255) NOT NULL default '',
  `shipping_date` date NOT NULL default '0000-00-00',
  `shipping_weight` decimal(5,2) NOT NULL default '0.00',
  PRIMARY KEY  (`orders_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_edit_attendees` table : 
#
DROP TABLE IF EXISTS `orders_edit_attendees`;
CREATE TABLE `orders_edit_attendees` (
  `orders_id` int(11) unsigned NOT NULL default '0',
  `first_name` char(32) NOT NULL default '',
  `last_name` char(32) NOT NULL default '',
  `email_address` char(32) NOT NULL default '',
  `street_address` char(64) NOT NULL default '',
  `city` char(32) NOT NULL default '',
  `postcode` char(32) NOT NULL default '',
  `state` char(100) NOT NULL default '',
  `zone_id` int(11) unsigned NOT NULL default '0',
  `country` int(6) unsigned NOT NULL default '0',
  `attendee_id` int(11) NOT NULL default '0',
  `customer_id` int(11) NOT NULL default '-1'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_edit_products` table : 
#
DROP TABLE IF EXISTS `orders_edit_products`;
CREATE TABLE `orders_edit_products` (
  `orders_products_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `products_id` int(11) NOT NULL default '0',
  `products_model` char(12) default NULL,
  `products_name` char(64) NOT NULL default '',
  `products_price` decimal(15,4) NOT NULL default '0.0000',
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `products_tax` decimal(7,4) NOT NULL default '0.0000',
  `products_quantity` int(2) NOT NULL default '0',
  `products_type` char(1) NOT NULL default 'P',
  `events_type` char(1) NOT NULL default 'P',
  `waitlist_type` char(1) default NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `events_fees` decimal(15,4) NOT NULL default '0.0000',
  `waitlist_orders_id` int(11) unsigned NOT NULL default '0',
  `products_sku` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`orders_products_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_edit_products_attributes` table : 
#
DROP TABLE IF EXISTS `orders_edit_products_attributes`;
CREATE TABLE `orders_edit_products_attributes` (
  `orders_products_attributes_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `orders_products_id` int(11) NOT NULL default '0',
  `products_options` char(32) NOT NULL default '',
  `products_options_values` char(32) NOT NULL default '',
  `options_values_price` decimal(15,4) NOT NULL default '0.0000',
  `price_prefix` char(1) NOT NULL default '',
  `products_options_id` int(11) unsigned default '0',
  `products_options_values_id` int(11) unsigned default '0',
  `products_type` char(1) NOT NULL default 'P',
  PRIMARY KEY  (`orders_products_attributes_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_edit_services` table : 
#
DROP TABLE IF EXISTS `orders_edit_services`;
CREATE TABLE `orders_edit_services` (
  `orders_id` int(3) NOT NULL default '0',
  `products_id` int(3) NOT NULL default '0',
  `start_date` date default '0000-00-00',
  `end_date` date default '0000-00-00',
  `start_time` time default '00:00:00',
  `end_time` time default '00:00:00',
  `resource_id` int(11) unsigned NOT NULL default '0',
  `orders_products_id` int(11) NOT NULL default '0',
  `resource_name` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_edit_subscriptions` table : 
#
DROP TABLE IF EXISTS `orders_edit_subscriptions`;
CREATE TABLE `orders_edit_subscriptions` (
  `orders_products_id` int(11) NOT NULL default '0',
  `orders_id` int(11) NOT NULL default '0',
  `products_id` int(11) NOT NULL default '0',
  `type` char(1) NOT NULL default 'O',
  `deliveries` int(11) NOT NULL default '0',
  `deliveries_perday` int(11) NOT NULL default '0',
  `deliveries_name` varchar(20) NOT NULL default 'Deliveries',
  `start_date` date NOT NULL default '0000-00-00',
  `finish_date` date NOT NULL default '0000-00-00'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_events_answers` table : 
#
DROP TABLE IF EXISTS `orders_events_answers`;
CREATE TABLE `orders_events_answers` (
  `answer_id` int(11) unsigned NOT NULL auto_increment,
  `orders_id` int(11) unsigned NOT NULL default '0',
  `events_id` int(11) unsigned NOT NULL default '0',
  `answer_type` char(1) default NULL,
  `answer_value` varchar(255) default NULL,
  `question_id` int(11) unsigned NOT NULL default '0',
  `customers_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`answer_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_products` table : 
#
DROP TABLE IF EXISTS `orders_products`;
CREATE TABLE `orders_products` (
  `orders_products_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `products_id` int(11) NOT NULL default '0',
  `products_model` varchar(12) default NULL,
  `products_name` varchar(64) NOT NULL default '',
  `products_price` decimal(15,4) NOT NULL default '0.0000',
  `final_price` decimal(15,4) NOT NULL default '0.0000',
  `products_tax` decimal(7,4) NOT NULL default '0.0000',
  `products_quantity` int(2) NOT NULL default '0',
  `products_type` char(1) NOT NULL default 'P',
  `events_type` char(1) NOT NULL default '',
  `waitlist_type` char(1) default NULL,
  `events_fees` decimal(15,4) NOT NULL default '0.0000',
  `waitlist_orders_id` int(11) unsigned NOT NULL default '0',
  `orders_products_status` tinyint(1) default '0',
  `invoice_printed` tinyint(3) unsigned default '0',
  `packing_slip_printed` tinyint(3) unsigned default '0',
  `invoice_printed_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `packslip_printed_time` datetime NOT NULL default '0000-00-00 00:00:00',
  `coupon_amount` double(15,4) NOT NULL default '0.0000',
  `products_sku` varchar(20) NOT NULL default '',
  PRIMARY KEY  (`orders_products_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_products_attributes` table : 
#
DROP TABLE IF EXISTS `orders_products_attributes`;
CREATE TABLE `orders_products_attributes` (
  `orders_products_attributes_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `orders_products_id` int(11) NOT NULL default '0',
  `products_options` varchar(32) NOT NULL default '',
  `products_options_values` varchar(32) NOT NULL default '',
  `options_values_price` decimal(15,4) NOT NULL default '0.0000',
  `price_prefix` char(1) NOT NULL default '',
  `products_options_id` int(11) unsigned default '0',
  `products_options_values_id` int(11) unsigned default '0',
  `products_type` char(1) NOT NULL default 'P',
  PRIMARY KEY  (`orders_products_attributes_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_products_download` table : 
#
DROP TABLE IF EXISTS `orders_products_download`;
CREATE TABLE `orders_products_download` (
  `orders_products_download_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `orders_products_id` int(11) NOT NULL default '0',
  `orders_products_filename` varchar(255) NOT NULL default '',
  `download_maxdays` int(2) NOT NULL default '0',
  `download_count` int(2) NOT NULL default '0',
  PRIMARY KEY  (`orders_products_download_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_services` table : 
#
DROP TABLE IF EXISTS `orders_services`;
CREATE TABLE `orders_services` (
  `orders_id` int(3) NOT NULL default '0',
  `products_id` int(3) NOT NULL default '0',
  `start_date` date NOT NULL default '0000-00-00',
  `end_date` date NOT NULL default '0000-00-00',
  `start_time` time NOT NULL default '00:00:00',
  `end_time` time NOT NULL default '00:00:00',
  `resource_id` int(3) NOT NULL default '0',
  `orders_products_id` int(11) NOT NULL default '0',
  `resource_name` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_status` table : 
#
DROP TABLE IF EXISTS `orders_status`;
CREATE TABLE `orders_status` (
  `orders_status_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `orders_status_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`orders_status_id`,`language_id`),
  KEY `idx_orders_status_name` (`orders_status_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_status_history` table : 
#
DROP TABLE IF EXISTS `orders_status_history`;
CREATE TABLE `orders_status_history` (
  `orders_status_history_id` int(11) NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `orders_status_id` int(5) NOT NULL default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `customer_notified` int(1) default '0',
  `comments` text,
  `user_added` varchar(65) default NULL,
  PRIMARY KEY  (`orders_status_history_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_subscriptions` table : 
#
DROP TABLE IF EXISTS `orders_subscriptions`;
CREATE TABLE `orders_subscriptions` (
  `orders_products_id` int(11) NOT NULL default '0',
  `orders_id` int(11) NOT NULL default '0',
  `products_id` int(11) NOT NULL default '0',
  `type` char(1) NOT NULL default 'O',
  `deliveries` int(11) NOT NULL default '0',
  `deliveries_perday` int(11) NOT NULL default '0',
  `deliveries_name` varchar(20) NOT NULL default 'Deliveries',
  `start_date` date NOT NULL default '0000-00-00',
  `finish_date` date NOT NULL default '0000-00-00'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `orders_total` table : 
#
DROP TABLE IF EXISTS `orders_total`;
CREATE TABLE `orders_total` (
  `orders_total_id` int(10) unsigned NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `title` varchar(255) NOT NULL default '',
  `text` varchar(255) NOT NULL default '',
  `value` decimal(15,4) NOT NULL default '0.0000',
  `class` varchar(32) NOT NULL default '',
  `sort_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`orders_total_id`),
  KEY `idx_orders_total_orders_id` (`orders_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `paypalipn_txn` table : 
#
DROP TABLE IF EXISTS `paypalipn_txn`;
CREATE TABLE `paypalipn_txn` (
  `paypalipn_txn_id` int(11) NOT NULL auto_increment,
  `txn_id` varchar(17) NOT NULL default '',
  `ipn_result` varchar(10) NOT NULL default '',
  `receiver_email` varchar(255) NOT NULL default '',
  `business` varchar(255) NOT NULL default '',
  `item_name` varchar(96) NOT NULL default '',
  `item_number` int(11) NOT NULL default '0',
  `quantity` int(11) NOT NULL default '0',
  `invoice` varchar(255) NOT NULL default '',
  `custom` varchar(255) NOT NULL default '',
  `option_name1` varchar(255) NOT NULL default '',
  `option_selection1` varchar(255) NOT NULL default '',
  `option_name2` varchar(255) NOT NULL default '',
  `option_selection2` varchar(255) NOT NULL default '',
  `num_cart_items` int(11) NOT NULL default '0',
  `payment_status` varchar(10) NOT NULL default '',
  `pending_reason` varchar(10) NOT NULL default '',
  `payment_date` varchar(100) NOT NULL default '',
  `settle_amount` varchar(32) NOT NULL default '',
  `settle_currency` varchar(32) NOT NULL default '',
  `exchange_rate` varchar(32) NOT NULL default '',
  `payment_gross` decimal(15,4) NOT NULL default '0.0000',
  `payment_fee` decimal(15,4) NOT NULL default '0.0000',
  `mc_gross` decimal(15,4) NOT NULL default '0.0000',
  `mc_fee` decimal(15,4) NOT NULL default '0.0000',
  `mc_currency` varchar(10) NOT NULL default '',
  `tax` varchar(32) NOT NULL default '',
  `txn_type` varchar(10) NOT NULL default '',
  `for_auction` varchar(255) NOT NULL default '',
  `memo` varchar(255) NOT NULL default '',
  `first_name` varchar(32) NOT NULL default '',
  `last_name` varchar(32) NOT NULL default '',
  `address_street` varchar(64) NOT NULL default '',
  `address_city` varchar(64) NOT NULL default '',
  `address_state` varchar(64) NOT NULL default '',
  `address_zip` varchar(10) NOT NULL default '',
  `address_country` varchar(32) NOT NULL default '',
  `address_status` varchar(11) NOT NULL default '',
  `payer_email` varchar(96) NOT NULL default '',
  `payer_id` varchar(128) NOT NULL default '',
  `payer_status` varchar(15) NOT NULL default '',
  `payment_type` varchar(7) NOT NULL default '',
  `notify_version` varchar(5) NOT NULL default '',
  `verify_sign` varchar(128) NOT NULL default '',
  PRIMARY KEY  (`paypalipn_txn_id`),
  KEY `txn_id` (`txn_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `phesis_poll_data` table : 
#
DROP TABLE IF EXISTS `phesis_poll_data`;
CREATE TABLE `phesis_poll_data` (
  `pollid` int(11) NOT NULL auto_increment,
  `optiontext` varchar(255) NOT NULL default '',
  `optioncount` varchar(255) NOT NULL default '',
  `voteid` int(11) unsigned default '0',
  PRIMARY KEY  (`pollid`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `phesis_poll_desc` table : 
#
DROP TABLE IF EXISTS `phesis_poll_desc`;
CREATE TABLE `phesis_poll_desc` (
  `pollID` int(11) NOT NULL auto_increment,
  `poll_type` varchar(255) NOT NULL default '',
  `voters` varchar(255) NOT NULL default '',
  `timestamp` datetime NOT NULL default '0000-00-00 00:00:00',
  `poll_open` varchar(255) NOT NULL default '',
  `pollitle` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`pollID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `products` table : 
#
DROP TABLE IF EXISTS `products`;
CREATE TABLE `products` (
  `products_id` int(11) NOT NULL auto_increment,
  `products_quantity` int(4) NOT NULL default '0',
  `products_model` varchar(12) default NULL,
  `products_image_1` varchar(64) default NULL,
  `products_price` decimal(15,4) NOT NULL default '0.0000',
  `products_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `products_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `products_date_available` datetime NOT NULL default '0000-00-00 00:00:00',
  `products_weight` decimal(5,2) NOT NULL default '0.00',
  `products_status` tinyint(1) NOT NULL default '0',
  `products_tax_class_id` int(11) NOT NULL default '0',
  `manufacturers_id` int(11) NOT NULL default '0',
  `products_ordered` int(11) NOT NULL default '0',
  `products_image_2` varchar(64) default NULL,
  `products_image_3` varchar(64) default NULL,
  `products_image_4` varchar(64) default NULL,
  `products_image_5` varchar(64) default NULL,
  `products_title_1` varchar(100) default NULL,
  `products_title_2` varchar(100) default NULL,
  `products_title_3` varchar(100) default NULL,
  `products_title_4` varchar(100) default NULL,
  `products_title_5` varchar(100) default NULL,
  `products_sort_order` int(6) NOT NULL default '0',
  `is_attributes` char(1) NOT NULL default 'N',
  `products_sku` varchar(20) NOT NULL default '',
  `author_name` varchar(255) NOT NULL default '',
  PRIMARY KEY  (`products_id`),
  KEY `idx_products_date_added` (`products_date_added`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `products_attributes` table : 
#
DROP TABLE IF EXISTS `products_attributes`;
CREATE TABLE `products_attributes` (
  `products_attributes_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `options_id` int(11) NOT NULL default '0',
  `options_values_id` int(11) NOT NULL default '0',
  `options_values_price` decimal(15,4) NOT NULL default '0.0000',
  `price_prefix` char(1) NOT NULL default '',
  `products_options_sort_order` int(6) NOT NULL default '0',
  `product_attributes_one_time` tinyint(1) NOT NULL default '0',
  `products_attributes_weight` decimal(5,2) NOT NULL default '0.00',
  `products_attributes_weight_prefix` char(1) NOT NULL default '',
  `products_attributes_units` int(4) NOT NULL default '0',
  `products_attributes_units_price` decimal(15,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`products_attributes_id`)
) ENGINE=MyISAM AUTO_INCREMENT=14 DEFAULT CHARSET=latin1;

#
# Structure for the `products_attributes_download` table : 
#
DROP TABLE IF EXISTS `products_attributes_download`;
CREATE TABLE `products_attributes_download` (
  `products_attributes_id` int(11) NOT NULL default '0',
  `products_attributes_filename` varchar(255) NOT NULL default '',
  `products_attributes_maxdays` int(2) default '0',
  `products_attributes_maxcount` int(2) default '0',
  PRIMARY KEY  (`products_attributes_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `products_description` table : 
#
DROP TABLE IF EXISTS `products_description`;
CREATE TABLE `products_description` (
  `products_id` int(11) NOT NULL auto_increment,
  `language_id` int(11) NOT NULL default '1',
  `products_name` varchar(64) NOT NULL default '',
  `products_description` text,
  `products_url` varchar(255) default '',
  `products_viewed` int(5) default '0',
  PRIMARY KEY  (`products_id`,`language_id`),
  KEY `products_name` (`products_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `products_freight` table : 
#
DROP TABLE IF EXISTS `products_freight`;
CREATE TABLE `products_freight` (
  `freight_id` int(11) NOT NULL auto_increment,
  `countries_id` int(11) NOT NULL default '0',
  `price_pack` decimal(15,4) NOT NULL default '0.0000',
  `price_kg` decimal(15,4) NOT NULL default '0.0000',
  `pack_type` tinyint(4) NOT NULL default '0',
  PRIMARY KEY  (`freight_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `products_notifications` table : 
#
DROP TABLE IF EXISTS `products_notifications`;
CREATE TABLE `products_notifications` (
  `products_id` int(11) NOT NULL default '0',
  `customers_id` int(11) NOT NULL default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`products_id`,`customers_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `products_options` table : 
#
DROP TABLE IF EXISTS `products_options`;
CREATE TABLE `products_options` (
  `products_options_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `products_options_name` varchar(32) NOT NULL default '',
  `products_options_sort_order` int(4) NOT NULL default '0',
  PRIMARY KEY  (`products_options_id`,`language_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `products_options_values` table : 
#
DROP TABLE IF EXISTS `products_options_values`;
CREATE TABLE `products_options_values` (
  `products_options_values_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `products_options_values_name` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`products_options_values_id`,`language_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `products_options_values_to_products_options` table : 
#
DROP TABLE IF EXISTS `products_options_values_to_products_options`;
CREATE TABLE `products_options_values_to_products_options` (
  `products_options_values_to_products_options_id` int(11) NOT NULL auto_increment,
  `products_options_id` int(11) NOT NULL default '0',
  `products_options_values_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`products_options_values_to_products_options_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `products_reminders` table : 
#
DROP TABLE IF EXISTS `products_reminders`;
CREATE TABLE `products_reminders` (
  `products_id` int(11) NOT NULL default '0',
  `attributes_id` tinytext NOT NULL,
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `email_address` varchar(96) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `products_stock` table : 
#
DROP TABLE IF EXISTS `products_stock`;
CREATE TABLE `products_stock` (
  `products_id` int(11) NOT NULL default '0',
  `attributes_id` tinytext,
  `products_quantity` int(11) default '0',
  `products_ordered` int(11) default '0',
  `sku` varchar(20) NOT NULL default '',
  `attribute_status` tinyint(2) NOT NULL default '1'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `products_to_categories` table : 
#
DROP TABLE IF EXISTS `products_to_categories`;
CREATE TABLE `products_to_categories` (
  `products_id` int(11) NOT NULL default '0',
  `categories_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`products_id`,`categories_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `products_xsell` table : 
#
DROP TABLE IF EXISTS `products_xsell`;
CREATE TABLE `products_xsell` (
  `ID` int(10) NOT NULL auto_increment,
  `products_id` int(10) unsigned NOT NULL default '1',
  `xsell_id` int(10) unsigned NOT NULL default '1',
  `sort_order` int(10) unsigned NOT NULL default '1',
  `xsell_type` char(1) NOT NULL default 'G',
  `item_type` char(1) NOT NULL default 'P',
  PRIMARY KEY  (`ID`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `resources` table : 
#
DROP TABLE IF EXISTS `resources`;
CREATE TABLE `resources` (
  `resource_id` int(11) NOT NULL auto_increment,
  `resource_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `resource_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `resource_tax_class_id` int(11) unsigned NOT NULL default '0',
  `resource_costs` decimal(15,4) NOT NULL default '0.0000',
  `sort_order` int(11) NOT NULL default '0',
  PRIMARY KEY  (`resource_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `resources_description` table : 
#
DROP TABLE IF EXISTS `resources_description`;
CREATE TABLE `resources_description` (
  `resource_id` int(11) unsigned NOT NULL default '0',
  `language_id` int(11) unsigned NOT NULL default '0',
  `resource_name` varchar(64) NOT NULL default '',
  `resource_description` text
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `reviews` table : 
#
DROP TABLE IF EXISTS `reviews`;
CREATE TABLE `reviews` (
  `reviews_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `customers_id` int(11) default '0',
  `customers_name` varchar(64) NOT NULL default '',
  `reviews_rating` int(1) default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `reviews_read` int(5) NOT NULL default '0',
  `admin_review` char(1) default 'N',
  PRIMARY KEY  (`reviews_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `reviews_description` table : 
#
DROP TABLE IF EXISTS `reviews_description`;
CREATE TABLE `reviews_description` (
  `reviews_id` int(11) NOT NULL default '0',
  `languages_id` int(11) NOT NULL default '0',
  `reviews_text` text NOT NULL,
  PRIMARY KEY  (`reviews_id`,`languages_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `salemaker_sales` table : 
#
DROP TABLE IF EXISTS `salemaker_sales`;
CREATE TABLE `salemaker_sales` (
  `sale_id` int(11) NOT NULL auto_increment,
  `sale_status` tinyint(4) NOT NULL default '0',
  `sale_name` varchar(30) NOT NULL default '',
  `sale_deduction_value` decimal(15,4) NOT NULL default '0.0000',
  `sale_deduction_type` tinyint(4) NOT NULL default '0',
  `sale_pricerange_from` decimal(15,4) NOT NULL default '0.0000',
  `sale_pricerange_to` decimal(15,4) NOT NULL default '0.0000',
  `sale_specials_condition` tinyint(4) NOT NULL default '0',
  `sale_categories_selected` varchar(255) default '',
  `sale_categories_all` varchar(255) default '',
  `sale_date_start` date NOT NULL default '0000-00-00',
  `sale_date_end` date NOT NULL default '0000-00-00',
  `sale_date_added` date NOT NULL default '0000-00-00',
  `sale_date_last_modified` date NOT NULL default '0000-00-00',
  `sale_date_status_change` date NOT NULL default '0000-00-00',
  PRIMARY KEY  (`sale_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services` table : 
#
DROP TABLE IF EXISTS `services`;
CREATE TABLE `services` (
  `service_id` int(11) unsigned NOT NULL auto_increment,
  `service_image` varchar(64) default NULL,
  `service_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `service_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `service_date_available` datetime NOT NULL default '0000-00-00 00:00:00',
  `service_status` tinyint(1) unsigned NOT NULL default '0',
  `service_tax_class_id` int(11) unsigned NOT NULL default '0',
  `service_costs` decimal(15,4) NOT NULL default '0.0000',
  `service_total_time` mediumint(6) unsigned NOT NULL default '0',
  `booking_granular` tinyint(3) unsigned NOT NULL default '0',
  `max_bookings` mediumint(6) NOT NULL default '0',
  `quantity` mediumint(6) NOT NULL default '0',
  `conditions` text,
  `multiple_purchase` char(1) NOT NULL default 'Y',
  `pending_period` mediumint(6) NOT NULL default '0',
  `service_location` int(11) unsigned default '0',
  `no_booking_time` char(1) NOT NULL default 'N',
  `booking_type` char(1) default 'H',
  `span_days` char(1) NOT NULL default 'N',
  `include_resource` char(1) NOT NULL default 'N',
  `include_resource_price` char(1) NOT NULL default 'N',
  `service_renewal_start` int(8) NOT NULL default '0',
  `service_renewal_end` int(8) NOT NULL default '0',
  `include_loadings` char(1) NOT NULL default 'N',
  `booking_buffer` char(4) NOT NULL default 'N',
  PRIMARY KEY  (`service_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_attributes` table : 
#
DROP TABLE IF EXISTS `services_attributes`;
CREATE TABLE `services_attributes` (
  `services_attributes_id` int(11) NOT NULL auto_increment,
  `service_id` int(11) NOT NULL default '0',
  `options_id` int(11) NOT NULL default '0',
  `options_values_id` int(11) NOT NULL default '0',
  `options_values_price` decimal(15,4) NOT NULL default '0.0000',
  `price_prefix` char(1) NOT NULL default '',
  `services_options_sort_order` int(6) NOT NULL default '0',
  `services_attributes_one_time` tinyint(1) NOT NULL default '0',
  `services_attributes_weight` decimal(5,2) NOT NULL default '0.00',
  `services_attributes_weight_prefix` char(1) NOT NULL default '',
  `services_attributes_units` int(4) NOT NULL default '0',
  `services_attributes_units_price` decimal(15,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`services_attributes_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_categories` table : 
#
DROP TABLE IF EXISTS `services_categories`;
CREATE TABLE `services_categories` (
  `services_categories_id` int(11) unsigned NOT NULL auto_increment,
  `services_categories_image` char(64) default NULL,
  `sort_order` int(3) default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `parent_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`services_categories_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_categories_description` table : 
#
DROP TABLE IF EXISTS `services_categories_description`;
CREATE TABLE `services_categories_description` (
  `services_categories_id` int(11) unsigned NOT NULL default '0',
  `services_categories_name` varchar(32) default NULL,
  `services_categories_heading_title` varchar(64) NOT NULL default '',
  `services_categories_description` text,
  `language_id` int(11) unsigned NOT NULL default '0',
  `services_categories_notes` text,
  PRIMARY KEY  (`services_categories_id`,`language_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_description` table : 
#
DROP TABLE IF EXISTS `services_description`;
CREATE TABLE `services_description` (
  `service_id` int(11) unsigned NOT NULL default '0',
  `language_id` int(11) unsigned NOT NULL default '0',
  `service_name` varchar(64) NOT NULL default '',
  `service_description` text,
  `service_url` varchar(255) default NULL,
  `service_viewed` int(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`service_id`,`language_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_loadings` table : 
#
DROP TABLE IF EXISTS `services_loadings`;
CREATE TABLE `services_loadings` (
  `service_loadings_id` int(11) NOT NULL auto_increment,
  `service_id` int(11) unsigned default '0',
  `loadings_start_date` date default '0000-00-00',
  `loadings_end_date` date default '0000-00-00',
  `recurring_type` char(2) NOT NULL default 'DD',
  `recurring_details` text,
  `loadings_start_time` time default '00:00:00',
  `loadings_end_time` time default '00:00:00',
  `loadings_price` decimal(15,4) NOT NULL default '0.0000',
  `loadings_type` char(1) NOT NULL default 'C',
  PRIMARY KEY  (`service_loadings_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_locations` table : 
#
DROP TABLE IF EXISTS `services_locations`;
CREATE TABLE `services_locations` (
  `service_location_id` int(11) NOT NULL auto_increment,
  `service_location_name` varchar(100) NOT NULL default '',
  `service_location_details` text,
  `service_location_travel_directions` text,
  `service_location_equipment` varchar(64) default NULL,
  `service_location_contact_person` varchar(64) default NULL,
  `service_location_seats` int(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (`service_location_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_locations_options` table : 
#
DROP TABLE IF EXISTS `services_locations_options`;
CREATE TABLE `services_locations_options` (
  `equipment_name` varchar(64) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_messages` table : 
#
DROP TABLE IF EXISTS `services_messages`;
CREATE TABLE `services_messages` (
  `services_message_id` int(8) unsigned NOT NULL auto_increment,
  `message_send` char(3) NOT NULL default '',
  `message_subject` varchar(100) NOT NULL default '',
  `message_reply_to` varchar(64) NOT NULL default '',
  `message_text` longtext NOT NULL,
  `message_format` char(1) NOT NULL default 'T',
  `service_id` int(11) unsigned NOT NULL default '0',
  `message_type` char(3) NOT NULL default 'RCF',
  `message_send1` char(3) NOT NULL default '',
  PRIMARY KEY  (`services_message_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_messages_history` table : 
#
DROP TABLE IF EXISTS `services_messages_history`;
CREATE TABLE `services_messages_history` (
  `message_history_id` int(11) unsigned NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `service_id` int(11) NOT NULL default '0',
  `message_type` char(3) NOT NULL default '',
  `message_mode` char(1) NOT NULL default 'E',
  `customers_id` int(11) unsigned NOT NULL default '0',
  `email_address` char(64) default NULL,
  `send_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`message_history_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_no_booking_days` table : 
#
DROP TABLE IF EXISTS `services_no_booking_days`;
CREATE TABLE `services_no_booking_days` (
  `service_no_booking_id` int(11) unsigned NOT NULL auto_increment,
  `service_id` int(11) unsigned default '0',
  `no_booking_days` date default '0000-00-00',
  `no_booking_start_date` date default '0000-00-00',
  `no_booking_end_date` date default '0000-00-00',
  `recurring_type` char(2) NOT NULL default 'DD',
  `recurring_details` text,
  `no_booking_start_time` time default '00:00:00',
  `no_booking_end_time` time default '00:00:00',
  PRIMARY KEY  (`service_no_booking_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_options` table : 
#
DROP TABLE IF EXISTS `services_options`;
CREATE TABLE `services_options` (
  `services_options_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `services_options_name` char(32) NOT NULL default '',
  `services_options_sort_order` int(4) NOT NULL default '0',
  PRIMARY KEY  (`services_options_id`,`language_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_options_values` table : 
#
DROP TABLE IF EXISTS `services_options_values`;
CREATE TABLE `services_options_values` (
  `services_options_values_id` int(11) NOT NULL default '0',
  `language_id` int(11) NOT NULL default '1',
  `services_options_values_name` char(64) NOT NULL default '',
  PRIMARY KEY  (`services_options_values_id`,`language_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_options_values_to_services_options` table : 
#
DROP TABLE IF EXISTS `services_options_values_to_services_options`;
CREATE TABLE `services_options_values_to_services_options` (
  `services_options_values_to_services_options_id` int(11) NOT NULL auto_increment,
  `services_options_id` int(11) NOT NULL default '0',
  `services_options_values_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`services_options_values_to_services_options_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_sms_messages` table : 
#
DROP TABLE IF EXISTS `services_sms_messages`;
CREATE TABLE `services_sms_messages` (
  `services_sms_message_id` int(8) unsigned NOT NULL auto_increment,
  `message_send` char(3) NOT NULL default '',
  `message_subject` varchar(100) NOT NULL default '',
  `message_text` longtext NOT NULL,
  `service_id` int(11) unsigned NOT NULL default '0',
  `message_type` char(3) NOT NULL default 'RCF',
  `message_send1` char(3) NOT NULL default '',
  PRIMARY KEY  (`services_sms_message_id`,`service_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_surveys` table : 
#
DROP TABLE IF EXISTS `services_surveys`;
CREATE TABLE `services_surveys` (
  `survey_id` int(11) unsigned NOT NULL auto_increment,
  `survey_name` varchar(100) NOT NULL default '',
  `survey_desc` text,
  `survey_time_period` smallint(6) unsigned NOT NULL default '0',
  `survey_expiration_date` date NOT NULL default '0000-00-00',
  `survey_visibility_flag` tinyint(1) unsigned NOT NULL default '0',
  `service_id` int(11) unsigned NOT NULL default '0',
  `survey_type` char(3) NOT NULL default '',
  PRIMARY KEY  (`survey_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_surveys_answer` table : 
#
DROP TABLE IF EXISTS `services_surveys_answer`;
CREATE TABLE `services_surveys_answer` (
  `answer_id` int(11) unsigned NOT NULL auto_increment,
  `survey_flag_id` int(11) unsigned NOT NULL default '0',
  `question_id` int(11) unsigned NOT NULL default '0',
  `choice_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`answer_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_surveys_choice` table : 
#
DROP TABLE IF EXISTS `services_surveys_choice`;
CREATE TABLE `services_surveys_choice` (
  `choice_id` int(11) unsigned NOT NULL auto_increment,
  `choice_text` text,
  `question_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`choice_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_surveys_flag` table : 
#
DROP TABLE IF EXISTS `services_surveys_flag`;
CREATE TABLE `services_surveys_flag` (
  `survey_flag_id` int(11) unsigned NOT NULL auto_increment,
  `survey_flag_email` char(100) NOT NULL default '',
  `survey_flag_date` date NOT NULL default '0000-00-00',
  `survey_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`survey_flag_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_surveys_question` table : 
#
DROP TABLE IF EXISTS `services_surveys_question`;
CREATE TABLE `services_surveys_question` (
  `question_id` int(11) unsigned NOT NULL auto_increment,
  `question_text` text,
  `question_type` smallint(6) NOT NULL default '0',
  `question_required` tinyint(1) NOT NULL default '0',
  `survey_id` int(11) unsigned NOT NULL default '0',
  `sort_order` mediumint(6) unsigned NOT NULL default '0',
  PRIMARY KEY  (`question_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_surveys_text` table : 
#
DROP TABLE IF EXISTS `services_surveys_text`;
CREATE TABLE `services_surveys_text` (
  `text_answer_id` int(11) NOT NULL auto_increment,
  `answer_text` text NOT NULL,
  `survey_flag_id` int(11) unsigned NOT NULL default '0',
  `question_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`text_answer_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_to_services_categories` table : 
#
DROP TABLE IF EXISTS `services_to_services_categories`;
CREATE TABLE `services_to_services_categories` (
  `service_id` int(11) NOT NULL default '0',
  `services_categories_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`service_id`,`services_categories_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `services_to_services_resources` table : 
#
DROP TABLE IF EXISTS `services_to_services_resources`;
CREATE TABLE `services_to_services_resources` (
  `service_id` int(3) NOT NULL default '0',
  `service_resource_id` int(3) NOT NULL default '0'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `sessions` table : 
#
DROP TABLE IF EXISTS `sessions`;
CREATE TABLE `sessions` (
  `sesskey` varchar(32) NOT NULL default '',
  `expiry` int(11) unsigned NOT NULL default '0',
  `value` text NOT NULL,
  PRIMARY KEY  (`sesskey`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `sources` table : 
#
DROP TABLE IF EXISTS `sources`;
CREATE TABLE `sources` (
  `sources_id` int(11) NOT NULL auto_increment,
  `sources_name` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`sources_id`),
  KEY `IDX_SOURCES_NAME` (`sources_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `sources_other` table : 
#
DROP TABLE IF EXISTS `sources_other`;
CREATE TABLE `sources_other` (
  `customers_id` int(11) NOT NULL default '0',
  `sources_other_customers_id` int(11) NOT NULL auto_increment,
  `sources_other_name` varchar(64) NOT NULL default '',
  PRIMARY KEY  (`sources_other_customers_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `specials` table : 
#
DROP TABLE IF EXISTS `specials`;
CREATE TABLE `specials` (
  `specials_id` int(11) NOT NULL auto_increment,
  `products_id` int(11) NOT NULL default '0',
  `specials_new_products_price` decimal(15,4) NOT NULL default '0.0000',
  `specials_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `specials_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `expires_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_status_change` datetime NOT NULL default '0000-00-00 00:00:00',
  `status` int(1) NOT NULL default '1',
  `customers_groups_id` int(11) NOT NULL default '0',
  `customers_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`specials_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `sql_queries` table : 
#
DROP TABLE IF EXISTS `sql_queries`;
CREATE TABLE `sql_queries` (
  `file_name` varchar(100) NOT NULL default '0',
  `date_installed` datetime NOT NULL default '0000-00-00 00:00:00'
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `subscription_categories` table : 
#
DROP TABLE IF EXISTS `subscription_categories`;
CREATE TABLE `subscription_categories` (
  `subscription_categories_id` int(11) unsigned NOT NULL auto_increment,
  `subscription_categories_image` char(64) default NULL,
  `sort_order` int(3) default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `parent_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`subscription_categories_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `subscription_categories_description` table : 
#
DROP TABLE IF EXISTS `subscription_categories_description`;
CREATE TABLE `subscription_categories_description` (
  `subscription_categories_id` int(11) unsigned NOT NULL auto_increment,
  `subscription_categories_name` varchar(32) default NULL,
  `subscription_categories_heading_title` varchar(64) NOT NULL default '',
  `subscription_categories_description` text,
  `language_id` int(11) unsigned NOT NULL default '0',
  PRIMARY KEY  (`subscription_categories_id`,`language_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `subscription_groups` table : 
#
DROP TABLE IF EXISTS `subscription_groups`;
CREATE TABLE `subscription_groups` (
  `subscription_group_id` int(11) NOT NULL auto_increment,
  `subscription_group_name` varchar(255) NOT NULL default '',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`subscription_group_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `subscription_messages` table : 
#
DROP TABLE IF EXISTS `subscription_messages`;
CREATE TABLE `subscription_messages` (
  `subscription_message_id` int(8) NOT NULL auto_increment,
  `message_send` char(3) NOT NULL default 'FLS',
  `message_subject` varchar(100) NOT NULL default '',
  `message_reply_to` varchar(64) NOT NULL default '',
  `message_text` longtext NOT NULL,
  `message_format` char(1) NOT NULL default 'T',
  `subscription_id` int(11) unsigned NOT NULL default '0',
  `message_type` char(3) NOT NULL default 'SCF',
  `message_send1` mediumint(6) NOT NULL default '0',
  PRIMARY KEY  (`subscription_message_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `subscription_messages_history` table : 
#
DROP TABLE IF EXISTS `subscription_messages_history`;
CREATE TABLE `subscription_messages_history` (
  `message_history_id` int(11) unsigned NOT NULL auto_increment,
  `orders_id` int(11) NOT NULL default '0',
  `subscription_id` int(11) NOT NULL default '0',
  `message_type` char(3) NOT NULL default '',
  `message_mode` char(1) NOT NULL default 'E',
  `customers_id` int(11) unsigned NOT NULL default '0',
  `email_address` char(64) default NULL,
  `send_date` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`message_history_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `subscription_sms_messages` table : 
#
DROP TABLE IF EXISTS `subscription_sms_messages`;
CREATE TABLE `subscription_sms_messages` (
  `subscription_sms_message_id` int(8) unsigned NOT NULL auto_increment,
  `message_send` char(3) NOT NULL default 'FLS',
  `message_subject` varchar(100) NOT NULL default '',
  `message_text` longtext NOT NULL,
  `subscription_id` int(11) unsigned NOT NULL default '0',
  `message_type` char(3) NOT NULL default 'RCF',
  PRIMARY KEY  (`subscription_sms_message_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `subscription_to_subscription_categories` table : 
#
DROP TABLE IF EXISTS `subscription_to_subscription_categories`;
CREATE TABLE `subscription_to_subscription_categories` (
  `subscription_id` int(11) NOT NULL default '0',
  `subscription_categories_id` int(11) NOT NULL default '0',
  PRIMARY KEY  (`subscription_id`,`subscription_categories_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `subscriptions` table : 
#
DROP TABLE IF EXISTS `subscriptions`;
CREATE TABLE `subscriptions` (
  `subscription_id` int(11) unsigned NOT NULL auto_increment,
  `subscription_image` varchar(64) default '',
  `subscription_date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `subscription_last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `subscription_date_available` datetime NOT NULL default '0000-00-00 00:00:00',
  `subscription_status` tinyint(1) unsigned NOT NULL default '0',
  `subscription_tax_class_id` int(11) unsigned NOT NULL default '0',
  `subscription_costs` decimal(15,4) NOT NULL default '0.0000',
  `subscription_type` char(1) NOT NULL default 'B',
  `subscription_period` int(11) unsigned NOT NULL default '0',
  `subscription_group` varchar(100) NOT NULL default '',
  `subscription_conditions` mediumtext,
  `subscription_pending_period` int(11) NOT NULL default '0',
  `subscription_renewal_start` int(6) default '0',
  `subscription_renewal_end` int(6) default '0',
  `subscription_forward_period` char(1) NOT NULL default 'N',
  `subscription_forward_length` int(5) unsigned NOT NULL default '0',
  `subscription_packing_slip` text,
  `subscription_free_trial` char(1) NOT NULL default 'N',
  `subscription_free_days` int(6) unsigned NOT NULL default '0',
  `emarketing_on_renewal` char(1) NOT NULL default 'S',
  `wallet_payment` char(1) NOT NULL default 'N',
  `periodic_payment` char(1) NOT NULL default 'N',
  `periodic_days` int(6) NOT NULL default '0',
  `periodic_type` char(1) NOT NULL default 'A',
  `deliveries` int(11) NOT NULL default '0',
  `deliveries_perday` int(11) NOT NULL default '0',
  `subscription_start_date` date NOT NULL default '0000-00-00',
  `subscription_finish_date` date NOT NULL default '0000-00-00',
  `subscription_date_period` int(11) NOT NULL default '0',
  `subscription_latest_start_date` date NOT NULL default '0000-00-00',
  `subscription_date_type` char(1) NOT NULL default 'F',
  `deliveries_name` varchar(20) NOT NULL default 'Deliveries',
  PRIMARY KEY  (`subscription_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `subscriptions_description` table : 
#
DROP TABLE IF EXISTS `subscriptions_description`;
CREATE TABLE `subscriptions_description` (
  `subscription_id` int(11) unsigned NOT NULL default '0',
  `language_id` int(11) unsigned NOT NULL default '0',
  `subscription_name` varchar(64) NOT NULL default '',
  `subscription_description` text,
  `subscription_url` varchar(255) default '',
  `subscription_viewed` int(5) unsigned NOT NULL default '0',
  PRIMARY KEY  (`subscription_id`,`language_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `tax_class` table : 
#
DROP TABLE IF EXISTS `tax_class`;
CREATE TABLE `tax_class` (
  `tax_class_id` int(11) NOT NULL auto_increment,
  `tax_class_title` varchar(32) NOT NULL default '',
  `tax_class_description` varchar(255) NOT NULL default '',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`tax_class_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `tax_rates` table : 
#
DROP TABLE IF EXISTS `tax_rates`;
CREATE TABLE `tax_rates` (
  `tax_rates_id` int(11) NOT NULL auto_increment,
  `tax_zone_id` int(11) NOT NULL default '0',
  `tax_class_id` int(11) NOT NULL default '0',
  `tax_priority` int(5) default '1',
  `tax_rate` decimal(7,4) NOT NULL default '0.0000',
  `tax_description` varchar(255) NOT NULL default '',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`tax_rates_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `template` table : 
#
DROP TABLE IF EXISTS `template`;
CREATE TABLE `template` (
  `template_id` int(11) NOT NULL auto_increment,
  `template_name` varchar(64) default '0',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `template_image` varchar(64) default NULL,
  `template_cellpadding_main` char(3) NOT NULL default '0',
  `template_cellpadding_left` char(3) NOT NULL default '0',
  `template_cellpadding_right` char(3) NOT NULL default '0',
  `template_cellpadding_sub` char(3) NOT NULL default '0',
  `site_width` varchar(5) NOT NULL default '100%',
  `side_box_left_width` varchar(64) NOT NULL default '0',
  `side_box_right_width` varchar(64) NOT NULL default '0',
  `include_column_left` varchar(64) NOT NULL default 'yes',
  `include_column_right` varchar(64) NOT NULL default 'yes',
  `box_width_left` varchar(4) NOT NULL default '125',
  `box_width_right` varchar(4) NOT NULL default '125',
  `main_table_border` varchar(6) NOT NULL default 'yes',
  `active` char(1) NOT NULL default '1',
  `show_heading_title_original` varchar(6) default 'true',
  `languages_in_header` char(3) default 'no',
  `cart_in_header` char(3) NOT NULL default 'yes',
  `show_header_link_buttons` char(3) NOT NULL default 'no',
  `show_page_descriptions` char(3) NOT NULL default 'yes',
  `module_one` varchar(64) NOT NULL default '',
  `module_two` varchar(64) NOT NULL default '',
  `module_three` varchar(64) NOT NULL default '',
  `module_four` varchar(64) NOT NULL default '',
  `module_five` varchar(64) NOT NULL default '',
  `module_six` varchar(64) NOT NULL default '',
  `customer_greeting` char(3) NOT NULL default 'yes',
  `edit_customer_greeting_personal` text NOT NULL,
  `edit_customer_greeting_personal_relogon` text NOT NULL,
  `edit_greeting_guest` text NOT NULL,
  `show_shipping_estimator` varchar(6) default 'false',
  PRIMARY KEY  (`template_id`),
  KEY `IDX_TEMPLATE_NAME` (`template_name`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;



#
# Structure for the `whos_online` table : 
#
DROP TABLE IF EXISTS `whos_online`;
CREATE TABLE `whos_online` (
  `customer_id` int(11) default '0',
  `full_name` varchar(64) NOT NULL default '',
  `session_id` varchar(128) NOT NULL default '',
  `ip_address` varchar(15) NOT NULL default '',
  `time_entry` varchar(14) NOT NULL default '',
  `time_last_click` varchar(14) NOT NULL default '',
  `last_page_url` varchar(64) NOT NULL default ''
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `zones` table : 
#
DROP TABLE IF EXISTS `zones`;
CREATE TABLE `zones` (
  `zone_id` int(11) NOT NULL auto_increment,
  `zone_country_id` int(11) NOT NULL default '0',
  `zone_code` varchar(32) NOT NULL default '',
  `zone_name` varchar(32) NOT NULL default '',
  PRIMARY KEY  (`zone_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `zones_to_geo_zones` table : 
#
DROP TABLE IF EXISTS `zones_to_geo_zones`;
CREATE TABLE `zones_to_geo_zones` (
  `association_id` int(11) NOT NULL auto_increment,
  `zone_country_id` int(11) NOT NULL default '0',
  `zone_id` int(11) default '0',
  `geo_zone_id` int(11) default '0',
  `last_modified` datetime NOT NULL default '0000-00-00 00:00:00',
  `date_added` datetime NOT NULL default '0000-00-00 00:00:00',
  PRIMARY KEY  (`association_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Data for the `address_book` table  
#

INSERT INTO `address_book` (`address_book_id`, `customers_id`, `entry_gender`, `entry_company`, `entry_firstname`, `entry_lastname`, `entry_street_address`, `entry_suburb`, `entry_postcode`, `entry_city`, `entry_state`, `entry_country_id`, `entry_zone_id`) VALUES 
  (1,1,'m','ACME Inc.','freeway','test','1 Way Street','','4895','Brisbane','',13,193);

#
# Data for the `address_format` table  
#

INSERT INTO `address_format` (`address_format_id`, `address_format`, `address_summary`) VALUES 
  (1,'$firstname $lastname$cr$streets$cr$city, $postcode$cr$statecomma$country','$city / $country'),
  (2,'$firstname $lastname$cr$streets$cr$city, $state    $postcode$cr$country','$city, $state / $country'),
  (3,'$firstname $lastname$cr$streets$cr$city$cr$postcode - $statecomma$country','$state / $country'),
  (4,'$firstname $lastname$cr$streets$cr$city ($postcode)$cr$country','$postcode / $country'),
  (5,'$firstname $lastname$cr$streets$cr$postcode $city$cr$country','$city / $country');

#
# Data for the `admin` table  
#

INSERT INTO `admin` (`admin_id`, `admin_groups_id`, `admin_firstname`, `admin_lastname`, `admin_email_address`, `admin_password`, `admin_created`, `admin_modified`, `admin_logdate`, `admin_lognum`, `admin_hide_backend`, `encryption_style`) VALUES 
  (1,1,'admin','user','freeway@zac-ware.com','39a89a28169b53c7e58438558adc5e37:7b','2007-04-26 17:35:51','2007-04-26 17:35:51','2007-04-27 10:12:10',2,'N','O'),
  (2,2,'Test','Instructor','test.instructor@zac-ware.com','f8b61a3a7dbe299294cffa5eff3525e0:0a','2007-04-26 17:35:51','2007-04-26 17:35:51','2007-04-26 17:35:51',0,'N','O');

INSERT INTO `admin_files` (`admin_files_id`, `admin_files_name`, `admin_files_is_boxes`, `admin_files_to_boxes`, `admin_groups_id`, `admin_files_type`,`admin_files_help_id`, `admin_new_group_id`) VALUES 
  (1146,'reports',0,0,'1','D','D',NULL),
  (1139,'services',0,0,'1','D','D',NULL),
  (1144,'sales',0,0,'1','D','D',NULL),
  (1138,'events',0,0,'1','D','D',NULL),
  (10,'shop_admin_members.php',1,1,'1','D','D',28),
  (11,'admin_files.php',0,1,'1','D','D',NULL),
  (12,'configuration.php',0,2,'1','D','D',NULL),
  (13,'products_create.php',0,3,'1','D','D',NULL),
  (14,'products_attributes.php',1,3,'1','D','D',16),
  (15,'products_manufacturers.php',0,3,'1','D','D',NULL),
  (16,'products_reviews.php',0,3,'1','D','D',NULL),
  (17,'products_specials.php',0,3,'1','D','D',NULL),
  (18,'products_expected.php',0,3,'1','D','D',NULL),
  (19,'modules.php',0,4,'1','D','D',NULL),
  (20,'customers.php',0,5,'1','D','D',NULL),
  (21,'customers_orders.php',0,5,'1','D','D',NULL),
  (22,'shop_countries.php',1,6,'1','D','D',28),
  (23,'shop_zones.php',1,6,'1','D','D',28),
  (24,'shop_geo_zones.php',1,6,'1','D','D',28),
  (25,'payment_tax_classes.php',1,6,'1','D','D',30),
  (26,'payment_tax_rates.php',1,6,'1','D','D',30),
  (27,'payment_currencies.php',1,7,'1','D','D',30),
  (28,'shop_languages.php',1,7,'1','D','D',28),
  (29,'shop_orders_status.php',1,7,'1','D','D',28),
  (30,'reports_products_viewed.php',1,8,'1','D','D',20),
  (31,'stats_products_purchased.php',0,8,'1','D','D',NULL),
  (32,'stats_customers.php',0,8,'1','D','D',NULL),
  (33,'shop_backup.php',1,9,'1','D','D',28),
  (34,'banner_manager.php',0,9,'1','D','D',NULL),
  (35,'cache.php',0,9,'1','D','D',NULL),
  (36,'shop_define_language.php',1,9,'1','D','D',28),
  (37,'shop_file_manager.php',1,9,'1','D','D',28),
  (38,'mail.php',0,9,'1','D','D',NULL),
  (39,'marketing_newsletters.php',0,9,'1','D','D',NULL),
  (40,'server_info.php',0,9,'1','D','D',NULL),
  (41,'shop_whos_online.php',1,9,'1','D','D',28),
  (42,'banner_statistics.php',0,9,'1','D','D',NULL),
  (44,'marketing_affiliate_affiliates.php',1,43,'1','D','D',11),
  (45,'marketing_affiliate_clicks.php',1,43,'1','D','D',11),
  (46,'marketing_affiliate_banners.php',1,43,'1','D','D',11),
  (47,'marketing_affiliate_contact.php',1,43,'1','D','D',11),
  (48,'marketing_affiliate_invoice.php',1,43,'1','D','D',11),
  (49,'marketing_affiliate_payment.php',1,43,'1','D','D',11),
  (50,'marketing_affiliate_popup_image.php',1,43,'1','D','D',11),
  (51,'marketing_affiliate_sales.php',1,43,'1','D','D',11),
  (52,'marketing_affiliate_statistics.php',1,43,'1','D','D',11),
  (53,'marketing_affiliate_summary.php',1,43,'1','D','D',11),
  (1123,'sales_giftvoucher_sent.php',1,1,'1','D','D',26),
  (1145,'payment',1,0,'1','D','D',30),
  (63,'sales_xsell_products.php',0,3,'1','D','D',NULL),
  (64,'products_easypopulate.php',0,3,'1','D','D',NULL),
  (65,'cms_mainpage.php',0,5,'1','D','D',NULL),
  (66,'customers_edit_orders.php',1,5,'1','D','D',6),
  (67,'shop_infobox_configuration.php',1,173,'1','D','D',28),
  (69,'sales_maker.php',0,3,'1','D','D',NULL),
  (70,'myaccount_update_account.php',0,1,'1','D','D',NULL),
  (71,'sales_coupon_listcategories.php',1,3,'1','D','D',25),
  (72,'products_attributes_quick_popup.php',1,3,'1','D','D',16),
  (73,'products_quick_popup.php',0,3,'1','D','D',NULL),
  (75,'cms_news_configuration.php',1,74,'1','D','D',3),
  (76,'cms_news.php',1,74,'1','D','D',3),
  (77,'cms_news_reviews.php',1,74,'1','D','D',3),
  (1120,'sales_coupon.php',1,1,'1','D','D',25),
  (80,'cms_faq.php',1,82,'1','D','D',1),
  (82,'products_featured.php',0,3,'1','D','D',NULL),
  (83,'products_salemaker_info.php',1,3,'1','D','D',17),
  (84,'customers_create_account_success.php',1,5,'1','D','D',5),
  (85,'customers_create_account_process.php',1,5,'1','D','D',5),
  (86,'customers_order_create.php',1,5,'1','D','D',7),
  (87,'customers_create.php',1,5,'1','D','D',5),
  (88,'customers_create_order_process.php',1,5,'1','D','D',5),
  (89,'reports_monthly_sales.php',0,8,'1','D','D',NULL),
  (1142,'cms',0,0,'1','D','D',NULL),
  (1143,'marketing',0,0,'1','D','D',NULL),
  (95,'events_create.php',1,92,'1','E','E',9),
  (96,'events_booking.php',0,92,'1','E','E',NULL),
  (97,'events_pop_questions.php',0,92,'1','E','E',NULL),
  (98,'events_locations.php',1,92,'1','E','E',9),
  (99,'events_options.php',0,92,'1','E','E',NULL),
  (100,'sales_events_discounts.php',0,92,'1','E','E',NULL),
  (101,'admin_letters.php',0,92,'1','E','E',NULL),
  (102,'events_waitlists.php',0,92,'1','E','R',NULL),
  (103,'marketing_events_messages.php',1,92,'1','E','M',12),
  (104,'send_email.php',0,92,'1','E','M',NULL),
  (105,'marketing_events_sms_messages.php',1,92,'1','E','M',12),
  (106,'send_sms_email.php',0,92,'1','E','M',NULL),
  (107,'events_copy_messages.php',0,92,'1','E','M',NULL),
  (108,'marketing_events_messages_log.php',1,92,'1','E','M',12),
  (109,'events_bookings_search.php',0,93,'1','E','R',NULL),
  (110,'events_search_reservation_print.php',1,93,'1','E','R',10),
  (111,'events_search_reservation_dated.php',1,93,'1','E','R',10),
  (112,'events_search_reservation_print_dated.php',1,93,'1','E','R',10),
  (113,'events_search_reservation_print_dated_pdf.php',1,93,'1','E','R',10),
  (114,'events_search_reservation_print_pdf.php',1,93,'1','E','R',10),
  (115,'events_refund_reservation.php',1,93,'1','E','R',9),
  (116,'events_refund_confirm_reservation.php',1,93,'1','E','R',9),
  (117,'events_refund_process.php',1,93,'1','E','R',9),
  (118,'events_refund_success.php',1,93,'1','E','R',9),
  (119,'events_withdraw_reservation.php',1,93,'1','E','R',9),
  (120,'events_withdraw_process.php',1,93,'1','E','R',9),
  (121,'events_move_reservations_confirm.php',1,93,'1','E','R',9),
  (122,'events_move_reservations_process.php',1,93,'1','E','R',9),
  (125,'events_pending_waitlist_payments.php',1,93,'1','E','O',9),
  (126,'events_pending_waitlist_payments_confirm.php',1,93,'1','E','O',9),
  (127,'events_pending_waitlist_payments_process.php',1,93,'1','E','O',9),
  (128,'events_pending_waitlist_new_order.php',1,93,'1','E','O',9),
  (129,'marketing_survey_events.php',1,93,'1','E','U',15),
  (130,'events_surveys_edit.php',1,93,'1','E','U',10),
  (131,'events_surveys_answer.php',1,93,'1','E','U',10),
  (132,'events_surveys_process.php',1,93,'1','E','U',10),
  (133,'events_copy_surveys.php',0,93,'1','E','U',NULL),
  (134,'events_browse.php',0,93,'1','E','E',NULL),
  (135,'events_instructors.php',1,94,'1','E','I',9),
  (136,'events_instructors_options.php',1,94,'1','E','I',9),
  (137,'events_instructor_view.php',1,94,'1','E','I',9),
  (138,'payment_events.php',1,94,'1','E','I',30),
  (139,'events_payments_detail.php',0,94,'1','E','I',NULL),
  (140,'events_instructor_messages.php',1,94,'1','E','I',9),
  (141,'events_instructor_payments.php',1,94,'1','E','I',9),
  (142,'events_admin_payments_detail.php',1,94,'1','E','I',9),
  (143,'marketing_email_messages.php',0,1,'1','D','D',NULL),
  (144,'reports_events_progress.php',1,8,'1','E','P',18),
  (145,'reports_events_birthday_list.php',1,8,'1','E','P',18),
  (146,'reports_events_daily_reservations.php',1,8,'1','E','P',18),
  (147,'reports_events_unpaid_payments.php',1,8,'1','E','P',18),
  (148,'reports_events_call_centre_orders.php',1,8,'1','E','P',18),
  (149,'reports_products_inventory.php',1,8,'1','E','P',20),
  (150,'reports_events_customer_details.php',1,8,'1','E','P',18),
  (151,'reports_events_non_returns.php',1,8,'1','E','P',18),
  (152,'reports_events_attendees.php',1,8,'1','E','P',18),
  (153,'reports_events_attendance_analysis.php',1,8,'1','E','P',18),
  (154,'reports_events_mailing_labels.php',1,8,'1','E','P',18),
  (155,'reports_sales_category.php',1,8,'1','E','P',21),
  (1147,'shop',1,0,'1','D','D',28),
  (1152,'reports_mainpage.php',1,8,'1','E','P',21),
  (157,'reports_sales_products.php',1,8,'1','E','P',21),
  (158,'reports_events_sales.php',1,8,'1','E','P',18),
  (159,'reports_events_instructor_payments.php',1,8,'1','E','P',18),
  (160,'reports_events_pending_payments.php',1,8,'1','E','P',18),
  (161,'reports_events_waitlist.php',1,8,'1','E','P',18),
  (162,'reports_events_surveys.php',1,8,'1','E','P',19),
  (163,'reports_events_surveys_summary.php',1,8,'1','E','P',19),
  (164,'reports_events_surveys_detail.php',1,8,'1','E','P',19),
  (165,'reports_events_surveys_relation.php',1,8,'1','E','P',19),
  (166,'customers_order_addevents.php',1,5,'1','E','O',7),
  (167,'customers_edit_orders_confirm.php',1,5,'1','E','O',6),
  (168,'customers_edit_orders_process.php',1,5,'1','E','O',6),
  (169,'customers_checkout_payment.php',1,5,'1','E','O',4),
  (170,'customers_checkout_process.php',1,5,'1','E','D',4),
  (171,'customers_edit_orders_success.php',1,5,'1','E','O',6),
  (175,'reports_events_viewed.php',1,8,'1','E','P',18),
  (1148,'myaccount',0,0,'1','D','D',NULL),
  (177,'events_check_in.php',0,93,'1','D','D',NULL),
  (1100,'subscriptions_create.php',1,187,'1','D','D',29),
  (181,'subscriptions_copy_messages.php',1,172,'1','D','D',29),
  (182,'customers_subscription_groups.php',0,5,'1','D','D',NULL),
  (183,'reports_subscription_viewed.php',1,8,'1','E','P',24),
  (184,'reports_subscriptions_sales.php',1,8,'1','E','P',24),
  (185,'reports_subscription_unpaid_payments.php',1,8,'1','E','P',24),
  (186,'reports_sales_subscriptions.php',1,8,'1','E','P',21),
  (1140,'products',0,0,'1','D','D',NULL),
  (188,'reports_subscription_details.php',1,8,'1','E','P',24),
  (189,'reports_subscription_renewals.php',1,8,'1','E','P',24),
  (190,'reports_subscription_non_renewals.php',1,8,'1','E','P',24),
  (191,'reports_subscription_monthlysales.php',1,8,'1','E','P',24),
  (192,'subscriptions_send_email.php',1,172,'1','E','B',29),
  (193,'reports_subscription_packing_slip.php',1,8,'1','E','P',24),
  (194,'events_preview_tickets.php',1,92,'1','D','D',9),
  (195,'events_preview_idcards.php',1,92,'1','D','D',9),
  (196,'reports_event_tickets.php',1,8,'1','D','D',18),
  (197,'reports_events_idcards.php',1,8,'1','D','D',18),
  (198,'events_ticket.php',0,5,'1','D','D',NULL),
  (199,'events_id_card.php',0,5,'1','D','D',9),
  (200,'payment_general_templates.php',1,92,'1','D','D',30),
  (201,'customers_groups.php',0,5,'1','D','D',NULL),
  (1119,'reports_wallet.php',0,1,'1','D','D',NULL),
  (1104,'marketing_wallet.php',0,1,'1','D','D',NULL),
  (204,'customers_payment_wallet.php',0,5,'1','D','D',NULL),
  (205,'customers_wallet_confirmation.php',1,5,'1','D','D',8),
  (206,'customers_wallet_process.php',1,5,'1','D','D',8),
  (207,'customers_wallet_success.php',1,5,'1','D','D',8),
  (208,'marketing_survey_referrals.php',1,5,'1','D','D',15),
  (209,'reports_sales_referral_sources.php',1,8,'1','E','P',21),
  (1118,'cms_faq_reviews.php',1,1,'1','D','D',1),
  (1121,'sales_giftvoucher_mail.php',1,1,'1','D','D',26),
  (1122,'sales_giftvoucher_queue.php',1,1,'1','D','D',26),
  (218,'marketing_survey_customer_options.php',1,5,'1','D','D',15),
  (221,'marketing_seo.php',0,2,'1','D','D',NULL),
  (222,'reports_products_fulfiller.php',1,8,'1','D','D',20),
  (223,'reports_products_fulfiller_mail_backorder.php',1,8,'1','D','D',20),
  (224,'reports_products_invoice.php',1,8,'1','D','D',20),
  (225,'reports_products_packslip.php',1,8,'1','D','D',20),
  (226,'reports_products_pickpack.php',1,8,'1','D','D',20),
  (1135,'products_easypopulate_functions.php',0,3,'1','D','D',NULL),
  (228,'products_freight.php',0,3,'1','D','D',NULL),
  (229,'reports_products_cart_drop.php',1,8,'1','D','D',20),
  (230,'products_options.php',0,3,'1','D','D',NULL),
  (231,'marketing_products_message.php',0,3,'1','D','D',NULL),
  (232,'paypal_notify.php',0,5,'1','D','D',NULL),
  (1000,'services_create.php',1,0,'1','D','D',27),
  (1001,'services_create.php',1,1000,'1','D','D',27),
  (1002,'services_categories.php',1,1000,'1','D','D',27),
  (1003,'marketing_services_messages.php',1,1000,'1','D','D',13),
  (1004,'send_services_email.php',1,1000,'1','D','D',13),
  (1005,'services_copy_messages.php',1,1000,'1','D','D',27),
  (1006,'marketing_services_sms_messages.php',1,1000,'1','D','D',13),
  (1007,'reports_services_viewed.php',1,8,'1','D','D',22),
  (1008,'reports_services_forsale.php',1,8,'1','D','D',22),
  (1009,'marketing_survey_services.php',1,1000,'1','D','D',15),
  (1010,'services_surveys_edit.php',1,1000,'1','D','D',27),
  (1011,'reports_services_customer_details.php',1,8,'1','D','D',22),
  (1012,'services_copy_surveys.php',1,1000,'1','D','D',27),
  (1013,'services_attributes.php',1,1000,'1','D','D',27),
  (1014,'services_bookings.php',1,8,'1','D','D',27),
  (1015,'reports_services_non_returns.php',1,8,'1','D','D',22),
  (1016,'reports_services_surveys.php',1,8,'1','D','D',23),
  (1017,'reports_services_pending_orders.php',1,8,'1','D','D',22),
  (1018,'reports_services_attendees.php',1,8,'1','D','D',22),
  (1019,'reports_services_salesby_category.php',1,8,'1','D','D',22),
  (1020,'reports_services_sales.php',1,8,'1','D','D',22),
  (1021,'reports_services_monthly_salestax.php',1,8,'1','D','D',22),
  (1022,'reports_services_provider_payments.php',1,8,'1','D','D',22),
  (1023,'reports_services_idcarts.php',1,8,'1','D','D',22),
  (1024,'reports_services_tickets.php',1,8,'1','D','D',22),
  (1025,'customers_order_add_services.php',1,5,'1','D','D',7),
  (1026,'services_id_card.php',1,8,'1','D','D',27),
  (1027,'services_ticket.php',1,8,'1','D','D',27),
  (1028,'payment_services_templates.php',1,1000,'1','D','D',30),
  (1029,'services_resources.php',1,1000,'1','D','D',27),
  (1114,'services_locations.php',1,1,'1','D','D',27),
  (1031,'reports_services_util.php',1,0,'1','D','D',22),
  (1032,'reports_services_bookings.php',1,8,'1','D','D',22),
  (1033,'reports_services_callc_orders.php',1,8,'1','D','D',22),
  (1034,'reports_services_surveys_summary.php',1,8,'1','D','D',23),
  (1035,'reports_services_surveys_crosstab.php',1,8,'1','D','D',23),
  (1036,'reports_services_surveys_detail.php',1,8,'1','D','D',23),
  (1037,'reports_services_surveys_relation.php',1,8,'1','D','D',23),
  (1038,'send_service_sms_email.php',1,96,'1','D','D',13),
  (1039,'services_options.php',1,1000,'1','D','D',27),
  (1040,'send_services_messages_script_new.php',0,1000,'1','D','D',NULL),
  (1041,'marketing_services_messages_log.php',1,1000,'1','D','D',13),
  (1042,'services_send_messages.php',1,1000,'1','D','D',27),
  (1043,'services_send_sms_messages.php',1,1000,'1','D','D',27),
  (1044,'services_send_sms_messages.php',0,1000,'1','D','D',0),
  (1045,'services_bookings.php',1,1000,'1','D','D',27),
  (1047,'reports_services_resources_view.php',1,8,'1','D','D',22),
  (1050,'services_move_bookings_confirm.php',1,1000,'1','D','D',27),
  (1051,'reports_products_reconciliation.php',1,8,'1','D','D',20),
  (1052,'shop_compat_test.php',1,9,'1','D','D',28),
  (1053,'customers_checkout_virtualpay_result.php',1,0,'1','D','D',4),
  (1054,'customers_checkout_commbank_result.php',1,1,'1','D','D',4),
  (1055,'customers_checkout_westpac_result.php',1,0,'1','D','D',4),
  (1056,'cms_level_pages_update.php',1,0,'1','D','D',2),
  (1057,'cms_level_pages.php',1,0,'1','D','D',2),
  (1058,'customers_order_addproducts.php',1,5,'1','D','D',7),
  (1059,'customers_order_addsubscriptions.php',1,5,'1','D','D',7),
  (1060,'reports_sales_direct_deposit.php',1,8,'1','D','D',21),
  (1065,'customers_checkout_attendees.php',1,247,'1','D','D',4),
  (1066,'paypalipn_txn.php',0,59,'1','D','D',NULL),
  (1067,'paypalipn_tests.php',0,59,'1','D','D',NULL),
  (1069,'search_links.php',0,0,'1','D','D',NULL),
  (1071,'send_subscription_sms_email.php',0,0,'1','D','D',14),
  (1078,'reports_general_customer_detail.php',0,8,'1','D','D',NULL),
  (1137,'customers',0,0,'1','D','D',NULL),
  (1083,'reports_general_call_center_orders.php',0,8,'1','D','D',NULL),
  (1141,'subscriptions',1,0,'1','D','D',29),
  (1085,'language_tool.php',1,1,'1','D','D',NULL),
  (1087,'language_admin.php',0,9,'1','D','D',NULL),
  (1089,'reports_events_surveys_crosstab.php',1,8,'1','D','D',19),
  (1090,'reports_events_surveys_file.php',1,8,'1','D','D',19),
  (1091,'site_settings.php',0,1,'1','D','D',NULL),
  (1092,'configuration_new.php',0,2,'1','D','D',NULL),
  (1093,'quick_links.php',0,2,'1','D','D',NULL),
  (1094,'customers_mainpage.php',0,0,'1','D','D',NULL),
  (1113,'menus.php',0,1,'1','D','D',NULL),
  (1096,'products_mainpage.php',0,3,'1','D','D',NULL),
  (1097,'configuration_mainpage.php',1,0,'1','D','D',NULL),
  (1098,'events_mainpage.php',0,3,'1','D','D',NULL),
  (1099,'subscriptions_mainpage.php',1,3,'1','D','D',29),
  (1101,'services_mainpage.php',1,1000,'1','D','D',27),
  (1103,'cms_homepage.php',0,1,'1','D','D',NULL),
  (1105,'marketing_subscription_messages.php',1,1,'1','D','D',14),
  (1107,'marketing_subscription_messages_logs.php',1,1,'1','D','D',14),
  (1108,'marketing_subscription_sms_messages.php',1,1,'1','D','D',14),
  (1117,'cms_faq_configuration.php',1,1,'1','D','D',1),
  (1110,'shop_template_configuration.php',1,1,'1','D','D',28),
  (1126,'customers_checkout_paypalipn.php',1,5,'1','E','D',4),
  (1127,'sales_coupon_listeventcategories.php',1,3,'1','D','D',25),
  (1128,'sales_coupon_listevents.php',1,3,'1','D','D',25),
  (1129,'sales_coupon_listproducts.php',1,3,'1','D','D',25),
  (1130,'sales_coupon_listservice.php',1,3,'1','D','D',25),
  (1131,'sales_coupon_listservicecategories.php',1,3,'1','D','D',25),
  (1132,'sales_coupon_listsubcategories.php',1,3,'1','D','D',25),
  (1133,'sales_coupon_listsubscription.php',1,3,'1','D','D',25),
  (1136,'products_salemaker.php',1,3,'1','D','D',17),
  (1149,'customers_checkout_cs_result.php',1,0,'1','D','D',1),
  (1150,'customers_mainpage_real.php',1,0,'1','D','D',NULL),
  (1151,'customers_packingslip.php',1,0,'1','D','D',5);
  

#
# Data for the `admin_files_groups` table
#

INSERT INTO `admin_files_groups` (`admin_files_groups_id`, `admin_files_groups_name`, `admin_files_groups_desc`, `admin_groups_id`) VALUES 
  (1,'cms_faq',NULL,'1'),
  (2,'cms_level',NULL,'1'),
  (3,'cms_news',NULL,'1'),
  (4,'customers_checkout',NULL,'1'),
  (5,'customers_create',NULL,'1'),
  (6,'customers_edit_orders',NULL,'1'),
  (7,'customers_order',NULL,'1'),
  (8,'customers_wallet',NULL,'1'),
  (9,'events',NULL,'1'),
  (10,'events_search',NULL,'1'),
  (11,'marketing_affiliate',NULL,'1'),
  (12,'marketing_events',NULL,'1'),
  (13,'marketing_services',NULL,'1'),
  (14,'marketing_subscription',NULL,'1'),
  (15,'marketing_survey',NULL,'1'),
  (16,'products_attributes',NULL,'1'),
  (17,'products_salemaker',NULL,'1'),
  (18,'reports_events',NULL,'1'),
  (19,'reports_events_surveys',NULL,'1'),
  (20,'reports_products',NULL,'1'),
  (21,'reports_sales',NULL,'1'),
  (22,'reports_services',NULL,'1'),
  (23,'reports_services_surveys',NULL,'1'),
  (24,'reports_subscription',NULL,'1'),
  (25,'sales_coupon',NULL,'1'),
  (26,'sales_giftvoucher',NULL,'1'),
  (27,'services',NULL,'1'),
  (28,'shop',NULL,'1'),
  (29,'subscriptions',NULL,'1'),
  (30,'payment',NULL,'1');
  
#
# Data for the `admin_groups` table  
#

INSERT INTO `admin_groups` (`admin_groups_id`, `admin_groups_name`, `admin_groups_type`) VALUES 
  (1,'Top Administrator','E'),
  (2,'Instructor','E'),
  (3,'Call Centre Manager','E'),
  (4,'Call Centre Staff','E'),
  (5,'Product Manager','E'),
  (6,'Reservation Manager','E'),
  (7,'Demo User Group','D'),
  (8,'Fulfiller','E'),
  (9,'Blocked','E');

#
# Data for the `affiliate_affiliate` table  
#

INSERT INTO `affiliate_affiliate` (`affiliate_id`, `affiliate_gender`, `affiliate_firstname`, `affiliate_lastname`, `affiliate_dob`, `affiliate_email_address`, `affiliate_telephone`, `affiliate_fax`, `affiliate_password`, `affiliate_homepage`, `affiliate_street_address`, `affiliate_suburb`, `affiliate_city`, `affiliate_postcode`, `affiliate_state`, `affiliate_country_id`, `affiliate_zone_id`, `affiliate_agb`, `affiliate_company`, `affiliate_company_taxid`, `affiliate_commission_percent`, `affiliate_payment_check`, `affiliate_payment_paypal`, `affiliate_payment_bank_name`, `affiliate_payment_bank_branch_number`, `affiliate_payment_bank_swift_code`, `affiliate_payment_bank_account_name`, `affiliate_payment_bank_account_number`, `affiliate_date_of_last_logon`, `affiliate_number_of_logons`, `affiliate_date_account_created`, `affiliate_date_account_last_modified`, `affiliate_lft`, `affiliate_rgt`, `affiliate_root`, `encryption_style`) VALUES 
  (3,'m','Test','User','1966-07-03','test@freeway.com','12345678','12345678','e75b084f524d74171ebd47e6d7b56e1b:db','http://oscommres.com','10 Test St','Testville','Test','1234','',13,193,1,'','',0,'Test User','test@freeway.com','Test Bank','123456','12345678','Test User','12345678','0000-00-00',4,'2007-04-26 17:35:39','0000-00-00',1,2,3,'O');

#
# Data for the `affiliate_banners` table  
#

INSERT INTO `affiliate_banners` (`affiliate_banners_id`, `affiliate_banners_title`, `affiliate_products_id`, `affiliate_banners_image`, `affiliate_banners_group`, `affiliate_banners_html_text`, `affiliate_expires_impressions`, `affiliate_expires_date`, `affiliate_date_scheduled`, `affiliate_date_added`, `affiliate_date_status_change`, `affiliate_status`) VALUES 
  (4,'freeway',0,'hammock.jpg','','',0,'0000-00-00','0000-00-00','2007-04-26 17:35:39','0000-00-00',1);

#
# Data for the `affiliate_payment_status` table  
#

INSERT INTO `affiliate_payment_status` (`affiliate_payment_status_id`, `affiliate_language_id`, `affiliate_payment_status_name`) VALUES 
  (1,2,'Ausgezahlt'),
  (0,2,'Offen'),
  (1,3,'Pagado'),
  (1,1,'Paid'),
  (0,3,'Pendiente'),
  (0,1,'Pending');

#
# Data for the `banners` table  
#

INSERT INTO `banners` (`banners_id`, `banners_title`, `banners_url`, `banners_image`, `banners_group`, `banners_html_text`, `expires_impressions`, `expires_date`, `date_scheduled`, `date_added`, `date_status_change`, `status`) VALUES 
  (1,'osCommerce','http://www.oscommerce.com','banners/oscommerce.gif','468x50','',0,'0000-00-00','0000-00-00','2007-04-26 17:35:17','0000-00-00',1);

#
# Data for the `configuration` table  
#

INSERT INTO `configuration` (`configuration_id`, `configuration_title`, `configuration_key`, `configuration_value`, `configuration_description`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES 
  (1,'Store Name','STORE_NAME','Freeway','The name of my store',1,1,'0000-00-00','2007-04-26 17:35:17',NULL,NULL),
  (2,'Store Owner','STORE_OWNER','Freeway Store Manager','The name of my store owner',1,2,'0000-00-00','2007-04-26 17:35:17',NULL,NULL),
  (3,'E-Mail Address','STORE_OWNER_EMAIL_ADDRESS','shop@freeway.com','The e-mail address of my store owner',1,3,'0000-00-00','2007-04-26 17:35:17',NULL,NULL),
  (4,'E-Mail From','EMAIL_FROM','shop@freeway.com','The e-mail address used in (sent) e-mails',1,4,'0000-00-00','2007-04-26 17:35:17',NULL,NULL),
  (5,'Country','STORE_COUNTRY','13','The country my store is located in <br><br><b>Note: Please remember to update the store zone.</b>',1,6,'0000-00-00','2007-04-26 17:35:17','tep_get_country_name','tep_cfg_pull_down_country_list('),
  (6,'State/Province','STORE_ZONE','193','The zone my store is located in',1,7,'0000-00-00','2007-04-26 17:35:17','tep_cfg_get_zone_name','tep_cfg_pull_down_zone_list('),
  (7,'Expected Sort Order','EXPECTED_PRODUCTS_SORT','desc','This is the sort order used in the expected products box.',150,8,'0000-00-00','2007-04-26 17:35:17',NULL,'tep_cfg_select_option(array(''asc'', ''desc''),'),
  (8,'Expected Sort Field','EXPECTED_PRODUCTS_FIELD','date_expected','The column to sort by in the expected products box.',150,9,'0000-00-00','2007-04-26 17:35:17',NULL,'tep_cfg_select_option(array(''products_name'', ''date_expected''),'),
  (10,'Send Extra Order Emails To','SEND_EXTRA_ORDER_EMAILS_TO','','Send extra order emails to the following email addresses, in this format: Name 1 &lt;email@address1&gt;, Name 2 &lt;email@address2&gt;',1,11,'0000-00-00','2007-04-26 17:35:17',NULL,NULL),
  (11,'Use Search-Engine Safe URLs (still in development)','SEARCH_ENGINE_FRIENDLY_URLS','false','Use search-engine safe urls for all site links',151,12,'0000-00-00','2007-04-26 17:35:17',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (12,'Display Cart After Adding Product','DISPLAY_CART','true','Display the shopping cart after adding a product (or return back to their origin)',151,14,'0000-00-00','2007-04-26 17:35:17',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (13,'Allow Guest To Tell A Friend','ALLOW_GUEST_TO_TELL_A_FRIEND','false','Allow guests to tell a friend about a product',154,15,'0000-00-00','2007-04-26 17:35:17',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (14,'Default Search Operator','ADVANCED_SEARCH_DEFAULT_OPERATOR','and','Default search operators',151,17,'0000-00-00','2007-04-26 17:35:17',NULL,'tep_cfg_select_option(array(''and'', ''or''),'),
  (15,'Store Address and Phone','STORE_NAME_ADDRESS','Freeway Pty Ltd\r\nABN 123456789\r\nGPO Box 1234\r\nBrisbane QLD 4001\r\nAustralia\r\ntel 123456789','This is the Store Name, Address and Phone used on printable documents and displayed online',1,18,'0000-00-00','2007-04-26 17:35:17',NULL,'tep_cfg_textarea('),
  (16,'Show Category Counts','SHOW_COUNTS','true','Count recursively how many products are in each category',150,19,'0000-00-00','2007-04-26 17:35:17',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (17,'Tax Decimal Places','TAX_DECIMAL_PLACES','0','Pad the tax value this amount of decimal places',152,20,'0000-00-00','2007-04-26 17:35:17',NULL,NULL),
  (18,'Display Prices with Tax','DISPLAY_PRICE_WITH_TAX','true','Display prices with tax included (true) or add the tax at the end (false)',152,21,'0000-00-00','2007-04-26 17:35:17',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (19,'First Name','ENTRY_FIRST_NAME_MIN_LENGTH','2','Minimum length of first name',2,1,'0000-00-00','2007-04-26 17:35:17',NULL,NULL),
  (20,'Last Name','ENTRY_LAST_NAME_MIN_LENGTH','2','Minimum length of last name',2,2,'0000-00-00','2007-04-26 17:35:17',NULL,NULL),
  (21,'Date of Birth','ENTRY_DOB_MIN_LENGTH','10','Minimum length of date of birth',2,3,'0000-00-00','2007-04-26 17:35:17',NULL,NULL),
  (22,'E-Mail Address','ENTRY_EMAIL_ADDRESS_MIN_LENGTH','6','Minimum length of e-mail address',2,4,'0000-00-00','2007-04-26 17:35:17',NULL,NULL),
  (23,'Street Address','ENTRY_STREET_ADDRESS_MIN_LENGTH','5','Minimum length of street address',2,5,'0000-00-00','2007-04-26 17:35:17',NULL,NULL),
  (24,'Company','ENTRY_COMPANY_MIN_LENGTH','2','Minimum length of company name',2,6,'0000-00-00','2007-04-26 17:35:17',NULL,NULL),
  (25,'Post Code','ENTRY_POSTCODE_MIN_LENGTH','4','Minimum length of post code',2,7,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (26,'City','ENTRY_CITY_MIN_LENGTH','3','Minimum length of city',2,8,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (27,'State','ENTRY_STATE_MIN_LENGTH','2','Minimum length of state',2,9,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (28,'Telephone Number','ENTRY_TELEPHONE_MIN_LENGTH','8','Minimum length of telephone number',2,10,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (29,'Password','ENTRY_PASSWORD_MIN_LENGTH','5','Minimum length of password',2,11,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (30,'Credit Card Owner Name','CC_OWNER_MIN_LENGTH','6','Minimum length of credit card owner name',2,12,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (31,'Credit Card Number','CC_NUMBER_MIN_LENGTH','12','Minimum length of credit card number',2,13,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (32,'Review Text','REVIEW_TEXT_MIN_LENGTH','50','Minimum length of review text',2,14,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (33,'Best Sellers','MIN_DISPLAY_BESTSELLERS','1','Minimum number of best sellers to display',2,15,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (34,'Also Purchased','MIN_DISPLAY_ALSO_PURCHASED','1','Minimum number of products to display in the ''This Customer Also Purchased'' box',2,16,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (35,'Address Book Entries','MAX_ADDRESS_BOOK_ENTRIES','5','Maximum address book entries a customer is allowed to have',3,1,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (36,'Search Results','MAX_DISPLAY_SEARCH_RESULTS','10','Amount of products to list',2,2,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (37,'Page Links','MAX_DISPLAY_PAGE_LINKS','5','Number of ''number'' links use for page-sets',2,3,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (38,'Special Products','MAX_DISPLAY_SPECIAL_PRODUCTS','3','Maximum number of products on special to display',2,4,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (39,'New Products Module','MAX_DISPLAY_NEW_PRODUCTS','3','Maximum number of new products to display in a category',2,5,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (40,'Products Expected','MAX_DISPLAY_UPCOMING_PRODUCTS','3','Maximum number of products expected to display',2,6,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (41,'Manufacturers List','MAX_DISPLAY_MANUFACTURERS_IN_A_LIST','5','Used in manufacturers box; when the number of manufacturers exceeds this number, a drop-down list will be displayed instead of the default list',2,7,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (42,'Manufacturers Select Size','MAX_MANUFACTURERS_LIST','1','Used in manufacturers box; when this value is ''1'' the classic drop-down list will be used for the manufacturers box. Otherwise, a list-box with the specified number of rows will be displayed.',2,7,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (43,'Length of Manufacturers Name','MAX_DISPLAY_MANUFACTURER_NAME_LEN','15','Used in manufacturers box; maximum length of manufacturers name to display',2,8,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (44,'New Reviews','MAX_DISPLAY_NEW_REVIEWS','6','Maximum number of new reviews to display',2,9,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (45,'Selection of Random Reviews','MAX_RANDOM_SELECT_REVIEWS','10','How many records to select from to choose one random product review',2,10,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (46,'Selection of Random New Products','MAX_RANDOM_SELECT_NEW','10','How many records to select from to choose one random new product to display',2,11,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (47,'Selection of Products on Special','MAX_RANDOM_SELECT_SPECIALS','10','How many records to select from to choose one random product special to display',2,12,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (48,'Categories To List Per Row','MAX_DISPLAY_CATEGORIES_PER_ROW','3','How many categories to list per row',2,13,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (49,'New Products Listing','MAX_DISPLAY_PRODUCTS_NEW','8','Maximum number of new products to display in new products page',2,14,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (50,'Best Sellers','MAX_DISPLAY_BESTSELLERS','10','Maximum number of best sellers to display',2,15,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (51,'Also Purchased','MAX_DISPLAY_ALSO_PURCHASED','6','Maximum number of products to display in the ''This Customer Also Purchased'' box',2,16,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (52,'Customer Order History Box','MAX_DISPLAY_PRODUCTS_IN_ORDER_HISTORY_BOX','6','Maximum number of products to display in the customer order history box',2,17,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (53,'Order History','MAX_DISPLAY_ORDER_HISTORY','10','Maximum number of orders to display in the order history page',2,18,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (54,'Small Image Width','SMALL_IMAGE_WIDTH','100','The pixel width of small images',4,1,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (55,'Small Image Height','SMALL_IMAGE_HEIGHT','80','The pixel height of small images',4,2,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (56,'Heading Image Width','HEADING_IMAGE_WIDTH','57','The pixel width of heading images',4,3,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (57,'Heading Image Height','HEADING_IMAGE_HEIGHT','40','The pixel height of heading images',4,4,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (58,'Subcategory Image Width','SUBCATEGORY_IMAGE_WIDTH','100','The pixel width of subcategory images',4,5,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (59,'Subcategory Image Height','SUBCATEGORY_IMAGE_HEIGHT','80','The pixel height of subcategory images',4,6,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (60,'Calculate Image Size','CONFIG_CALCULATE_IMAGE_SIZE','true','Calculate the size of images?',4,7,'0000-00-00','2007-04-26 17:35:18',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (61,'Image Required','IMAGE_REQUIRED','true','Enable to display broken images. Good for development.',4,8,'0000-00-00','2007-04-26 17:35:18',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (62,'Gender','ACCOUNT_GENDER','true','Display gender in the customers account',5,1,'0000-00-00','2007-04-26 17:35:18',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (63,'Date of Birth','ACCOUNT_DOB','true','Display date of birth in the customers account',5,2,'0000-00-00','2007-04-26 17:35:18',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (64,'Company','ACCOUNT_COMPANY','false','Display company in the customers account',5,3,'0000-00-00','2007-04-26 17:35:18',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (65,'Suburb','ACCOUNT_SUBURB','true','Display suburb in the customers account',5,4,'0000-00-00','2007-04-26 17:35:18',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (66,'State','ACCOUNT_STATE','true','Display state in the customers account',5,5,'0000-00-00','2007-04-26 17:35:18',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (67,'Installed Modules','MODULE_PAYMENT_INSTALLED','moneyorder.php;cash.php;securepay.php;dresdnerbank.php;wallet.php;virtualpay.php','List of payment module filenames separated by a semi-colon. This is automatically updated. No need to edit. (Example: cc.php;cod.php;paypal.php)',6,0,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (68,'Installed Modules','MODULE_ORDER_TOTAL_INSTALLED','ot_subtotal.php;ot_shipping.php;ot_tax.php;ot_coupon.php;ot_total.php','List of order_total module filenames separated by a semi-colon. This is automatically updated. No need to edit. (Example: ot_subtotal.php;ot_tax.php;ot_shipping.php;ot_total.php)',6,0,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (69,'Installed Modules','MODULE_SHIPPING_INSTALLED','auspost.php;auspostair.php;ausposteconomy.php;auspostexpress.php;auspostsea.php','List of shipping module filenames separated by a semi-colon. This is automatically updated. No need to edit. (Example: ups.php;flat.php;item.php)',6,0,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (84,'Default Currency','DEFAULT_CURRENCY','AUD','Default Currency',6,0,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (85,'Default Language','DEFAULT_LANGUAGE','en','Default Language',6,0,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (86,'Default Order Status For New Orders','DEFAULT_ORDERS_STATUS_ID','1','When a new order is created, this order status will be assigned to it.',6,0,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (96,'Display Total','MODULE_ORDER_TOTAL_TOTAL_STATUS','true','Do you want to display the total order value?',6,4,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (98,'Country of Origin','SHIPPING_ORIGIN_COUNTRY','13','Select the country of origin to be used in shipping quotes.',7,1,'0000-00-00','2007-04-26 17:35:19','tep_get_country_name','tep_cfg_pull_down_country_list('),
  (99,'Postal Code','SHIPPING_ORIGIN_ZIP','4066','Enter the Postal Code (ZIP) of the Store to be used in shipping quotes.',7,2,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (100,'Enter the Maximum Package Weight you will ship','SHIPPING_MAX_WEIGHT','50','Carriers have a max weight limit for a single package. This is a common one for all.',7,3,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (101,'Package Tare weight.','SHIPPING_BOX_WEIGHT','0','What is the weight of typical packaging of small to medium packages?',7,4,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (102,'Larger packages - percentage increase.','SHIPPING_BOX_PADDING','10','For 10% enter 10',7,5,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (103,'Display Product Image','PRODUCT_LIST_IMAGE','1','Do you want to display the Product Image?',8,1,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (104,'Display Product Manufaturer Name','PRODUCT_LIST_MANUFACTURER','0','Do you want to display the Product Manufacturer Name?',8,2,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (105,'Display Product Model','PRODUCT_LIST_MODEL','0','Do you want to display the Product Model?',8,3,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (106,'Display Product Name','PRODUCT_LIST_NAME','2','Do you want to display the Product Name?',8,4,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (107,'Display Product Price','PRODUCT_LIST_PRICE','3','Do you want to display the Product Price',8,5,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (108,'Display Product Quantity','PRODUCT_LIST_QUANTITY','0','Do you want to display the Product Quantity?',8,6,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (109,'Display Product Weight','PRODUCT_LIST_WEIGHT','0','Do you want to display the Product Weight?',8,7,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (110,'Display Buy Now column','PRODUCT_LIST_BUY_NOW','4','Do you want to display the Buy Now column?',8,8,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (111,'Display Category/Manufacturer Filter (0=disable; 1=enable)','PRODUCT_LIST_FILTER','1','Do you want to display the Category/Manufacturer Filter?',8,9,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (112,'Location of Prev/Next Navigation Bar (1-top, 2-bottom, 3-both)','PREV_NEXT_BAR_LOCATION','3','Sets the location of the Prev/Next Navigation Bar (1-top, 2-bottom, 3-both)',8,10,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (113,'Check stock level','STOCK_CHECK','true','Check to see if sufficent stock is available',9,1,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (114,'Subtract stock','STOCK_LIMITED','true','Subtract product in stock by product orders',9,2,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (115,'Allow Checkout','STOCK_ALLOW_CHECKOUT','true','Allow customer to checkout even if there is insufficient stock',9,3,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (116,'Mark product out of stock','STOCK_MARK_PRODUCT_OUT_OF_STOCK','***','Display something on screen so customer can see which product has insufficient stock',9,4,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (117,'Stock Re-order level','STOCK_REORDER_LEVEL','5','Define when stock needs to be re-ordered',9,5,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (118,'Store Page Parse Time','STORE_PAGE_PARSE_TIME','false','Store the time it takes to parse a page',10,1,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (119,'Log Destination','STORE_PAGE_PARSE_TIME_LOG','/var/log/www/tep/page_parse_time.log','Directory and filename of the page parse time log',10,2,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (120,'Log Date Format','STORE_PARSE_DATE_TIME_FORMAT','%d/%m/%Y %H:%M:%S','The date format',10,3,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (121,'Display The Page Parse Time','DISPLAY_PAGE_PARSE_TIME','true','Display the page parse time (store page parse time must be enabled)',10,4,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (122,'Store Database Queries','STORE_DB_TRANSACTIONS','false','Store the database queries in the page parse time log (PHP4 only)',10,5,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (123,'Use Cache','USE_CACHE','true','Use caching features',11,1,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (124,'Cache Directory','DIR_FS_CACHE','/tmp/','The directory where the cached files are saved',11,2,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (125,'E-Mail Transport Method','EMAIL_TRANSPORT','sendmail','Defines if this server uses a local connection to sendmail or uses an SMTP connection via TCP/IP. Servers running on Windows and MacOS should change this setting to SMTP.',12,1,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''sendmail'', ''smtp''),'),
  (126,'E-Mail Linefeeds','EMAIL_LINEFEED','LF','Defines the character sequence used to separate mail headers.',12,2,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''LF'', ''CRLF''),'),
  (127,'Use MIME HTML When Sending Emails','EMAIL_USE_HTML','false','Send e-mails in HTML format',12,3,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (128,'Verify E-Mail Addrsses Through DNS','ENTRY_EMAIL_ADDRESSES_CHECK','false','Verify e-mail address through a DNS server',12,4,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (129,'Send E-Mails','SEND_EMAILS','true','Send out e-mails',12,5,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (130,'Enable download','DOWNLOAD_ENABLED','true','Enable the products download functions.',13,1,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (131,'Download by redirect','DOWNLOAD_BY_REDIRECT','true','Use browser redirection for download. Disable on non-Unix systems.',13,2,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (132,'Expiry delay (days)','DOWNLOAD_MAX_DAYS','7','Set number of days before the download link expires. 0 means no limit.',13,3,'0000-00-00','2007-04-26 17:35:19',NULL,''),
  (133,'Maximum number of downloads','DOWNLOAD_MAX_COUNT','5','Set the maximum number of downloads. 0 means no download authorized.',13,4,'0000-00-00','2007-04-26 17:35:19',NULL,''),
  (134,'Enable GZip Compression','GZIP_COMPRESSION','false','Enable HTTP GZip compression.',14,1,'0000-00-00','2007-04-26 17:35:19',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (135,'Compression Level','GZIP_LEVEL','5','Use this compression level 0-9 (0 = minimum, 9 = maximum).',14,2,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (136,'Session Directory','SESSION_WRITE_DIRECTORY','/tmp','If sessions are file based, store them in this directory.',15,1,'0000-00-00','2007-04-26 17:35:20',NULL,NULL),
  (137,'Force Cookie Use','SESSION_FORCE_COOKIE_USE','False','Force the use of sessions when cookies are only enabled.',15,2,'0000-00-00','2007-04-26 17:35:20',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (138,'Check SSL Session ID','SESSION_CHECK_SSL_SESSION_ID','True','Validate the SSL_SESSION_ID on every secure HTTPS page request.',15,3,'0000-00-00','2007-04-26 17:35:20',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (139,'Check User Agent','SESSION_CHECK_USER_AGENT','False','Validate the clients browser user agent on every page request.',15,4,'0000-00-00','2007-04-26 17:35:20',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (140,'Check IP Address','SESSION_CHECK_IP_ADDRESS','True','Validate the clients IP address on every page request.',15,5,'0000-00-00','2007-04-26 17:35:20',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (141,'Prevent Spider Sessions','SESSION_BLOCK_SPIDERS','True','Prevent known spiders from starting a session.',15,6,'0000-00-00','2007-04-26 17:35:20',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (142,'Recreate Session','SESSION_RECREATE','True','Recreate the session to generate a new session ID when the customer logs on or creates an account (PHP >=4.1 needed).',15,7,'0000-00-00','2007-04-26 17:35:20',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (143,'PRODUCT DESCRIPTIONS use WYSIWYG HTMLAREA?','HTML_AREA_WYSIWYG_DISABLE','Enable','Enable/Disable WYSIWYG box',112,0,'0000-00-00','2007-04-26 17:35:46',NULL,'tep_cfg_select_option(array(''Enable'', ''Disable''),'),
  (144,'Product Description Basic/Advanced Version?','HTML_AREA_WYSIWYG_BASIC_PD','Basic','Basic Features FASTER<br>Advanced Features SLOWER',112,10,'0000-00-00','2007-04-26 17:35:46',NULL,'tep_cfg_select_option(array(''Basic'', ''Advanced''),'),
  (145,'Product Description Layout Width','HTML_AREA_WYSIWYG_WIDTH','505','How WIDE should the HTMLAREA be in pixels (default: 505)',112,15,'0000-00-00','2007-04-26 17:35:46',NULL,''),
  (146,'Product Description Layout Height','HTML_AREA_WYSIWYG_HEIGHT','240','How HIGH should the HTMLAREA be in pixels (default: 240)',112,19,'0000-00-00','2007-04-26 17:35:46',NULL,''),
  (147,'CUSTOMER EMAILS use WYSIWYG HTMLAREA?','HTML_AREA_WYSIWYG_DISABLE_EMAIL','Enable','Use WYSIWYG Area in Email Customers',112,20,'0000-00-00','2007-04-26 17:35:46',NULL,'tep_cfg_select_option(array(''Enable'', ''Disable''),'),
  (148,'Customer Email Basic/Advanced Version?','HTML_AREA_WYSIWYG_BASIC_EMAIL','Basic','Basic Features FASTER<br>Advanced Features SLOWER',112,21,'0000-00-00','2007-04-26 17:35:46',NULL,'tep_cfg_select_option(array(''Basic'', ''Advanced''),'),
  (149,'Customer Email Layout Width','EMAIL_AREA_WYSIWYG_WIDTH','505','How WIDE should the HTMLAREA be in pixels (default: 505)',112,25,'0000-00-00','2007-04-26 17:35:46',NULL,''),
  (150,'Customer Email Layout Height','EMAIL_AREA_WYSIWYG_HEIGHT','140','How HIGH should the HTMLAREA be in pixels (default: 140)',112,29,'0000-00-00','2007-04-26 17:35:46',NULL,''),
  (151,'NEWSLETTER EMAILS use WYSIWYG HTMLAREA?','HTML_AREA_WYSIWYG_DISABLE_NEWSLETTER','Enable','Use WYSIWYG Area in Email Newsletter',112,30,'0000-00-00','2007-04-26 17:35:46',NULL,'tep_cfg_select_option(array(''Enable'', ''Disable''),'),
  (152,'Newsletter Email Basic/Advanced Version?','HTML_AREA_WYSIWYG_BASIC_NEWSLETTER','Basic','Basic Features FASTER<br>Advanced Features SLOWER',112,32,'0000-00-00','2007-04-26 17:35:46',NULL,'tep_cfg_select_option(array(''Basic'', ''Advanced''),'),
  (153,'Newsletter Email Layout Width','NEWSLETTER_EMAIL_WYSIWYG_WIDTH','505','How WIDE should the HTMLAREA be in pixels (default: 505)',112,35,'0000-00-00','2007-04-26 17:35:46',NULL,''),
  (154,'Newsletter Email Layout Height','NEWSLETTER_EMAIL_WYSIWYG_HEIGHT','140','How HIGH should the HTMLAREA be in pixels (default: 140)',112,39,'0000-00-00','2007-04-26 17:35:46',NULL,''),
  (155,'DEFINE MAINPAGE use WYSIWYG HTMLAREA?','HTML_AREA_WYSIWYG_DISABLE_DEFINE','Enable','Use WYSIWYG Area in Define Mainpage',112,40,'0000-00-00','2007-04-26 17:35:46',NULL,'tep_cfg_select_option(array(''Enable'', ''Disable''),'),
  (156,'Define Mainpage Basic/Advanced Version?','HTML_AREA_WYSIWYG_BASIC_DEFINE','Advanced','Basic Features FASTER<br>Advanced Features SLOWER',112,41,'0000-00-00','2007-04-26 17:35:46',NULL,'tep_cfg_select_option(array(''Basic'', ''Advanced''),'),
  (157,'Define Mainpage Layout Width','DEFINE_MAINPAGE_WYSIWYG_WIDTH','605','How WIDE should the HTMLAREA be in pixels (default: 505)',112,42,'0000-00-00','2007-04-26 17:35:46',NULL,''),
  (158,'Define Mainpage Layout Height','DEFINE_MAINPAGE_WYSIWYG_HEIGHT','300','How HIGH should the HTMLAREA be in pixels (default: 140)',112,43,'0000-00-00','2007-04-26 17:35:46',NULL,''),
  (159,'GLOBAL - User Interface Font Type','HTML_AREA_WYSIWYG_FONT_TYPE','Arial','User Interface Font Type<br>(not saved to product description)',112,45,'0000-00-00','2007-04-26 17:35:46',NULL,'tep_cfg_select_option(array(''Arial'', ''Courier New'', ''Georgia'', ''Impact'', ''Tahoma'', ''Times New Roman'', ''Verdana'', ''Wingdings''),'),
  (160,'GLOBAL - User Interface Font Size','HTML_AREA_WYSIWYG_FONT_SIZE','12','User Interface Font Size (not saved to product description)<p><b>10 Equals 10 pt',112,50,'0000-00-00','2007-04-26 17:35:46',NULL,'tep_cfg_select_option(array(\\''8\\'', \\''10\\'', \\''12\\'', \\''14\\'', \\''18\\'', \\''24\\'', \\''36\\''),'),
  (161,'GLOBAL - User Interface Font Colour','HTML_AREA_WYSIWYG_FONT_COLOUR','Black','White, Black, C0C0C0, Red, FFFFFF, Yellow, Pink, Blue, Gray, 000000, ect..<br>basically any colour or HTML colour code!<br>(not saved to product description)',112,55,'0000-00-00','2007-04-26 17:35:46',NULL,''),
  (162,'GLOBAL - User Interface Background Colour','HTML_AREA_WYSIWYG_BG_COLOUR','White','White, Black, C0C0C0, Red, FFFFFF, Yellow, Pink, Blue, Gray, 000000, ect..<br>basically any colour or html colour code!<br>(not saved to product description)',112,60,'0000-00-00','2007-04-26 17:35:46',NULL,''),
  (163,'GLOBAL - ALLOW DEBUG MODE?','HTML_AREA_WYSIWYG_DEBUG','0','Moniter Live-html, It updates as you type in a 2nd field above it.<p>Disable Debug = 0<br>Enable Debug = 1<br>Default = 0 OFF',112,65,'0000-00-00','2007-04-26 17:35:46',NULL,'tep_cfg_select_option(array(''0'', ''1''),'),
  (164,'E-Mail Address','AFFILIATE_EMAIL_ADDRESS','<affiliate@localhost.com>','The E Mail Address for the Affiliate Programm',900,1,'0000-00-00','2007-04-26 17:35:46',NULL,NULL),
  (165,'Affiliate Pay Per Sale Payment % Rate','AFFILIATE_PERCENT','10.0000','Percentage Rate for the Affiliate Program',900,2,'0000-00-00','2007-04-26 17:35:46',NULL,NULL),
  (166,'Payment Threshold','AFFILIATE_THRESHOLD','50.00','Payment Threshold for paying affiliates',900,3,'0000-00-00','2007-04-26 17:35:46',NULL,NULL),
  (167,'Cookie Lifetime','AFFILIATE_COOKIE_LIFETIME','7200','How long does the click count (seconds) if customer comes back',900,4,'0000-00-00','2007-04-26 17:35:46',NULL,NULL),
  (168,'Billing Time','AFFILIATE_BILLING_TIME','30','Orders billed must be at least \"30\" days old.<br>This is needed if a order is refunded',900,5,'0000-00-00','2007-04-26 17:35:46',NULL,NULL),
  (169,'Order Min Status','AFFILIATE_PAYMENT_ORDER_MIN_STATUS','3','The status an order must have at least, to be billed',900,6,'0000-00-00','2007-04-26 17:35:46',NULL,NULL),
  (170,'Pay Affiliates with check','AFFILIATE_USE_CHECK','true','Pay Affiliates with check',900,7,'0000-00-00','2007-04-26 17:35:46',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (171,'Pay Affiliates with PayPal','AFFILIATE_USE_PAYPAL','true','Pay Affiliates with PayPal',900,8,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (172,'Pay Affiliates by Bank','AFFILIATE_USE_BANK','true','Pay Affiliates by Bank',900,9,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (173,'Individual Affiliate Percentage','AFFILATE_INDIVIDUAL_PERCENTAGE','true','Allow per Affiliate provision',900,10,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (174,'Use Affiliate-tier','AFFILATE_USE_TIER','false','Multilevel Affiliate provisions',900,11,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (175,'Number of Tierlevels','AFFILIATE_TIER_LEVELS','0','Number of Tierlevels',900,12,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (176,'Percentage Rate for the Tierlevels','AFFILIATE_TIER_PERCENTAGE','8.00;5.00;1.00','Percent Rates for the tierlevels<br>Example: 8.00;5.00;1.00',900,13,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (191,'Default theme','DEFAULT_TEMPLATE','Freeway','Use this to set the default theme.',1,0,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_pull_down_template_list('),
  (211,'Allow Category Descriptions','ALLOW_CATEGORY_DESCRIPTIONS','true','Allow use of full text descriptions for categories',150,19,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (234,'Show Featured Products on Main Page','SHOW_MAIN_FEATURED_PRODUCTS','true','true= on<br>false= off',154,20,'0000-00-00','2007-04-26 17:35:48',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (235,'Product Featured Maximum Display','MAX_DISPLAY_FEATURED_PRODUCTS','6','Amount of products to on main page',2,170,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (236,'Product Featured Display Results','MAX_DISPLAY_FEATURED_PRODUCTS_LISTING','10','Amount of products to list per page',2,171,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (264,'Big Images Directory','IN_IMAGE_BIGIMAGES','images_big/','The directory inside catalog/ images where your big images are stored.',99,1,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (265,'Thumbnail Images Directory','IN_IMAGE_THUMBS','thumbs/','The directory inside catalog/ images where you extra image thumbs are stored.',99,2,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (266,'Main Thumbnail In Thumb Directory','MAIN_THUMB_IN_SUBDIR','true','If you store your main thumb in the thumbnail directory set this true.  If it is in the main image dir, set it false.',99,3,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (267,'Number of Pics per Row','THUMBS_PER_ROW','3','How Many images to show per row.',99,4,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (268,'Mo Pics Extension','MORE_PICS_EXT','_pic','The addition to your image name for the mopics',99,5,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (269,'Main Big Pic Extension','BIG_PIC_EXT','_big','This is if you name your main big image like IMAGE_big.jpg, you would put <b>_big</b> here.  Otherwise leave it blank',99,6,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (270,'Mo Pics Thumbnail Image Type','THUMB_IMAGE_TYPE','jpg','The file type of the mopic thumbnails',99,7,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''jpg'', ''gif'', ''png'', ''bmp'', ''jpeg''),'),
  (271,'Mo Pics Big Image Type','BIG_IMAGE_TYPE','jpg','The file type of the mopic big images',99,8,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''jpg'', ''gif'', ''png'', ''bmp'',  ''jpeg''),'),
  (272,'<B>Down for Maintenance: ON/OFF</B>','DOWN_FOR_MAINTENANCE','false','Down for Maintenance <br>(true=on false=off)',16,1,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (273,'Down for Maintenance: filename','DOWN_FOR_MAINTENANCE_FILENAME','down_for_maintenance.php','Down for Maintenance filename Default=down_for_maintenance.php',16,2,'0000-00-00','2007-04-26 17:35:47',NULL,''),
  (274,'Down for Maintenance: Hide Header','DOWN_FOR_MAINTENANCE_HEADER_OFF','false','Down for Maintenance: Hide Header <br>(true=hide false=show)',16,3,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (275,'Down for Maintenance: Hide Column Left','DOWN_FOR_MAINTENANCE_COLUMN_LEFT_OFF','true','Down for Maintenance: Hide Column Left <br>(true=hide false=show)',16,4,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (276,'Down for Maintenance: Hide Column Right','DOWN_FOR_MAINTENANCE_COLUMN_RIGHT_OFF','true','Down for Maintenance: Hide Column Right <br>(true=hide false=show)r',16,5,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (277,'Down for Maintenance: Hide Footer','DOWN_FOR_MAINTENANCE_FOOTER_OFF','false','Down for Maintenance: Hide Footer <br>(true=hide false=show)',16,6,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (278,'Down for Maintenance: Hide Prices','DOWN_FOR_MAINTENANCE_PRICES_OFF','false','Down for Maintenance: Hide Prices <br>(true=hide false=show)',16,7,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (279,'Down For Maintenance (exclude this IP-Address)','EXCLUDE_ADMIN_IP_FOR_MAINTENANCE','144.136.152.5','This IP Address is able to access the website while it is Down For Maintenance (like webmaster)',16,8,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (280,'NOTIFY PUBLIC Before going Down for Maintenance: ON/OFF','WARN_BEFORE_DOWN_FOR_MAINTENANCE','false','Give a WARNING some time before you put your website Down for Maintenance<br>(true=on false=off)<br>If you set the ''Down For Maintenance: ON/OFF'' to true this will automaticly be updated to false',16,9,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (281,'Date and hours for notice before maintenance','PERIOD_BEFORE_DOWN_FOR_MAINTENANCE','12/02/2004  between the hours of 11.00-11.30 PM Australian Estern Standard Time','Date and hours for notice before maintenance website, enter date and hours for maintenance website',16,10,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (282,'Display when webmaster has enabled maintenance','DISPLAY_MAINTENANCE_TIME','true','Display when Webmaster has enabled maintenance <br>(true=on false=off)<br>',16,11,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (283,'Display website maintenance period','DISPLAY_MAINTENANCE_PERIOD','true','Display Website maintenance period <br>(true=on false=off)<br>',16,12,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (284,'Website maintenance period','TEXT_MAINTENANCE_PERIOD_TIME','0h30','Enter Website Maintenance period (hh:mm)',16,13,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (285,'Category/Products Display Order','CATEGORIES_SORT_ORDER','model','<b>Valid Orders:<br>products_name<br>products_name-desc<br>model<br>model-desc</b>',150,99,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (351,'X-Sell','MIN_DISPLAY_XSELL','1','Minimum nuber of X-sell products to display',2,17,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (998,'Shipping Estimator','SHOW_SHIPPING_ESTIMATOR','true','Show Shipping Estimator on Shopping Cart <br>true= always <br>false= button popup only',7,102,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1058,'Company Logo','COMPANY_LOGO','freeway.png','Your Store Logo',1,0,'0000-00-00','2003-12-04 06:07:45',NULL,'file_upload'),
  (1218,'Set Order Status','MODULE_PAYMENT_VIRTUALPAY_ORDER_STATUS_ID','0','Set the status of orders made with this payment module to this value',6,0,'0000-00-00','2007-04-26 17:35:48','tep_get_order_status_name','tep_cfg_pull_down_order_statuses('),
  (1219,'Sort order of display.','MODULE_PAYMENT_VIRTUALPAY_SORT_ORDER','1','Sort order of display. Lowest is displayed first.',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1220,'Enable VirtualPay','MODULE_PAYMENT_VIRTUALPAY_STATUS','True','Do you want to accept VirtualPay payments?',6,1,'0000-00-00','2007-04-26 17:35:48',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (1221,'Transaction Mode','MODULE_PAYMENT_VIRTUALPAY_TESTMODE','Test','Transaction mode used for processing orders',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,'tep_cfg_select_option(array(''Test'', ''Production''),'),
  (1222,'Vendor ID','MODULE_PAYMENT_VIRTUALPAY_VENDOR_ID','sec0001','The vendor id used for the VirtualPay service',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1223,'Payment Zone','MODULE_PAYMENT_VIRTUALPAY_ZONE','2','If a zone is selected, only enable this payment method for that zone.',6,2,'0000-00-00','2007-04-26 17:35:48','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1224,'Enable Cheque/Money Order Module','MODULE_PAYMENT_MONEYORDER_STATUS','True','Do you want to accept Cheque/Money Order payments?',6,1,'0000-00-00','2007-04-26 17:35:49',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (1225,'Money Order  Make Payable to:','MODULE_PAYMENT_MONEYORDER_PAYTO','Freeway Pty. Ltd','Who should payments be made payable to?',6,2,'0000-00-00','2007-04-26 17:35:49',NULL,NULL),
  (1226,'Money Order  Sort order of display.','MODULE_PAYMENT_MONEYORDER_SORT_ORDER','2','Sort order of display. Lowest is displayed first.',6,3,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1227,'Money Order  Payment Zone','MODULE_PAYMENT_MONEYORDER_ZONE','2','If a zone is selected, only enable this payment method for that zone.',6,4,'0000-00-00','2007-04-26 17:35:48','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1228,'Money Order  Set Order Status','MODULE_PAYMENT_MONEYORDER_ORDER_STATUS_ID','2','Set the status of orders made with this payment module to this value',6,7,'0000-00-00','2007-04-26 17:35:48','tep_get_order_status_name','tep_cfg_pull_down_order_statuses('),
  (1229,'Display Sub-Total','MODULE_ORDER_TOTAL_SUBTOTAL_STATUS','true','Do you want to display the order sub-total cost?',6,1,'0000-00-00','2007-04-26 17:35:48',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1230,'Sort Order','MODULE_ORDER_TOTAL_SUBTOTAL_SORT_ORDER','1','Sort order of display.',6,2,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1231,'Display Shipping','MODULE_ORDER_TOTAL_SHIPPING_STATUS','true','Do you want to display the order shipping cost?',6,1,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1232,'Sort Order','MODULE_ORDER_TOTAL_SHIPPING_SORT_ORDER','2','Sort order of display.',6,2,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (1233,'Allow Free Shipping','MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING','false','Do you want to allow free shipping?',6,3,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1234,'Free Shipping For Orders Over','MODULE_ORDER_TOTAL_SHIPPING_FREE_SHIPPING_OVER','2000','Provide free shipping for orders over the set amount.',6,4,'0000-00-00','2007-04-26 17:35:47','currencies->format',NULL),
  (1235,'Provide Free Shipping For Orders Made','MODULE_ORDER_TOTAL_SHIPPING_DESTINATION','international','Provide free shipping for orders sent to the set destination.',6,5,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''national'', ''international'', ''both''),'),
  (1236,'Display Total','MODULE_ORDER_TOTAL_GV_STATUS','true','Do you want to display the Gift Voucher value?',6,1,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1237,'Sort Order','MODULE_ORDER_TOTAL_GV_SORT_ORDER','5','Sort order of display.',6,2,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1238,'Queue Purchases','MODULE_ORDER_TOTAL_GV_QUEUE','true','Do you want to queue purchases of the Gift Voucher?',6,3,'0000-00-00','2007-04-26 17:35:48',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1239,'Include Shipping','MODULE_ORDER_TOTAL_GV_INC_SHIPPING','false','Include Shipping in calculation',6,5,'0000-00-00','2007-04-26 17:35:48',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1240,'Include Tax','MODULE_ORDER_TOTAL_GV_INC_TAX','true','Include Tax in calculation.',6,6,'0000-00-00','2007-04-26 17:35:48',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1241,'Re-calculate Tax','MODULE_ORDER_TOTAL_GV_CALC_TAX','Standard','Re-Calculate Tax',6,7,'0000-00-00','2007-04-26 17:35:48',NULL,'tep_cfg_select_option(array(''None'', ''Standard'', ''Credit Note''),'),
  (1242,'Tax Class','MODULE_ORDER_TOTAL_GV_TAX_CLASS','2','Use the following tax class when treating Gift Voucher as Credit Note.',6,0,'0000-00-00','2007-04-26 17:35:48','tep_get_tax_class_title','tep_cfg_pull_down_tax_classes('),
  (1243,'Credit including Tax','MODULE_ORDER_TOTAL_GV_CREDIT_TAX','false','Add tax to purchased Gift Voucher when crediting to Account',6,8,'0000-00-00','2007-04-26 17:35:48',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1244,'Display Total','MODULE_ORDER_TOTAL_COUPON_STATUS','false','Do you want to display the Discount Coupon value?',6,1,'0000-00-00','2007-04-26 17:35:48',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1245,'Sort Order','MODULE_ORDER_TOTAL_COUPON_SORT_ORDER','7','Sort order of display.',6,2,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (1246,'Include Shipping','MODULE_ORDER_TOTAL_COUPON_INC_SHIPPING','false','Include Shipping in calculation',6,5,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1247,'Include Tax','MODULE_ORDER_TOTAL_COUPON_INC_TAX','true','Include Tax in calculation.',6,6,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1248,'Re-calculate Tax','MODULE_ORDER_TOTAL_COUPON_CALC_TAX','Standard','Re-Calculate Tax',6,7,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''None'', ''Standard'', ''Credit Note''),'),
  (1249,'Tax Class','MODULE_ORDER_TOTAL_COUPON_TAX_CLASS','2','Use the following tax class when treating Discount Coupon as Credit Note.',6,0,'0000-00-00','2007-04-26 17:35:48','tep_get_tax_class_title','tep_cfg_pull_down_tax_classes('),
  (1269,'Enable auspostair','MODULE_SHIPPING_AUSPOST_AIR_STATUS','True','Do you want to offer auspostair?',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (1270,'Insurance','MODULE_SHIPPING_AUSPOST_AIR_INSURANCE','','Insurance cost is based on the total cost of items. Example: 25:8.50,50:5.50,etc.. Up to $25 charge $8.50, from there to $50 charge $5.50, etc',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1271,'Dispatch Postcode','MODULE_SHIPPING_AUSPOST_AIR_SPCODE','4066','Dispatch Postcode?',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1272,'Handling Fee','MODULE_SHIPPING_AUSPOST_AIR_HANDLING','2','Handling Fee for this shipping method',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1273,'Parcel Height','MODULE_SHIPPING_AUSPOST_AIR_SHEIGHT','100','Parcel Height (in mm)',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1274,'Parcel Width','MODULE_SHIPPING_AUSPOST_AIR_SWIDTH','100','Parcel Width (in mm)',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1275,'Parcel Depth','MODULE_SHIPPING_AUSPOST_AIR_SDEPTH','100','Parcel Depth (in mm)',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1277,'Tax Class','MODULE_SHIPPING_AUSPOST_AIR_TAX_CLASS','0','Use the following tax class on the shipping fee.',6,0,'0000-00-00','2007-04-26 17:35:48','tep_get_tax_class_title','tep_cfg_pull_down_tax_classes('),
  (1278,'Sort order of display.','MODULE_SHIPPING_AUSPOST_AIR_SORT_ORDER','1','Sort order of display. Lowest is displayed first.',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1279,'Enable ausposteconomy','MODULE_SHIPPING_AUSPOST_ECONOMY_STATUS','True','Do you want to offer ausposteconomy?',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (1280,'Insurance','MODULE_SHIPPING_AUSPOST_ECONOMY_INSURANCE','','Insurance cost is based on the total cost of items. Example: 25:8.50,50:5.50,etc.. Up to $25 charge $8.50, from there to $50 charge $5.50, etc',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1281,'Dispatch Postcode','MODULE_SHIPPING_AUSPOST_ECONOMY_SPCODE','4066','Dispatch Postcode?',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1282,'Handling Fee','MODULE_SHIPPING_AUSPOST_ECONOMY_HANDLING','2','Handling Fee for this shipping method',6,0,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1283,'Parcel Height','MODULE_SHIPPING_AUSPOST_ECONOMY_SHEIGHT','100','Parcel Height (in mm)',6,0,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (1284,'Parcel Width','MODULE_SHIPPING_AUSPOST_ECONOMY_SWIDTH','100','Parcel Width (in mm)',6,0,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (1285,'Parcel Depth','MODULE_SHIPPING_AUSPOST_ECONOMY_SDEPTH','100','Parcel Depth (in mm)',6,0,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (1286,'Shipping Zone','MODULE_SHIPPING_AUSPOST_ECONOMY_ZONE','2','If a zone is selected, only enable this shipping method for that zone.',6,0,'0000-00-00','2007-04-26 17:35:47','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1287,'Tax Class','MODULE_SHIPPING_AUSPOST_ECONOMY_TAX_CLASS','0','Use the following tax class on the shipping fee.',6,0,'0000-00-00','2007-04-26 17:35:47','tep_get_tax_class_title','tep_cfg_pull_down_tax_classes('),
  (1288,'Sort order of display.','MODULE_SHIPPING_AUSPOST_ECONOMY_SORT_ORDER','2','Sort order of display. Lowest is displayed first.',6,0,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (1289,'Enable auspostexpress','MODULE_SHIPPING_AUSPOST_EXPRESS_STATUS','True','Do you want to offer auspostexpress?',6,0,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (1290,'Insurance','MODULE_SHIPPING_AUSPOST_EXPRESS_INSURANCE','','Insurance cost is based on the total cost of items. Example: 25:8.50,50:5.50,etc.. Up to $25 charge $8.50, from there to $50 charge $5.50, etc',6,0,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (1291,'Dispatch Postcode','MODULE_SHIPPING_AUSPOST_EXPRESS_SPCODE','4066','Dispatch Postcode?',6,0,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (1292,'Handling Fee','MODULE_SHIPPING_AUSPOST_EXPRESS_HANDLING','2','Handling Fee for this shipping method',6,0,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (1293,'Parcel Height','MODULE_SHIPPING_AUSPOST_EXPRESS_SHEIGHT','100','Parcel Height (in mm)',6,0,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (1294,'Parcel Width','MODULE_SHIPPING_AUSPOST_EXPRESS_SWIDTH','100','Parcel Width (in mm)',6,0,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (1295,'Parcel Depth','MODULE_SHIPPING_AUSPOST_EXPRESS_SDEPTH','100','Parcel Depth (in mm)',6,0,'0000-00-00','2007-04-26 17:35:18',NULL,NULL),
  (1296,'Shipping Zone','MODULE_SHIPPING_AUSPOST_EXPRESS_ZONE','3','If a zone is selected, only enable this shipping method for that zone.',6,0,'0000-00-00','2007-04-26 17:35:18','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1297,'Tax Class','MODULE_SHIPPING_AUSPOST_EXPRESS_TAX_CLASS','2','Use the following tax class on the shipping fee.',6,0,'0000-00-00','2007-04-26 17:35:18','tep_get_tax_class_title','tep_cfg_pull_down_tax_classes('),
  (1298,'Sort order of display.','MODULE_SHIPPING_AUSPOST_EXPRESS_SORT_ORDER','3','Sort order of display. Lowest is displayed first.',6,0,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (1299,'Enable auspostsea','MODULE_SHIPPING_AUSPOST_SEA_STATUS','True','Do you want to offer auspostsea?',6,0,'0000-00-00','2007-04-26 17:35:47',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (1300,'Insurance','MODULE_SHIPPING_AUSPOST_SEA_INSURANCE','','Insurance cost is based on the total cost of items. Example: 25:8.50,50:5.50,etc.. Up to $25 charge $8.50, from there to $50 charge $5.50, etc',6,0,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (1301,'Dispatch Postcode','MODULE_SHIPPING_AUSPOST_SEA_SPCODE','4066','Dispatch Postcode?',6,0,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (1302,'Handling Fee','MODULE_SHIPPING_AUSPOST_SEA_HANDLING','2','Handling Fee for this shipping method',6,0,'0000-00-00','2007-04-26 17:35:47',NULL,NULL),
  (1303,'Parcel Height','MODULE_SHIPPING_AUSPOST_SEA_SHEIGHT','100','Parcel Height (in mm)',6,0,'0000-00-00','2007-04-26 17:35:49',NULL,NULL),
  (1304,'Parcel Width','MODULE_SHIPPING_AUSPOST_SEA_SWIDTH','100','Parcel Width (in mm)',6,0,'0000-00-00','2007-04-26 17:35:49',NULL,NULL),
  (1305,'Parcel Depth','MODULE_SHIPPING_AUSPOST_SEA_SDEPTH','100','Parcel Depth (in mm)',6,0,'0000-00-00','2007-04-26 17:35:49',NULL,NULL),
  (1306,'Shipping Zone','MODULE_SHIPPING_AUSPOST_SEA_ZONE','2','If a zone is selected, only enable this shipping method for that zone.',6,0,'0000-00-00','2007-04-26 17:35:49','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1307,'Tax Class','MODULE_SHIPPING_AUSPOST_SEA_TAX_CLASS','0','Use the following tax class on the shipping fee.',6,0,'0000-00-00','2007-04-26 17:35:49','tep_get_tax_class_title','tep_cfg_pull_down_tax_classes('),
  (1308,'Sort order of display.','MODULE_SHIPPING_AUSPOST_SEA_SORT_ORDER','4','Sort order of display. Lowest is displayed first.',6,0,'0000-00-00','2007-04-26 17:35:49',NULL,NULL),
  (1309,'Sort Order','MODULE_ORDER_TOTAL_TOTAL_SORT_ORDER','99','Sort order of display',6,4,'0000-00-00','2007-04-26 17:35:48',NULL,NULL),
  (1311,'Display Tax','MODULE_ORDER_TOTAL_TAX_STATUS','true','Do you want to display the order tax value?',6,1,'0000-00-00','2007-04-26 17:35:48',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1312,'Sort Order','MODULE_ORDER_TOTAL_TAX_SORT_ORDER','3','Sort order of display.',6,2,'0000-00-00','2007-04-26 17:35:19',NULL,NULL),
  (1313,'Last sql file executed during previous installation','LAST_SQL_FILE_EXECUTED','1_4_7','',99999,0,'0000-00-00','0000-00-00',NULL,NULL),
  (1323,'Test Email address','EVENTS_TEST_EMAIL_ADDRESS','admin@freeway.com','testing email address used in messaging system',12,1,'0000-00-00','2007-04-26 17:35:52',NULL,NULL),
  (1324,'Second Phone number','ACCOUNT_SECOND_PHONE','true','Second phone number moved manually to primary by admin if needed',5,6,'0000-00-00','2007-04-26 17:35:52',NULL,'tep_cfg_select_option(array(''true'',''false''),'),
  (1325,'Second Email address','ACCOUNT_SECOND_EMAIL','true','Second Email address moved manually to primary by admin if needed',5,7,'0000-00-00','2007-04-26 17:35:52',NULL,'tep_cfg_select_option(array(''true'',''false''),'),
  (1344,'Cash  Sort order of display.','MODULE_PAYMENT_CASH_SORT_ORDER','3','Sort order of display. Lowest is displayed first.',6,2,'0000-00-00','2007-04-26 17:35:52',NULL,NULL),
  (1345,'Cash  Payment Zone','MODULE_PAYMENT_CASH_ZONE','2','If a zone is selected, only enable this payment method for that zone.',6,3,'0000-00-00','2007-04-26 17:35:52','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1346,'Cash  Set Order Status','MODULE_PAYMENT_CASH_ORDER_STATUS_ID','1','Set the status of orders made with this payment module to this value',6,6,'0000-00-00','2007-04-26 17:35:52','tep_get_order_status_name','tep_cfg_pull_down_order_statuses('),
  (1347,'Enable Cash Order Module','MODULE_PAYMENT_CASH_STATUS','True','Do you want to accept Cash Order payments?',6,1,'0000-00-00','2007-04-26 17:35:52',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (1348,'SMS Key','EVENTS_SMS_KEY','QJ7186','Key to activate sms message sending process',901,3,'0000-00-00','2007-04-26 17:35:52',NULL,NULL),
  (1350,'SMS Test phone number','SMS_TEST_PHONE','12345678','SMS Testing phone number to call on',903,3,'0000-00-00','2007-04-26 17:35:52',NULL,NULL),
  (1351,'SMS Available Gateways','EVENTS_SMS_AVAILABLE_GATEWAYS','redcoal.com','Available Gateways to select',901,3,'0000-00-00','2007-04-26 17:35:52',NULL,NULL),
  (1352,'SMS Gateway','SMS_GATEWAY','clickatell','Gateway to send sms email messages',903,3,'0000-00-00','2007-04-26 17:35:52',NULL,'tep_cfg_sms_gateway('),
  (1353,'Date format to display dates','EVENTS_DATE_FORMAT','d-m-Y','Date format used to display date entries',1,4,'0000-00-00','2007-04-26 17:35:52',NULL,'tep_cfg_date_formats('),
  (1354,'Installed Modules','MODULE_SMS_GATEWAYS_INSTALLED','clickatell.php','This is automatically updated. No need to edit.',6,0,'0000-00-00','2007-04-26 17:35:52',NULL,NULL),
  (1355,'Survey text change','EVENTS_SURVEY_TEXT','Sample Survey','This text is repaced in survey details.',904,2,'0000-00-00','2007-04-26 17:35:52',NULL,NULL),
  (1356,'Enable Clickatell sms Module','MODULE_SMS_CLICKATELL_STATUS','True','Do you want to include Clickatell SMS?',6,1,'0000-00-00','2007-04-26 17:35:52',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (1357,'Clickatell Sort order of display.','MODULE_SMS_CLICKATELL_SORT_ORDER','1','Sort order of display. Lowest is displayed first.',6,2,'0000-00-00','2007-04-26 17:35:52',NULL,NULL),
  (1358,'Clickatell Host Url.','MODULE_SMS_CLICKATELL_URL','','Gateway URL used to access',6,3,'0000-00-00','2007-04-26 17:35:52',NULL,NULL),
  (1359,'Clickatell Username.','MODULE_SMS_CLICKATELL_USERNAME','','Username used to authenticate gateway',6,0,'0000-00-00','2007-04-26 17:35:52',NULL,NULL),
  (1360,'Clickatell Password.','MODULE_SMS_CLICKATELL_PASSWORD','','Password used to authenticate gateway',6,0,'0000-00-00','2007-04-26 17:35:52',NULL,NULL),
  (1361,'Clickatell API id.','MODULE_SMS_CLICKATELL_API_ID','','API id used to authenticate gateway',6,0,'0000-00-00','2007-04-26 17:35:52',NULL,NULL),
  (1362,'Lock Order','EVENTS_ORDER_TIMEOUT','10','Lock order for period of time(in minutes)',905,5,'0000-00-00','2007-04-26 17:35:52',NULL,NULL),
  (1363,'Server Date Offset','EVENTS_SERVER_DATE_OFFSET','16','Ensure messages are sent in correct time',1,4,'0000-00-00','2007-04-26 17:35:52',NULL,'tep_cfg_pull_down_date_offset('),
  (1364,'Messaging Times','EVENTS_EMAIL_TIMINGS','0:00,0:00','Limit the times messages are sent',12,3,'0000-00-00','2007-04-26 17:35:52',NULL,'tep_cfg_pull_down_msg_times('),
  (1365,'Messaging Times','EVENTS_SMS_TIMINGS','8:00,21:00','Limit the times messages are sent',903,3,'0000-00-00','2007-04-26 17:35:52',NULL,'tep_cfg_pull_down_msg_times('),
  (1366,'SMS Activation','SMS_ACTIVATE','1','Activation flag used to enable the sms sending process',903,4,'0000-00-00','2007-04-26 17:35:52',NULL,'tep_cfg_sms_option('),
  (1367,'Amount Rounding Factor','EVENTS_ORDER_AMOUNT_ROUND','0.05','Round up gross amounts for the total amount of order reservations',905,5,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_pull_down_round_factors('),
  (1368,'Email Activation','EMAIL_ACTIVATE','1','Activation flag used to enable the email sending process',12,3,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_email_option('),
  (1369,'SMS From name','SMS_FROM_NAME','Freeway','From name used in sending sms messages',903,3,'0000-00-00','2007-04-26 17:35:53',NULL,NULL),
  (1370,'Reserve seats for Renewal','EVENTS_RENEWAL_CHECK','1','Flag used to reserve seats for renewal users',905,3,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_renewal_option('),
  (1371,'Presentation Style','EVENTS_VIEW_STYLE','calendar','Events View Style in Browse events',915,6,'0000-00-00','2007-04-26 17:35:53','','tep_cfg_pull_down_view_style('),
  (1372,'Calendar Style','EVENTS_CALENDAR_STYLE','month','Calendar Style in Browse events',915,7,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_pull_down_calendar_style('),
  (1373,'Maximum Rows','REPORT_MAX_ROWS_PAGE','100','No of Rows per page in Report',906,8,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_pull_down_report_max_rows('),
  (1374,'Maximum Links','REPORT_MAX_LINKS_PAGE','5','No of page links to display in Report',906,8,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_pull_down_report_max_links('),
  (1375,'Email Interval(Sec,)','EMAIL_TIME_LIMIT','1','Set TimeLimit for Email sending process',12,3,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_email_timelimit('),
  (1376,'version','CURRENT_VERSION','0','Details Regarding Reminder of new version',6,6,'0000-00-00','2007-04-26 17:35:53',NULL,''),
  (1377,'Display \"Other\" Referral option','DISPLAY_REFERRAL_OTHER','true','Display \"Other - please specify\" with text box in referral source in account creation',5,22,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1378,'Hide the Referral Question in the Front End','HIDE_REFERRAL_FRONT','false','Hide the Question in the front end in customer details page',5,23,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1379,'Hide the Referral Question in the Back End','HIDE_REFERRAL_BACK','false','Hide the Question in the back end in customer details page',5,23,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_select_option(array(''true'',''false''),'),
  (1380,'Display Customer Details Survey in Front End','CUSTOMER_BOOKING_DETAILS','1','Activation flag used to Display the Customer details survey after sessions display.',904,2,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_email_option('),
  (1381,'No checkout for zero price events','NO_CHECKOUT_ZERO_PRICE','1','Flag used to redirect users with zero event to checkout success without doing checkout process',905,5,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_email_option('),
  (1382,'Enable Dresdner Bank Deposit Module','MODULE_PAYMENT_DRESDNERBANK_STATUS','True','Do you want to accept Australian Bank Deposit payments?',6,1,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_select_option(array(''True'', ''False''), '),
  (1383,'Payment Zone','MODULE_PAYMENT_DRESDNERBANK_ZONE','2','If a zone is selected, only enable this payment method for that zone.',6,2,'0000-00-00','2007-04-26 17:35:53','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1384,'Sort order of display.','MODULE_PAYMENT_DRESDNERBANK_SORT_ORDER','4','Sort order of display. Lowest is displayed first.',6,5,'0000-00-00','2007-04-26 17:35:53',NULL,NULL),
  (1385,'Bank Account No.','MODULE_PAYMENT_DRESDNERBANK_ACCNUM','12345678','Bank Account No.',6,6,'0000-00-00','2007-04-26 17:35:53',NULL,NULL),
  (1386,'Swift Code.','MODULE_PAYMENT_DRESDNERBANK_SWIFT','12345678','Swift Code.',6,7,'0000-00-00','2007-04-26 17:35:53',NULL,NULL),
  (1387,'Bank Account Name','MODULE_PAYMENT_DRESDNERBANK_ACCNAM','Joe Bloggs','Bank account name',6,8,'0000-00-00','2007-04-26 17:35:53',NULL,NULL),
  (1388,'Bank Name','MODULE_PAYMENT_DRESDNERBANK_BANKNAM','The Bank','Bank Name',6,9,'0000-00-00','2007-04-26 17:35:53',NULL,NULL),
  (1389,'Set Order Status','MODULE_PAYMENT_DRESDNERBANK_ORDER_STATUS_ID','1','Set the status of orders made with this payment module to this value',6,10,'0000-00-00','2007-04-26 17:35:53','tep_get_order_status_name','tep_cfg_pull_down_order_statuses('),
  (1390,'Session Timeout for Front-end users','SESSION_TIMEOUT_FRONTEND','20','Set the  session timeout value for  for front-end users',15,12,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_text_field('),
  (1391,'Session Timeout for Back-end users','SESSION_TIMEOUT_BACKEND','10','Set the session timeout value for for back-end users',15,13,'0000-00-00','2007-04-26 17:35:53',NULL,'tep_cfg_text_field('),
  (1392,'Newsletter','ACCOUNT_NEWSLETTER','true','Display Newsleter in the Customer Account',5,6,'0000-00-00','2007-04-26 17:35:53','','tep_cfg_select_option(array(''true'', ''false''),'),
  (1393,'Reservation/waitlist Newsletter','ACCOUNT_RESERVATION_NEWSLETTER','true','Display Reservation/Waitlist Newsleter in the Customer Account',5,6,'0000-00-00','2007-04-26 17:35:54','','tep_cfg_select_option(array(''true'', ''false''),'),
  (1394,'Subscription Newsletter','ACCOUNT_SUBSCRIPTION_NEWSLETTER','true','Display Subscription Newsleter in the Customer Account',5,6,'0000-00-00','2007-04-26 17:35:54','','tep_cfg_select_option(array(''true'', ''false''),'),
  (1395,'Allow Guest To See Prices','ALLOW_GUEST_TO_SEE_PRICES','true','Allow guests to view default prices',153,31,'0000-00-00','2007-04-26 17:35:59',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1396,'Guest Discount','GUEST_DISCOUNT','0','Guest discount',153,32,'0000-00-00','2007-04-26 17:35:59',NULL,NULL),
  (1397,'Minimum Amount','WALLET_MINIMUM_AMOUNT','50','Minimum amount needed in Customers Wallet',902,15,'0000-00-00','2007-04-26 17:36:00',NULL,'tep_cfg_text_field('),
  (1398,'Minimum Amount Type','WALLET_MINIMUM_TYPE','P','Type of Minimum Amount either percentage of last 3 orders or currency value made by wallet payment',902,15,'0000-00-00','2007-04-26 17:36:00','tep_get_wallet_minimum_type','tep_cfg_pull_down_minimum_type('),
  (1399,'First Order Balance','WALLET_FIRST_ORDER_BALANCE','500','Minimum money allowed for  Subscription Order',902,15,'0000-00-00','2007-04-26 17:36:00',NULL,'tep_cfg_text_field('),
  (1400,'Wallet Set Order Status','MODULE_PAYMENT_WALLET_ORDER_STATUS_ID','2','Set the status of orders made with this payment module to this value',6,6,'0000-00-00','2007-04-26 17:36:00','tep_get_order_status_name','tep_cfg_pull_down_order_statuses('),
  (1401,'Wallet Payment Zone','MODULE_PAYMENT_WALLET_ZONE','2','If a zone is selected, only enable this payment method for that zone.',6,3,'0000-00-00','2007-04-26 17:36:00','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1402,'Wallet  Sort order of display.','MODULE_PAYMENT_WALLET_SORT_ORDER','5','Sort order of display. Lowest is displayed first.',6,2,'0000-00-00','2007-04-26 17:36:00',NULL,NULL),
  (1403,'Enable Wallet Module','MODULE_PAYMENT_WALLET_STATUS','True','Do you want to accept Wallet payments?',6,1,'0000-00-00','2007-04-26 17:36:00',NULL,'tep_cfg_select_option(array(''True'', ''False''),'),
  (1404,'User name','ACCOUNT_USERNAME','true','Display username in the customers account',5,1,'0000-00-00','2007-04-26 17:36:00',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1405,'User name','ENTRY_USERNAME_MIN_LENGTH','6','Minimum length of user name',2,3,'0000-00-00','2007-04-26 17:36:00',NULL,NULL),
  (1406,'Define Mainpage type','DEFINEPAGE_TYPE','Default','Display the mainpage',0,15,'0000-00-00','2007-04-26 17:36:00',NULL,NULL),
  (1407,'Define Mainpage categories','DEFINEPAGE_CATEGORIES','Default','Display the mainpage',0,15,'0000-00-00','2007-04-26 17:36:00',NULL,NULL),
  (1412,'Activate the webservice','ENABLE_WEB_SERVICE','0','To Enable or Disable the webservice',151,20,'0000-00-00','2007-04-26 17:36:00',NULL,'tep_cfg_email_option('),
  (1413,'Cash  Except Payment Country','MODULE_PAYMENT_CASH_EXCEPT_COUNTRY','','If countries are selected, disable this payment method for that countries.',6,4,'0000-00-00','2007-04-26 17:36:01','tep_get_zone_except_country','tep_cfg_pull_down_zone_except_countries(MODULE_PAYMENT_CASH_ZONE,'),
  (1414,'Cash  Except Payment Zone','MODULE_PAYMENT_CASH_EXCEPT_ZONE','','If a zone is selected, disable this payment method for that zone.',6,5,'0000-00-00','2007-04-26 17:36:01','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1415,'Money Order  Except Payment Country','MODULE_PAYMENT_MONEYORDER_EXCEPT_COUNTRY','','If countries are selected, disable this payment method for that countries.',6,4,'0000-00-00','2007-04-26 17:36:01','tep_get_zone_except_country','tep_cfg_pull_down_zone_except_countries(MODULE_PAYMENT_MONEYORDER_ZONE,'),
  (1416,'Money Order  Except Payment Zone','MODULE_PAYMENT_MONEYORDER_EXCEPT_ZONE','','If a zone is selected, disable this payment method for that zone.',6,6,'0000-00-00','2007-04-26 17:36:01','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1419,'Except Payment Country','MODULE_PAYMENT_DRESDNERBANK_EXCEPT_COUNTRY','','If countries are selected, disable this payment method for that countries.',6,4,'0000-00-00','2007-04-26 17:36:01','tep_get_zone_except_country','tep_cfg_pull_down_zone_except_countries(MODULE_PAYMENT_DRESDNERBANK_ZONE,'),
  (1420,'Except Payment Zone','MODULE_PAYMENT_DRESDNERBANK_EXCEPT_ZONE','','If a zone is selected, disable this payment method for that zone.',6,3,'0000-00-00','2007-04-26 17:36:01','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1421,'Wallet Except Payment Country','MODULE_PAYMENT_WALLET_EXCEPT_COUNTRY','','If countries are selected, disable this payment method for that countries.',6,4,'0000-00-00','2007-04-26 17:36:01','tep_get_zone_except_country','tep_cfg_pull_down_zone_except_countries(MODULE_PAYMENT_WALLET_ZONE,'),
  (1422,'Wallet Except Payment Zone','MODULE_PAYMENT_WALLET_EXCEPT_ZONE','','If a zone is selected, disable this payment method for that zone.',6,5,'0000-00-00','2007-04-26 17:36:01','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1423,'Shipping Zone','MODULE_SHIPPING_AUSPOST_AIR_ZONE','2','If a zone is selected, disable this shipping method for that zone.',6,3,'0000-00-00','2007-04-26 17:36:01','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1426,'Except Shipping Country','MODULE_SHIPPING_AUSPOST_AIR_EXCEPT_COUNTRY','','If countries are selected, disable this shipping method for that countries.',6,4,'0000-00-00','2007-04-26 17:36:01','tep_get_zone_except_country','tep_cfg_pull_down_zone_except_countries(MODULE_SHIPPING_AUSPOST_AIR_ZONE,'),
  (1427,'Except Shipping Zone','MODULE_SHIPPING_AUSPOST_AIR_EXCEPT_ZONE','3','If a zone is selected, disable this shipping method for that zone.',6,3,'0000-00-00','2007-04-26 17:36:01','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1428,'Except Shipping Country','MODULE_SHIPPING_AUSPOST_ECONOMY_EXCEPT_COUNTRY','','If countries are selected, disable this shipping method for that countries.',6,4,'0000-00-00','2007-04-26 17:36:02','tep_get_zone_except_country','tep_cfg_pull_down_zone_except_countries(MODULE_SHIPPING_AUSPOST_ECONOMY_ZONE,'),
  (1429,'Except Shipping Zone','MODULE_SHIPPING_AUSPOST_ECONOMY_EXCEPT_ZONE','3','If a zone is selected, disable this shipping method for that zone.',6,3,'0000-00-00','2007-04-26 17:36:02','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1430,'Except Shipping Country','MODULE_SHIPPING_AUSPOST_EXPRESS_EXCEPT_COUNTRY','','If countries are selected, disable this shipping method for that countries.',6,4,'0000-00-00','2007-04-26 17:36:02','tep_get_zone_except_country','tep_cfg_pull_down_zone_except_countries(MODULE_SHIPPING_AUSPOST_EXPRESS_ZONE,'),
  (1431,'Except Shipping Zone','MODULE_SHIPPING_AUSPOST_EXPRESS_EXCEPT_ZONE','','If a zone is selected, disable this shipping method for that zone.',6,3,'0000-00-00','2007-04-26 17:36:02','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1432,'Except Shipping Country','MODULE_SHIPPING_AUSPOST_SEA_EXCEPT_COUNTRY','','If countries are selected, disable this shipping method for that countries.',6,4,'0000-00-00','2007-04-26 17:36:02','tep_get_zone_except_country','tep_cfg_pull_down_zone_except_countries(MODULE_SHIPPING_AUSPOST_SEA_ZONE,'),
  (1433,'Except Shipping Zone','MODULE_SHIPPING_AUSPOST_SEA_EXCEPT_ZONE','3','If a zone is selected, disable this shipping method for that zone.',6,3,'0000-00-00','2007-04-26 17:36:02','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1434,'Except Payment Country','MODULE_PAYMENT_VIRTUALPAY_EXCEPT_COUNTRY','','If countries are selected, disable this payment method for that countries.',6,4,'0000-00-00','2007-04-26 17:36:02','tep_get_zone_except_country','tep_cfg_pull_down_zone_except_countries(MODULE_PAYMENT_VIRTUALPAY_ZONE,'),
  (1435,'Except Payment Zone','MODULE_PAYMENT_VIRTUALPAY_EXCEPT_ZONE','','If a zone is selected, disable this payment method for that zone.',6,3,'0000-00-00','2007-04-26 17:36:02','tep_get_zone_class_title','tep_cfg_pull_down_zone_classes('),
  (1436,'Hide the Customer Occupation in the Front End','HIDE_CUSTOMER_OCCUPATION_FRONT','true','Hide the customer occupation in the front end in customer details page',904,23,'0000-00-00','2007-04-26 17:36:02',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1437,'Hide the Customer Occupation in the Back End','HIDE_CUSTOMER_OCCUPATION_BACK','true','Hide the customer occupation in the back end in customer details page',904,24,'0000-00-00','2007-04-26 17:36:02',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1438,'Hide the Customer Interest in the Front End','HIDE_CUSTOMER_INTEREST_FRONT','true','Hide the customer interest in the front end in customer details page',904,20,'0000-00-00','2007-04-26 17:36:02',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1439,'Hide the Customer Interest in the Back End','HIDE_CUSTOMER_INTEREST_BACK','true','Hide the customer interest in the back end in customer details page',904,23,'0000-00-00','2007-04-26 17:36:02',NULL,'tep_cfg_select_option(array(''true'', ''false''),'),
  (1440,'Telephone','ACCOUNT_TELEPHONE','true','Display Telephone in the customers account',5,5,'0000-00-00','2007-04-26 17:36:02',NULL,'tep_cfg_select_option(array(''true'',''false''),'),
  (1444,'Packaging Surcharge','PRODUCT_PACKAGING_SURCHARGE','','Packaging surcharge for products ($)',7,0,'0000-00-00','2007-04-26 17:36:04',NULL,NULL),
  (1445,'Packaging Cost','PRODUCT_PACKAGING_COST','','Packaging cost for products (%)',7,0,'0000-00-00','2007-04-26 17:36:04',NULL,NULL),
  (2160,'Hide Featured Product id','HIDE_FEATURED_PRODUCT_ID','No','Do you want to Hide the Featured Product id on Front End?.',150,1,'0000-00-00','2007-04-26 17:36:06','','tep_cfg_select_option(array(''Yes'', ''No''),'),
  (2161,'BackOrder-Rule','PRODUCT_FULFILLER','PARTIALSHIP','Defines action in response to an out-of-stock sit',8,11,'0000-00-00','2007-04-26 17:36:09',NULL,'tep_cfg_pull_down_prod_view('),
  (2162,'set Page Conversion code','GENERAL_CONVERSION','True','Do you want to display page conversion code in Front End?',907,907,'0000-00-00','2007-04-26 17:36:09',NULL,'tep_cfg_select_option(array(''True'',''False''),'),
  (2163,'Shop Index Page Conversion code','SHOP_INDEX_PAGE_CONV','<!-- Add Your Google Conversion Code here --> ','Set conversion code to  Shop Index  page',907,907,'0000-00-00','2007-04-26 17:36:09',NULL,'tep_cfg_textarea('),
  (2164,'Product Category Page Conversion code','PRODUCT_CATEGORY_PAGE_CONV','<!-- Add Your Google Conversion Code here -->','Set conversion code to  Product Category page',907,907,'0000-00-00','2007-04-26 17:36:09',NULL,'tep_cfg_textarea('),
  (2165,'Product Page Conversion code','PRODUCT_PAGE_CONV','<!-- Add Your Google Conversion Code here -->','Set conversion code to  Product  page',907,907,'0000-00-00','2007-04-26 17:36:09',NULL,'tep_cfg_textarea('),
  (2166,'Checkout Success Page Conversion code','CHECKOUT_SUCCESS_PAGE_CONV','<!-- Add Your Google Conversion Code here -->','Set conversion code to Checkout Success  page',907,907,'0000-00-00','2007-04-26 17:36:09',NULL,'tep_cfg_textarea('),
  (2167,'Display Handling Charges','DISPLAY_HANDLING_CHARGE','False','Display handling charge in shipping cost',7,0,'0000-00-00','2007-04-26 17:36:10',NULL,'tep_cfg_select_option(array(''True'', ''False''), '),
  (2169,'Define Mainpage type','DEFINEPAGE_TYPE','Default','Display the mainpage',0,15,'0000-00-00','2007-04-26 17:36:10',NULL,NULL),
  (2170,'Checkout Failure retries','CHECKOUT_FAIL_RETRY','3','Number of allowable retries during checkout failure',2,1,'0000-00-00','2007-04-26 17:36:11',NULL,NULL),
  (2171,'SKU length','SKU_LENGTH','false','Enable SKU',907,7,'0000-00-00','2007-04-26 17:36:11','NULL','tep_cfg_select_option(array(''true'', ''false''),'),
  (2172,'Weight Unit','SHOP_WEIGHT_UNIT','KG','Shop Weight Unit used',7,0,'0000-00-00','2007-04-26 17:36:11','tep_cfg_pull_down_shop_weight_unit_title','tep_cfg_pull_down_shop_weight_unit('),
  (2173,'Encryption style','ENCRYPTION_STYLE','O','Encryption style used in password storage and checking',151,100,'0000-00-00','2007-04-26 17:36:33','tep_get_encryption_name','tep_cfg_pull_down_encryption_type('),
  (2174,'Resource Description','RESOURCE_DESCRIPTION','0','Show the Resource Description',915,10,'0000-00-00','2007-04-26 17:36:35','NULL','tep_cfg_resource_description('),
  (2175,'Calender Style','SERVICES_CALENDAR_STYLE','month','Calender Style in Browse services',915,7,'0000-00-00','2007-04-26 17:36:35',NULL,'tep_cfg_pull_down_service_calendar_style('),
  (2176,'Edit Delete Resource Choice','RESOURCE_ACTIVATE','1','Show the Available Resource in Search Results',915,8,'0000-00-00','2007-04-26 17:36:35',NULL,'tep_cfg_resource_option('),
  (2177,'Edit Delete Resource Name','RESOURCE_NAME','0','Show the Resource Name',915,9,'0000-00-00','2007-04-26 17:36:35',NULL,'tep_cfg_resource_name('),
  (2178,'Show Calender','SERVICES_SHOW_CALENDER','true','Do u want to show the Calender in front-end?',915,6,'0000-00-00','2007-04-26 17:36:35','','tep_cfg_select_option(array(''true'', ''false''),'),
  (2179,'Encryption Hash','ENCRYPTION_HASH_VALUE','@sC@mmRes','Encryption Hash Value applied in cookies for storage of password',2,100,'0000-00-00','2007-04-26 17:36:35','',''),
  (2180,'Display Review','DISPLAY_REVIEW','YN','Display Admin review or Customer review or Both?',0,2,'0000-00-00','2007-04-26 17:36:38',NULL,NULL),
  (2181,'Enable Buffer Booking','SERVICES_BUFFER_BOOKING','true','Show the booking buffer in service page',915,6,'0000-00-00','2007-04-26 17:36:38','','tep_cfg_select_option(array(''true'', ''false''),'),
  (2182,'What you want to Sell','SHOP_SELL_ITEMS','PESV','Items Sold in the shop',1,101,'2007-04-27 08:22:22','0000-00-00','tep_cfg_select_option_title','tep_cfg_select_multioption(array(''P'',''E'',''S'',''V''),'),
  (2184,'My Account on Login','MY_ACCOUNT_LOGIN','false','To set the Customer to view their MyAccount page directly.',2,1,'2007-06-14 06:57:23','0000-00-00','','tep_cfg_select_option(array(''true'',''false''),'),
  (2183,'Number of SKU Characters','SKU_COUNT','13','Total Length of characters for SKU',907,0,'0000-00-00','2007-04-26 17:36:39',NULL,'tep_cfg_sku_length_count_option('),
  (NULL,'Display Name', 'MODULE_PAYMENT_MONEYORDER_DISPLAY_NAME', 'Cheque/Money Order', 'Set the Display name to payment module', '6', '8','0000-00-00',now(),NULL,NULL),
  (NULL,'Image', 'MODULE_PAYMENT_MONEYORDER_IMAGE', 'moneyorder', 'Set the Image of payment module', '6', '9','0000-00-00',now(),NULL, 'tep_cfg_file_field('),
  (NULL,'Display Name', 'MODULE_PAYMENT_CASH_DISPLAY_NAME', 'Cash', 'Set the Display name to payment module', '6', '7','0000-00-00',now(),NULL,NULL),
  (NULL,'Image', 'MODULE_PAYMENT_CASH_IMAGE', 'cash', 'Set the Image of payment module', '6', '8','0000-00-00',now(),NULL, 'tep_cfg_file_field('),
  (NULL,'Display Name', 'MODULE_PAYMENT_VIRTUALPAY_DISPLAY_NAME', 'VirtualPay', 'Set the Display name to payment module', '6', '9','0000-00-00', now(),NULL,NULL),
  (NULL,'Image', 'MODULE_PAYMENT_VIRTUALPAY_IMAGE', 'virtualpay', 'Set the Image of payment module', '6', '10','0000-00-00',now(),NULL, 'tep_cfg_file_field('),
  (NULL,'Display Name', 'MODULE_PAYMENT_DRESDNERBANK_DISPLAY_NAME', 'Bank Transfer Payment', 'Set the Display name to payment module', '6', '11','0000-00-00',now(),NULL,NULL),
  (NULL,'Image', 'MODULE_PAYMENT_DRESDNERBANK_IMAGE', 'dresdnerbank', 'Set the Image of payment module', '6', '12','0000-00-00',now(),NULL, 'tep_cfg_file_field('),
  (NULL,'Display Name', 'MODULE_PAYMENT_WALLET_DISPLAY_NAME', 'Wallet Payment', 'Set the Display name to payment module', '6', '7','0000-00-00',now(),NULL,NULL),
  (NULL,'Image', 'MODULE_PAYMENT_WALLET_IMAGE', 'wallet', 'Set the Image of payment module', '6', '8','0000-00-00',now(),NULL, 'tep_cfg_file_field(');
    
#
# Data for the `configuration_group` table  
#

INSERT INTO `configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`,`configuration_access_key`) VALUES 
  (1,'My Store','General information about my store',1,1,'Shop Settings General'),
  (2,'Values','The minimum values for functions / data',2,1,'Shop Settings Advanced Max/Min Values'),
  (4,'Images','Image parameters',4,1,'Shop Settings Images'),
  (5,'Customer Details','Customer account configuration',5,1,'Customers Advanced'),
  (6,'Module Options','Hidden from configuration',6,1,''),
  (7,'Shipping/Packaging','Shipping options available at my store',7,1,'Products Shipping Options'),
  (8,'Product Listing','Product Listing    configuration options',8,1,'Products Advanced Listing'),
  (9,'Stock','Stock configuration options',9,1,'Products Advanced Stock'),
  (10,'Logging','Logging configuration options',10,1,'Shop Settings Advanced Logging'),
  (12,'E-Mail Options','General setting for E-Mail transport and HTML E-Mails',12,1,'Marketing eMarketing Advanced'),
  (13,'Download','Downloadable products options',13,1,'Shop Settings Advanced Download'),
  (14,'GZip Compression','GZip compression options',14,1,'Products Advanced GZip Compression'),
  (15,'Sessions','Session options',15,1,'Shop Settings Advanced Sessions'),
  (16,'Site Maintenance','Site Maintenance Options',16,1,'Shop Settings Emergency Processes'),
  (17,'Site Maintenance','Site Maintenance Options',17,1,'shop settings emergency processes site maintenance wizard'),
  (18,'Site Maintenance','Site Maintenance Options',18,1,'shop settings emergency processes emergency support'),
  (99,'Dynamic MoPics','The options which configure Dynamic MoPics.',99,1,'Shop Settings Images Advanced'),
  (112,'HtmlArea','HTMLArea 1.7 Options',15,1,'Shop Settings Advanced HtmlArea'),
  (900,'Affiliate Program','Options for the Affiliate Program',50,1,'Marketing Affiliates Advanced'),
  (150,'Product Advanced','Product Listing Options',16,1,'Products Advanced'),
  (151,'My Store Advanced','Advanced Information about store',17,1,'Shop Settings Advanced'),
  (152,'Tax Options','Tax Decimal places and display',18,1,'Payment Tax'),
  (153,'Payment Options','General Payment options',16,1,'Payment General'),
  (154,'Marketing Options','General Marketing options',17,1,'Marketing Options'),
  (901,'Events','Events settings',17,1,'Events Advanced'),
  (902,'Wallet','Payment_process',19,1,'Payment Advanced Wallet'),
  (903,'SMS','SMS Messaging',10,1,'Marketing SMS Marketing Advanced'),
  (904,'Surveys','Survey Options',13,1,'Marketing Surveys'),
  (905,'Orders','Orders Options',14,1,'Products Advanced Orders'),
  (906,'Reports','Report Options',15,1,'Shop Settings Advanced Reports'),
  (915,'Events','Events Options',6,1,'Events Options');


#
# Data for the `countries` table  
#

INSERT INTO `countries` (`countries_id`, `countries_name`, `countries_iso_code_2`, `countries_iso_code_3`, `address_format_id`, `country_code`) VALUES 
  (1,'Afghanistan','AF','AFG',1,93),
  (2,'Albania','AL','ALB',1,355),
  (3,'Algeria','DZ','DZA',1,213),
  (4,'American Samoa','AS','ASM',1,684),
  (5,'Andorra','AD','AND',1,376),
  (6,'Angola','AO','AGO',1,244),
  (7,'Anguilla','AI','AIA',1,1264),
  (8,'Antarctica','AQ','ATA',1,67212),
  (9,'Antigua and Barbuda','AG','ATG',1,268),
  (10,'Argentina','AR','ARG',1,54),
  (11,'Armenia','AM','ARM',1,374),
  (12,'Aruba','AW','ABW',1,297),
  (13,'Australia','AU','AUS',1,61),
  (14,'Austria','AT','AUT',5,43),
  (15,'Azerbaijan','AZ','AZE',1,994),
  (16,'Bahamas','BS','BHS',1,1242),
  (17,'Bahrain','BH','BHR',1,973),
  (18,'Bangladesh','BD','BGD',1,880),
  (19,'Barbados','BB','BRB',1,1246),
  (20,'Belarus','BY','BLR',1,375),
  (21,'Belgium','BE','BEL',1,32),
  (22,'Belize','BZ','BLZ',1,501),
  (23,'Benin','BJ','BEN',1,229),
  (24,'Bermuda','BM','BMU',1,1441),
  (25,'Bhutan','BT','BTN',1,975),
  (26,'Bolivia','BO','BOL',1,591),
  (27,'Bosnia and Herzegowina','BA','BIH',1,387),
  (28,'Botswana','BW','BWA',1,267),
  (29,'Bouvet Island','BV','BVT',1,0),
  (30,'Brazil','BR','BRA',1,55),
  (31,'British Indian Ocean Territory','IO','IOT',1,1284),
  (32,'Brunei Darussalam','BN','BRN',1,673),
  (33,'Bulgaria','BG','BGR',1,359),
  (34,'Burkina Faso','BF','BFA',1,226),
  (35,'Burundi','BI','BDI',1,257),
  (36,'Cambodia','KH','KHM',1,855),
  (37,'Cameroon','CM','CMR',1,237),
  (38,'Canada','CA','CAN',1,1),
  (39,'Cape Verde','CV','CPV',1,238),
  (40,'Cayman Islands','KY','CYM',1,1345),
  (41,'Central African Republic','CF','CAF',1,236),
  (42,'Chad','TD','TCD',1,235),
  (43,'Chile','CL','CHL',1,56),
  (44,'China','CN','CHN',1,86),
  (45,'Christmas Island','CX','CXR',1,6724),
  (46,'Cocos (Keeling) Islands','CC','CCK',1,6722),
  (47,'Colombia','CO','COL',1,57),
  (48,'Comoros','KM','COM',1,269),
  (49,'Congo','CG','COG',1,243),
  (50,'Cook Islands','CK','COK',1,682),
  (51,'Costa Rica','CR','CRI',1,506),
  (52,'Cote D''Ivoire','CI','CIV',1,225),
  (53,'Croatia','HR','HRV',1,385),
  (54,'Cuba','CU','CUB',1,53),
  (55,'Cyprus','CY','CYP',1,357),
  (56,'Czech Republic','CZ','CZE',1,420),
  (57,'Denmark','DK','DNK',1,45),
  (58,'Djibouti','DJ','DJI',1,253),
  (59,'Dominica','DM','DMA',1,1767),
  (60,'Dominican Republic','DO','DOM',1,1809),
  (61,'East Timor','TP','TMP',1,670),
  (62,'Ecuador','EC','ECU',1,593),
  (63,'Egypt','EG','EGY',1,20),
  (64,'El Salvador','SV','SLV',1,503),
  (65,'Equatorial Guinea','GQ','GNQ',1,240),
  (66,'Eritrea','ER','ERI',1,291),
  (67,'Estonia','EE','EST',1,372),
  (68,'Ethiopia','ET','ETH',1,251),
  (69,'Falkland Islands (Malvinas)','FK','FLK',1,500),
  (70,'Faroe Islands','FO','FRO',1,298),
  (71,'Fiji','FJ','FJI',1,679),
  (72,'Finland','FI','FIN',1,358),
  (73,'France','FR','FRA',1,33),
  (74,'France  Metropolitan','FX','FXX',1,0),
  (75,'French Guiana','GF','GUF',1,594),
  (76,'French Polynesia','PF','PYF',1,689),
  (77,'French Southern Territories','TF','ATF',1,596),
  (78,'Gabon','GA','GAB',1,241),
  (79,'Gambia','GM','GMB',1,220),
  (80,'Georgia','GE','GEO',1,995),
  (81,'Germany','DE','DEU',5,49),
  (82,'Ghana','GH','GHA',1,233),
  (83,'Gibraltar','GI','GIB',1,350),
  (84,'Greece','GR','GRC',1,30),
  (85,'Greenland','GL','GRL',1,299),
  (86,'Grenada','GD','GRD',1,1473),
  (87,'Guadeloupe','GP','GLP',1,590),
  (88,'Guam','GU','GUM',1,1671),
  (89,'Guatemala','GT','GTM',1,502),
  (90,'Guinea','GN','GIN',1,224),
  (91,'Guinea-bissau','GW','GNB',1,245),
  (92,'Guyana','GY','GUY',1,592),
  (93,'Haiti','HT','HTI',1,509),
  (94,'Heard and Mc Donald Islands','HM','HMD',1,0),
  (95,'Honduras','HN','HND',1,504),
  (96,'Hong Kong','HK','HKG',1,852),
  (97,'Hungary','HU','HUN',1,36),
  (98,'Iceland','IS','ISL',1,354),
  (99,'India','IN','IND',1,91),
  (100,'Indonesia','ID','IDN',1,62),
  (101,'Iran (Islamic Republic of)','IR','IRN',1,98),
  (102,'Iraq','IQ','IRQ',1,964),
  (103,'Ireland','IE','IRL',1,353),
  (104,'Israel','IL','ISR',1,972),
  (105,'Italy','IT','ITA',1,39),
  (106,'Jamaica','JM','JAM',1,1876),
  (107,'Japan','JP','JPN',1,81),
  (108,'Jordan','JO','JOR',1,962),
  (109,'Kazakhstan','KZ','KAZ',1,7),
  (110,'Kenya','KE','KEN',1,254),
  (111,'Kiribati','KI','KIR',1,686),
  (112,'Korea Democratic People''s Republic of','KP','PRK',1,850),
  (113,'Korea Republic of','KR','KOR',1,82),
  (114,'Kuwait','KW','KWT',1,965),
  (115,'Kyrgyzstan','KG','KGZ',1,7),
  (116,'Lao People''s Democratic Republic','LA','LAO',1,856),
  (117,'Latvia','LV','LVA',1,371),
  (118,'Lebanon','LB','LBN',1,961),
  (119,'Lesotho','LS','LSO',1,266),
  (120,'Liberia','LR','LBR',1,231),
  (121,'Libyan Arab Jamahiriya','LY','LBY',1,218),
  (122,'Liechtenstein','LI','LIE',1,423),
  (123,'Lithuania','LT','LTU',1,370),
  (124,'Luxembourg','LU','LUX',1,352),
  (125,'Macau','MO','MAC',1,853),
  (126,'Macedonia  The Former Yugoslav Republic of','MK','MKD',1,389),
  (127,'Madagascar','MG','MDG',1,261),
  (128,'Malawi','MW','MWI',1,265),
  (129,'Malaysia','MY','MYS',1,60),
  (130,'Maldives','MV','MDV',1,960),
  (131,'Mali','ML','MLI',1,223),
  (132,'Malta','MT','MLT',1,356),
  (133,'Marshall Islands','MH','MHL',1,692),
  (134,'Martinique','MQ','MTQ',1,596),
  (135,'Mauritania','MR','MRT',1,222),
  (136,'Mauritius','MU','MUS',1,230),
  (137,'Mayotte','YT','MYT',1,269),
  (138,'Mexico','MX','MEX',1,52),
  (139,'Micronesia Federated States of','FM','FSM',1,691),
  (140,'Moldova Republic of','MD','MDA',1,373),
  (141,'Monaco','MC','MCO',1,377),
  (142,'Mongolia','MN','MNG',1,976),
  (143,'Montserrat','MS','MSR',1,1664),
  (144,'Morocco','MA','MAR',1,212),
  (145,'Mozambique','MZ','MOZ',1,258),
  (146,'Myanmar','MM','MMR',1,95),
  (147,'Namibia','NA','NAM',1,264),
  (148,'Nauru','NR','NRU',1,674),
  (149,'Nepal','NP','NPL',1,977),
  (150,'Netherlands','NL','NLD',1,31),
  (151,'Netherlands Antilles','AN','ANT',1,599),
  (152,'New Caledonia','NC','NCL',1,687),
  (153,'New Zealand','NZ','NZL',1,64),
  (154,'Nicaragua','NI','NIC',1,505),
  (155,'Niger','NE','NER',1,227),
  (156,'Nigeria','NG','NGA',1,234),
  (157,'Niue','NU','NIU',1,683),
  (158,'Norfolk Island','NF','NFK',1,672),
  (159,'Northern Mariana Islands','MP','MNP',1,1670),
  (160,'Norway','NO','NOR',1,47),
  (161,'Oman','OM','OMN',1,968),
  (162,'Pakistan','PK','PAK',1,92),
  (163,'Palau','PW','PLW',1,680),
  (164,'Panama','PA','PAN',1,507),
  (165,'Papua New Guinea','PG','PNG',1,675),
  (166,'Paraguay','PY','PRY',1,595),
  (167,'Peru','PE','PER',1,51),
  (168,'Philippines','PH','PHL',1,63),
  (169,'Pitcairn','PN','PCN',1,872),
  (170,'Poland','PL','POL',1,48),
  (171,'Portugal','PT','PRT',1,351),
  (172,'Puerto Rico','PR','PRI',1,787),
  (173,'Qatar','QA','QAT',1,974),
  (174,'Reunion','RE','REU',1,262),
  (175,'Romania','RO','ROM',1,40),
  (176,'Russian Federation','RU','RUS',1,7),
  (177,'Rwanda','RW','RWA',1,250),
  (178,'Saint Kitts and Nevis','KN','KNA',1,1869),
  (179,'Saint Lucia','LC','LCA',1,1758),
  (180,'Saint Vincent and the Grenadines','VC','VCT',1,1784),
  (181,'Samoa','WS','WSM',1,685),
  (182,'San Marino','SM','SMR',1,378),
  (183,'Sao Tome and Principe','ST','STP',1,239),
  (184,'Saudi Arabia','SA','SAU',1,966),
  (185,'Serbia and Montenegro','CS','SCG',1,381),
  (186,'Seychelles','SC','SYC',1,248),
  (187,'Sierra Leone','SL','SLE',1,232),
  (188,'Singapore','SG','SGP',4,65),
  (189,'Slovakia (Slovak Republic)','SK','SVK',1,421),
  (190,'Slovenia','SI','SVN',1,386),
  (191,'Solomon Islands','SB','SLB',1,677),
  (192,'Somalia','SO','SOM',1,252),
  (193,'South Africa','ZA','ZAF',1,27),
  (194,'South Georgia and the South Sandwich Islands','GS','SGS',1,0),
  (195,'Spain','ES','ESP',3,34),
  (196,'Sri Lanka','LK','LKA',1,94),
  (197,'St. Helena','SH','SHN',1,290),
  (198,'St. Pierre and Miquelon','PM','SPM',1,508),
  (199,'Sudan','SD','SDN',1,249),
  (200,'Suriname','SR','SUR',1,597),
  (201,'Svalbard and Jan Mayen Islands','SJ','SJM',1,47),
  (202,'Swaziland','SZ','SWZ',1,268),
  (203,'Sweden','SE','SWE',1,46),
  (204,'Switzerland','CH','CHE',1,41),
  (205,'Syrian Arab Republic','SY','SYR',1,963),
  (206,'Taiwan','TW','TWN',1,886),
  (207,'Tajikistan','TJ','TJK',1,7),
  (208,'Tanzania United Republic of','TZ','TZA',1,255),
  (209,'Thailand','TH','THA',1,66),
  (210,'Togo','TG','TGO',1,228),
  (211,'Tokelau','TK','TKL',1,690),
  (212,'Tonga','TO','TON',1,676),
  (213,'Trinidad and Tobago','TT','TTO',1,1868),
  (214,'Tunisia','TN','TUN',1,216),
  (215,'Turkey','TR','TUR',1,90),
  (216,'Turkmenistan','TM','TKM',1,993),
  (217,'Turks and Caicos Islands','TC','TCA',1,1649),
  (218,'Tuvalu','TV','TUV',1,688),
  (219,'Uganda','UG','UGA',1,256),
  (220,'Ukraine','UA','UKR',1,380),
  (221,'United Arab Emirates','AE','ARE',1,971),
  (222,'United Kingdom','GB','GBR',1,44),
  (223,'United States','US','USA',2,1),
  (224,'United States Minor Outlying Islands','UM','UMI',1,0),
  (225,'Uruguay','UY','URY',1,598),
  (226,'Uzbekistan','UZ','UZB',1,7),
  (227,'Vanuatu','VU','VUT',1,678),
  (228,'Vatican City State (Holy See)','VA','VAT',1,39),
  (229,'Venezuela','VE','VEN',1,58),
  (230,'Viet Nam','VN','VNM',1,84),
  (231,'Virgin Islands (British)','VG','VGB',1,284),
  (232,'Virgin Islands (U.S.)','VI','VIR',1,340),
  (233,'Wallis and Futuna Islands','WF','WLF',1,681),
  (234,'Western Sahara','EH','ESH',1,685),
  (235,'Yemen','YE','YEM',1,967),
  (236,'Yugoslavia','YU','YUG',1,381),
  (237,'Zaire','ZR','ZAR',1,243),
  (238,'Zambia','ZM','ZMB',1,260),
  (239,'Zimbabwe','ZW','ZWE',1,263),
  (240,'Congo -Democractic Republic','CD','COD',1,242),
  (241,'Senegal','SN','SEN',1,221);

#
# Data for the `currencies` table  
#

INSERT INTO `currencies` (`currencies_id`, `title`, `code`, `symbol_left`, `symbol_right`, `decimal_point`, `thousands_point`, `decimal_places`, `value`, `last_updated`) VALUES 
  (6,'Australian Dollar','AUD','$','','.',',','2',1,'2005-08-09 20:37:20'),
  (7,'United States Dollar','USD','$','','.',',','2',0.76130003,'2005-08-09 20:37:20'),
  (8,'Euro','EUR','€','','.',',','2',0.61559999,'2005-08-09 20:37:20'),
  (9,'UK Pound','GBP','£','','.',',','2',0.42609999,'2005-08-09 20:37:20');

#
# Data for the `customers` table  
#

INSERT INTO `customers` (`customers_id`, `customers_gender`, `customers_firstname`, `customers_lastname`, `customers_dob`, `customers_email_address`, `customers_default_address_id`, `customers_telephone`, `customers_fax`, `customers_password`, `customers_newsletter`, `customers_selected_template`, `customers_second_email_address`, `customers_second_telephone`, `customers_reserve_newsletter`, `customers_subscription_newsletter`, `customers_type`, `idcards_printed`, `customers_discount`, `customers_groups_id`, `customers_username`, `customers_occupation`, `customers_interest`, `encryption_style`, `admin_groups_id`, `resume_from`, `suspend_from`, `is_blocked`) VALUES 
  (1,'m','freeway','test','1985-05-25','test001@openfreeway.org',1,'489534893','','89aa6250bb453142e1e1f0de460dc7e0:17','1','','','','0','0','D','N',0,1,'test001',0,0,'O',0,'0000-00-00','0000-00-00','N');

#
# Data for the `customers_groups` table  
#

INSERT INTO `customers_groups` (`customers_groups_id`, `customers_groups_name`, `customers_groups_discount`) VALUES 
  (1,'Default',0),
  (2,'WholeSale',-20);

#
# Data for the `customers_info` table  
#

INSERT INTO `customers_info` (`customers_info_id`, `customers_info_date_of_last_logon`, `customers_info_number_of_logons`, `customers_info_date_account_created`, `customers_info_date_account_last_modified`, `global_product_notifications`, `customers_info_source_id`) VALUES 
  (1,'0000-00-00',0,'2007-04-26 17:35:25','0000-00-00',0,0);

#
# Data for the `email_messages` table  
#

INSERT INTO `email_messages` (`message_id`, `message_send`, `message_subject`, `message_reply_to`, `message_text`, `message_format`, `message_type`) VALUES 
  (1,'','Freeway Registration Confirmation','shop@freeway.com','Dear %%First_Name%%,\r\n\r\nWelcome to %%Store_Name%%.\r\n\r\nYour details are as follows:\r\n\r\nUsername: %%Login_Email%%\r\nPassword: %%Login_Password%%\r\n\r\nPlease use this link: %%Admin_Link%%\r\n\r\nWith thanks,\r\n\r\n%%Store_Owner%%','T','AUT'),
  (2,'','Freeway Account Confirmation','shop@freeway.com','<P>Dear %%First_Name%%,</P>\r\n<P>Your %%Store_Name%% account has been created. You can now take part in the <BR>various services we have to offer you. Some of these services include: </P>\r\n<P>Integrated Online shop and Event Reservations<BR>SMS event reminders</P>\r\n<P>The details of your account are as follows:</P>\r\n<P>Username: %%Login_Email%%</P>\r\n<P>Password: %%Login_Password%%</P>\r\n<P>For help with any of our online services, please email the <BR>store-owner: %%Store_Email%% </P>\r\n<P>With thanks,</P>\r\n<P>%%Store_Owner%% </P>\r\n<P>Note: This email address was given to us by one of our customers. If you did not signup to be a member, please send an email to %%Store_Email%%. </P>','B','CUS'),
  (3,'','Freeway Password','shop@freeway.com','Dear %%First_Name%%,\r\n\r\nYour %%Store_Name%% account details are as follows:\r\n\r\nUsername: %%Store_Email%%\r\nPassword: %%Login_Password%%\r\n\r\nThe link to the admin section is:\r\n\r\n%%Admin_Link%%\r\n\r\nIf you have trouble accessing your account, please contact us at:\r\n\r\n%%Store_Email%%\r\n\r\nWith thanks,\r\n\r\n%%Store_Owner%%','T','AUR'),
  (4,'','Freeway Account Details','shop@freeway.com','Dear %%First_Name%%,\r\nYour %%Store_Name%% account details are as follows:\r\nUsername: %%Login_Email%%\r\nPassword: %%Login_Password%%\r\n If you have trouble accessing your account, please contact us at: %%Store_Email%%\r\nWith thanks, \r\n%%Store_Owner%%','T','CUR'),
  (5,'','Freeway Update','shop@freeway.com','<html>\r\n<head>\r\n<style>\r\n\t.totalText{\r\n\t\tbackground:#FF7300;\r\n\t\tcolor:#00000;\r\n\t}\r\n\t.link a,a:hover {\r\n\t\tfont-family:Arial, Helvetica, sans-serif;\r\n\t\tfont-size:13px;\r\n\t\tcolor:#3966B1;\r\n\t\tfont-weight:bold;\r\n\t\ttext-decoration:none;\r\n\t}\r\n\t.textMain {\r\n\t\tfont-family: Arial, Helvetica, sans-serif;\r\n\t\tfont-size:12px;\r\n\t\tcolor:#000000;\r\n\t}\r\n\t.main {\r\n\t\tfont-family: Arial, Helvetica, sans-serif;\r\n\t\tfont-size:12px;\r\n\t\tcolor:#000000;\r\n\t}\r\n\t.textMainBold {\r\n\t\tfont-family: Arial, Helvetica, sans-serif;\r\n\t\tfont-size:12px;\r\n\t\tfont-weight:bold;\r\n\t\tcolor:#000000;\r\n\t}\r\n\t.textMainHead {\r\n\t\tfont-family: Arial, Helvetica, sans-serif;\r\n\t\tfont-size:16px;\r\n\t\tfont-weight:bold;\r\n\t\tcolor:#56398B;\r\n\t}\r\n\t.textTableHead {\r\n\t\tfont-family: Arial, Helvetica, sans-serif;\r\n\t\tfont-size:12px;\r\n\t\tfont-weight:bold;\r\n\t\tcolor:#ffffff;\r\n\t\tbackground: #54388c ;\r\n\t}\r\n\t\r\n\t.textTableSubHead {\r\n\t\tfont-family: Arial, Helvetica, sans-serif;\r\n\t\tfont-size:12px;\r\n\t\tfont-weight:bold;\r\n\t\tcolor:#54388c;\r\n\t}\r\n\t.textTotal {\r\n\t\tfont-family: Arial, Helvetica, sans-serif;\r\n\t\tfont-size:12px;\r\n\t\tfont-weight:bold;\r\n\t\tcolor:#ffffff;\r\n\t\tbackground: #FF7300;\r\n\t}\r\n\t.textTableTotalE {\r\n\t\tfont-family: Arial, Helvetica, sans-serif;\r\n\t\tfont-size:12px;\r\n\t}\r\n\t.textTableTotalO {\r\n\t\tfont-family: Arial, Helvetica, sans-serif;\r\n\t\tfont-size:12px;\r\n\t}\r\n</style>\r\n</head>\r\n<body>\r\n\r\n<table cellpadding=\"20\" cellspacing=\"0\" style=\"border:1px solid #BBBBBB\" align=\"center\">\r\n<tr>\r\n\t<td>\r\n\t<table cellpadding=\"5\" cellspacing=\"10\" width=\"700\" align=\"center\">\r\n\t\t<tr>\r\n\t\t\t<td>\r\n\t\t\t<table border=\"0\" cellpadding=\"0\" width=\"100%\" cellspacing=\"0\">\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td width=\"10\"></td>\r\n\t\t\t\t\t<td>%%Store_Logo%%</td>\r\n\t\t\t\t\t<Td align=\"right\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\"><b><font color=\"#000000\">Order Number: %%Order_Number%%</font></b></font></Td>\r\n\t\t\t\t\t<td width=\"10\"></td>\r\n\t\t\t\t</tr>\r\n\t\t\t</table>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td>\r\n\t\t\t<table cellpadding=\"2\" cellspacing=\"0\" width=\"700\">\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">Dear <b> %%First_Name%%&nbsp;%%Last_Name%%</b>,</font></td>\r\n\t\t\t\t</tr>\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">Thank you for your purchase. The details of your order are below:</font></td>\r\n\t\t\t\t</tr>\r\n\t\t\t</table>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td><table cellpadding=\"2\" cellspacing=\"0\" width=\"700\">\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td align=\"left\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\"><b>%%Date_Purchased%%</b></font></td>\r\n\t\t\t\t\t<td align=\"right\" width=\"500\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">Detailed Invoice : </font><span class=\"link\">%%Order_Link%%</span></font></td>\r\n\t\t\t\t</tr>\r\n\t\t\t</table></td>\t\t\r\n\t\t</tr>\r\n\t\t\r\n\t\t<tr>\r\n\t\t\t<td valign=\"top\" bgcolor=\"#FCF7E4\" style=\"border:1px solid #F5EED1\">\r\n\t\t\t\t<table border=\"0\" cellpadding=\"3\" width=\"100%\" cellspacing=\"0\">\r\n\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t<td bgcolor=\"#3966B1\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#FFFFFF\"><b>Delivery Details</b></font></td>\r\n\t\t\t\t\t</tr>\r\n\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t<td valign=\"top\">\r\n\t\t\t\t\t\t<table border=\"0\" cellpadding=\"3\" width=\"100%\" cellspacing=\"0\">\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td width=\"120\" valign=\"top\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">Address: </font></td>\r\n\t\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">%%Delivery_Name%%<br/>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t%%Delivery_Street_Address%%<br/>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t%%Delivery_City%%<br/>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t%%Delivery_State%%, %%Delivery_Post_Code%%<br/>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t%%Delivery_Country%%<br/>\r\n\t\t\t\t\t\t\t\t\t</font>\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">Phone: </font></td>\r\n\t\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">%%Telephone%%</font></td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">Email: </font></td>\r\n\t\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">%%Email_Address%%</font></td>\r\n\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t</table>\r\n\t\t\t\t\t\t</td>\r\n\t\t\t\t\t</tr>\r\n\t\t\t\t</table>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td valign=\"top\" bgcolor=\"#FCF7E4\" style=\"border:1px solid #F5EED1\">\r\n\t\t\t<table border=\"0\" cellpadding=\"3\" width=\"700\" cellspacing=\"0\">\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td bgcolor=\"#3966B1\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#FFFFFF\"><b>Payment Details</b></font></td>\r\n\t\t\t\t</tr>\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td valign=\"top\">\r\n\t\t\t\t\t<table border=\"0\" cellpadding=\"3\" cellspacing=\"0\">\r\n\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t<td>\r\n\t\t\t\t\t\t\t\t<table cellpadding=\"3 \" cellspacing=\"0\" width=\"335\">\r\n\t\t\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t\t\t<td valign=\"top\" width=\"50\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">Address: </font></td>\r\n\t\t\t\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">%%Billing_Name%%<br/>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t%%Billing_Street_Address%%<br/>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t%%Billing_City%%<br/>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t%%Billing_State%%, %%Billing_Post_Code%%<br/>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t%%Billing_Country%%<br/>\r\n\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t\t</font>\r\n\t\t\t\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">Payment Method: </font></td>\r\n\t\t\t\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">%%Payment_Method%%</font></td>\r\n\t\t\t\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t\t\t</table>\r\n\t\t\t\t\t\t\t</td>\r\n\t\t\t\t\t\t</tr>\t\t\t\r\n\t\t\t\t\t\t\t\t\t\r\n\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"1\" color=\"#000000\">%%Order_Comments%%</font></td>\r\n\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t</table>\r\n\t\t\t\t\t</td>\r\n\t\t\t\t</tr>\r\n\t\t\t</table>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td valign=\"top\" bgcolor=\"#FCF7E4\" style=\"border:1px solid #F5EED1\">\r\n\t\t\t<table border=\"0\" cellpadding=\"3\" width=\"100%\" cellspacing=\"0\">\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td bgcolor=\"#3966B1\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#FFFFFF\"><b>Products</b></font></td>\r\n\t\t\t\t</tr>\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td valign=\"top\">\r\n\t\t\t\t\t\t%%Products_Ordered%%\r\n\t\t\t\t\t</td>\r\n\t\t\t\t</tr>\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td>%%Order_Totals%%</td>\r\n\t\t\t\t</tr>\r\n\t\t\t</table>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr height=\"5\">\r\n\t\t\t<td></td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td>\r\n\t\t\t\t<table cellpadding=\"0\" cellspacing=\"0\" width=\"700\">\r\n\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t<td valign=\"top\" align=\"left\">\r\n\t\t\t\t\t\t<font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">\r\n\t\t\t\t\t\t\t<b>With thanks, </b>\r\n\t\t\t\t\t\t</font>\r\n\t\t\t\t\t\t</td>\r\n\t\t\t\t\t</tr>\r\n\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t<td class=\"link\">%%Store_Link%%</td>\r\n\t\t\t\t\t</tr>\t\t\r\n\t\t\t\t</table>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t</table>\r\n\t</td>\r\n</tr>\r\n</table>\r\n</body>\r\n</html>','B','PRD'),
  (6,'','Freeway Tax Invoice','invoice','<html>\r\n<head>\r\n</head>\r\n<body>\r\n<table cellpadding=\"20\" cellspacing=\"0\" style=\"border:1px solid #BBBBBB\" align=\"center\">\r\n<tr>\r\n\t<td>\r\n\t<table cellpadding=\"5\" cellspacing=\"10\" width=\"700\" align=\"center\">\r\n\t\t<tr>\r\n\t\t\t<td>\r\n\t\t\t<table border=\"0\" cellpadding=\"5\" width=\"100%\" cellspacing=\"0\">\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td width=\"10\"></td>\r\n\t\t\t\t\t<td>%%Store_Logo%%</td>\r\n\t\t\t\t\t<td align=\"right\"><font face=\"Arial, Helvetica, sans-serif\" size=\"3\" color=\"#000000\">%%Store_Address,Phone%%</font></td>\r\n\t\t\t\t\t<td width=\"10\"></td>\r\n\t\t\t\t</tr>\r\n\t\t\t</table>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td valign=\"top\" align=\"center\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\"><b>Order Number: %%Order_Number%%</b></font></td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td valign=\"top\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\"><b>%%Date_Purchased%%</b></font></td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td valign=\"top\" bgcolor=\"#FCF7E4\" style=\"border:1px solid #F5EED1\">\r\n\t\t\t<table border=\"0\" cellpadding=\"3\" width=\"100%\" cellspacing=\"0\">\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td bgcolor=\"#3966B1\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#FFFFFF\"><b>Products</b></font></td>\r\n\t\t\t\t</tr>\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td valign=\"top\">\r\n\t\t\t\t\t\t%%Products_Ordered%%\r\n\t\t\t\t\t</td>\r\n\t\t\t\t</tr>\r\n\t\t\t</table>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td valign=\"top\" bgcolor=\"#FCF7E4\" style=\"border:1px solid #F5EED1\">\r\n\t\t\t<table border=\"0\" cellpadding=\"3\" width=\"100%\" cellspacing=\"0\">\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td bgcolor=\"#3966B1\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#FFFFFF\"><b>Delivery Details</b></font></td>\r\n\t\t\t\t</tr>\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td valign=\"top\">\r\n\t\t\t\t\t<table border=\"0\" cellpadding=\"3\" width=\"100%\" cellspacing=\"0\">\r\n\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t<td width=\"120\" valign=\"top\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">Address: </font></td>\r\n\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">%%Shipping_Address%%</font></td>\r\n\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">Phone: </font></td>\r\n\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">%%Phone%%</font></td>\r\n\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">Email: </font></td>\r\n\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">%%Email_Address%%</font></td>\r\n\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t</table>\r\n\t\t\t\t\t</td>\r\n\t\t\t\t</tr>\r\n\t\t\t</table>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td valign=\"top\" bgcolor=\"#FCF7E4\" style=\"border:1px solid #F5EED1\">\r\n\t\t\t<table border=\"0\" cellpadding=\"3\" width=\"100%\" cellspacing=\"0\">\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td bgcolor=\"#3966B1\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#FFFFFF\"><b>Payment Details</b></font></td>\r\n\t\t\t\t</tr>\r\n\t\t\t\t<tr>\r\n\t\t\t\t\t<td valign=\"top\">\r\n\t\t\t\t\t<table border=\"0\" cellpadding=\"3\" width=\"100%\" cellspacing=\"0\">\r\n\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t<td width=\"120\" valign=\"top\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">Address: </font></td>\r\n\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">%%Billing_Address%%</font></td>\r\n\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">Payment Method: </font></td>\r\n\t\t\t\t\t\t\t<td><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">%%Payment_Method%%</font></td>\r\n\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t\t<tr>\r\n\t\t\t\t\t\t\t<td colspan=\"2\"><font face=\"Arial, Helvetica, sans-serif\" size=\"1\" color=\"#000000\">%%Order_Comments%%</font></td>\r\n\t\t\t\t\t\t</tr>\r\n\t\t\t\t\t</table>\r\n\t\t\t\t\t</td>\r\n\t\t\t\t</tr>\r\n\t\t\t</table>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t\t<tr height=\"30\">\r\n\t\t\t<td></td>\r\n\t\t</tr>\r\n\t\t<tr>\r\n\t\t\t<td valign=\"top\" align=\"center\"><font face=\"Arial, Helvetica, sans-serif\" size=\"2\" color=\"#000000\">\r\n\t\t\t<b>Thanks for your business - %%Store_Name%%</b>\r\n\t\t\t</font>\r\n\t\t\t</td>\r\n\t\t</tr>\r\n\t</table>\r\n\t</td>\r\n</tr>\r\n</table>\r\n</body>\r\n</html>','','MIV'),
  (8,'','Welcome New Affiliate','shop@freeway.com','<P>Dear %%First_Name%%,</P>\r\n<P>Thank you for signing up to %%Store_Name%% affiliate program.Your account details are below:</P>\r\n<P>Username: %%Login_Email%% <BR>Password: %%Login_Password%%</P>\r\n<P>Affiliate ID Number: %%Id_Number%%</P>\r\n<P>You can log into your account and view your ''real-time'' statistics by going to:</P>\r\n<P>%%Affilliate_Link%% </P>\r\n<P>Thank you once again, and we wish you luck with your profit making! </P>\r\n<P>Affiliate Manager<BR>%%Store_Owner%%</P>','H','AFT'),
  (9,'','Affliate Lost Password','shop@freeway.com','Dear %%First_Name%%,<BR>Your %%Store_Name%% account details are as follows: <BR>Username: %%Username%% <BR>Password: %%Password%%  \r\nThis is your affiliate link:\r\n%%Affliate_Link%%\r\n<BR>If you have trouble accessing your account, please contact us at: %%Store_Email%% \r\nWith thanks,\r\n%%Store_Owner%%','T','AFR');

#
# Data for the `events_instructors` table  
#

INSERT INTO `events_instructors` (`instructors_id`, `admin_id`, `instructors_gender`, `instructors_dob`, `instructors_street_address`, `instructors_suburb`, `instructors_postcode`, `instructors_city`, `instructors_state`, `instructors_country`, `instructors_telephone`, `instructors_fax`, `instructors_department`, `instructors_position`, `instructors_description`, `instructors_qualifications`, `instructors_payment`) VALUES 
  (1,2,'f','2006-10-10','qo Test Street','Testville','4001','Brisbane','Queensland','13','12345678','','','','','','');

#
# Data for the `events_instructors_options` table  
#

INSERT INTO `events_instructors_options` (`options_id`, `options_name`, `options_key`) VALUES 
  (1,'Department','DE'),
  (2,'Position','PO'),
  (3,'Qualifications','QA');

#
# Data for the `events_instructors_options_values` table  
#

INSERT INTO `events_instructors_options_values` (`options_values_id`, `options_key`, `options_values_text`) VALUES 
  (22,'Wo','DE'),
  (23,'He','DE'),
  (24,'Tr','PO'),
  (26,'Pr','PO'),
  (27,'Ju','PO'),
  (28,'In','PO'),
  (29,'Se','PO'),
  (30,'Tr','QA');

#
# Data for the `events_locations` table  
#

INSERT INTO `events_locations` (`location_id`, `location_name`, `location_details`, `location_travel_directions`, `location_equipment`, `location_contact_person`, `location_seats`) VALUES 
  (1,'Carnegie Hall','Carnegie hall','New York','Overhead projector','Management',5),
  (2,'Casino Rama','Casino Rama','Orillia ON','CANADA','Overhead projector,Management',5),
  (3,'Dance Studio','Level 2, 24 Burton Lane\r\nSmithton, Brisbane','','','',100);

#
# Data for the `events_locations_options` table  
#

INSERT INTO `events_locations_options` (`equipment_name`) VALUES 
  ('Sprung Wooden Floor'),
  ('Sprung Floor'),
  ('Wall Mirrors'),
  ('Overhead projector');

#
# Data for the `faqdesk` table  
#

INSERT INTO `faqdesk` (`faqdesk_id`, `faqdesk_image`, `faqdesk_image_two`, `faqdesk_image_three`, `faqdesk_date_added`, `faqdesk_last_modified`, `faqdesk_date_available`, `faqdesk_status`, `faqdesk_sticky`) VALUES 
  (5,'freeway_logo.jpg','','','2007-04-26 17:35:40','0000-00-00','2007-04-26 17:35:40',1,1);

#
# Data for the `faqdesk_categories` table  
#

INSERT INTO `faqdesk_categories` (`categories_id`, `categories_image`, `parent_id`, `sort_order`, `date_added`, `last_modified`, `catagory_status`) VALUES 
  (2,'',0,1,'2007-04-26 17:35:40','0000-00-00',1);

#
# Data for the `faqdesk_categories_description` table  
#

INSERT INTO `faqdesk_categories_description` (`categories_id`, `language_id`, `categories_name`, `categories_heading_title`, `categories_description`) VALUES 
  (2,1,'General Questions',NULL,NULL);

#
# Data for the `faqdesk_configuration` table  
#

INSERT INTO `faqdesk_configuration` (`configuration_id`, `configuration_title`, `configuration_key`, `configuration_value`, `configuration_description`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES 
  (1,'Search Results','MAX_DISPLAY_FAQDESK_SEARCH_RESULTS','20','How many FAQS do you want to list?',1,1,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (2,'Page Links','MAX_DISPLAY_FAQDESK_PAGE_LINKS','5','Number of links to use for page-sets',1,2,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (3,'Display Question','FAQDESK_QUESTION','1','Do you want to display the question? (0=disable; 1-4 sort order)',1,3,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (4,'Display Short Answer','FAQDESK_SHORT_ANSWER','2','Do you want to display the short answer? (0=disable; 1-4 sort order)',1,4,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (5,'Display Long Answer','FAQDESK_LONG_ANSWER','3','Do you want to display the long Answer? (0=disable; 1-4 sort order)',1,5,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (6,'Display Date','FAQDESK_DATE_AVAILABLE','4','Do you want to display the date? (0=disable; 1-4 sort order)',1,6,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (7,'Location of Prev/Next Navigation Bar','FAQDESK_PREV_NEXT_BAR_LOCATION','3','Sets the location of the Prev/Next Navigation Bar (1-top, 2-bottom, 3-both)',1,12,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (8,'Display Main FAQS Items','MAX_DISPLAY_FAQDESK_FAQS','3','How many FAQS do you want to display on the top page?',2,1,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (9,'Latest FAQS Box Counts','LATEST_DISPLAY_FAQDESK_FAQS','5','How many FAQS do you want to display in the Latest News Box?',2,2,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (10,'Display Latest FAQS Box','DISPLAY_LATEST_FAQS_BOX','1','Do you want to display the Latest FAQS Box? (0=disable; 1=enable)',2,3,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (11,'Display FAQS Catagory Box','DISPLAY_FAQS_CATAGORY_BOX','1','Do you want to display the FAQS Catagory Box? (0=disable; 1=enable)',2,4,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (12,'Display View Counts','DISPLAY_FAQDESK_VIEWCOUNT','1','Do you want to display View Counts? (0=disable; 1=enable)',2,5,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (13,'Display Read More','DISPLAY_FAQDESK_READMORE','1','Do you want to display Read More? (0=disable; 1=enable)',2,6,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (14,'Display Short Answwer','DISPLAY_FAQDESK_SHORT_ANSWER','1','Do you want to display the Short Answer? (0=disable; 1=enable)',2,7,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (15,'Display Question','DISPLAY_FAQDESK_QUESTION','1','Do you want to display the Question? (0=disable; 1=enable)',2,8,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (16,'Display Date','DISPLAY_FAQDESK_DATE','1','Do you want to display the FAQS Date? (0=disable; 1=enable)',2,9,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (17,'Display Image 1','DISPLAY_FAQDESK_IMAGE','1','Do you want to display image \"1\" for the FAQ? (0=disable; 1=enable)',2,10,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (18,'Display Image 2','DISPLAY_FAQDESK_IMAGE_TWO','1','Do you want to display image \"2\" for the FAQ? (0=disable; 1=enable)',2,11,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (19,'Display Image 3','DISPLAY_FAQDESK_IMAGE_THREE','1','Do you want to display image \"3\" for the FAQ? (0=disable; 1=enable)',2,12,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (20,'Display Reviews','DISPLAY_FAQDESK_REVIEWS','1','Do you want to display FAQS Reviews? (0=disable; 1=enable)',3,1,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (21,'New Reviews','MAX_DISPLAY_NEW_REVIEWS','10','Maximum number of new reviews to display',3,2,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (22,'Display Question','STICKY_QUESTION','1','Do you want to display the question? (0=disable; 1=enable)',4,1,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (23,'Display Short Answer','STICKY_SHORT_ANSWER','1','Do you want to display the short answer? (0=disable; 1=enable)',4,2,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (24,'Display Long Answer','STICKY_LONG_ANSWER','1','Do you want to display the long answer? (0=disable; 1=enable)',4,3,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (25,'Display View Counts','STICKY_FAQDESK_VIEWCOUNT','0','Do you want to display View Counts? (0=disable; 1=enable)',4,4,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (26,'Display Read More','STICKY_FAQDESK_READMORE','0','Do you want to display Read More? (0=disable; 1=enable)',4,5,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (27,'Display Date','STICKY_DATE_ADDED','0','Do you want to display the date? (0=disable; 1=enable)',4,6,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (28,'Display URL','STICKY_EXTRA_URL','1','Do you want to display the extra URL? (0=disable; 1=enable)',4,7,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (29,'Display Image','STICKY_IMAGE','1','Do you want to display image \"1\" for the FAQ? (0=disable; 1=enable)',4,8,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (30,'Display Image 2','STICKY_IMAGE_TWO','1','Do you want to display image \"2\"for the FAQ? (0=disable; 1=enable)',4,9,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (31,'Display Image 3','STICKY_IMAGE_THREE','1','Do you want to display image \"3\" for the FAQ? (0=disable; 1=enable)',4,10,'0000-00-00','2007-04-26 17:35:40',NULL,NULL),
  (32,'Allow Category Descriptions','ALLOW_CATEGORY_DESCRIPTIONS','1','Allow use of full text descriptions for categories? (true=disable; false=enable)',5,1,'0000-00-00','2007-04-26 17:35:41',NULL,'tep_cfg_select_option(array(''true'', ''false''),');

#
# Data for the `faqdesk_configuration_group` table  
#

INSERT INTO `faqdesk_configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES 
  (1,'Listing Settings','Listing Page configuration options',1,1),
  (2,'Frontpage Settings','Front Page configuration options',1,1),
  (3,'Reviews Settings','Reviews configuration options',1,1),
  (4,'Sticky Settings','Reviews configuration options',1,1),
  (5,'Other Settings','FAQDesk wide options',1,1);

#
# Data for the `faqdesk_to_categories` table  
#

INSERT INTO `faqdesk_to_categories` (`faqdesk_id`, `categories_id`) VALUES 
  (3,1),
  (4,1);

#
# Data for the `featured` table  
#

INSERT INTO `featured` (`featured_id`, `products_id`, `featured_date_added`, `featured_last_modified`, `expires_date`, `date_status_change`, `status`) VALUES 
  (1,8,'2007-04-26 17:35:41','0000-00-00','2012-04-26','2007-04-26 17:35:41',1);

#
# Data for the `geo_zones` table  
#

INSERT INTO `geo_zones` (`geo_zone_id`, `geo_zone_name`, `geo_zone_description`, `last_modified`, `date_added`) VALUES 
  (1,'USA','United States of America','0000-00-00','2007-04-26 17:35:28'),
  (2,'World Zones','All International Zones','0000-00-00','2007-04-26 17:35:28'),
  (3,'Australia','Australia Zones','0000-00-00','2007-04-26 17:35:28');

#
# Data for the `infobox_configuration` table  
#

INSERT INTO `infobox_configuration` (`template_id`, `infobox_id`, `infobox_file_name`, `infobox_define`, `infobox_display`, `display_in_column`, `location`, `sort_order`, `last_modified`, `date_added`, `box_heading`, `box_template`, `box_heading_font_color`) VALUES 
  (2,30,'languages.php','BOX_HEADING_LANGUAGES','yes','right',1,6,'0000-00-00','2007-04-26 17:35:42','Languages','infobox','#000066'),
  (2,31,'manufacturer_info.php','BOX_HEADING_MANUFACTURER_INFO','no','left',6,7,'0000-00-00','2007-04-26 17:35:42','Manufactures Info','infobox','#000066'),
  (2,32,'manufacturers.php','BOX_HEADING_MANUFACTURERS','no','left',7,8,'0000-00-00','2007-04-26 17:35:42','Manufactures','infobox','#000066'),
  (2,33,'order_history.php','BOX_HEADING_CUSTOMER_ORDERS','yes','left',7,9,'0000-00-00','2007-04-26 17:35:42','Order History','infobox','#000066'),
  (2,34,'product_notifications.php','BOX_HEADING_NOTIFICATIONS','yes','left',8,10,'0000-00-00','2007-04-26 17:35:42','Notifications','infobox','#000066'),
  (2,35,'reviews.php','BOX_HEADING_REVIEWS','no','left',9,11,'0000-00-00','2007-04-26 17:35:42','Reviews','infobox','#000066'),
  (2,36,'search.php','BOX_HEADING_SEARCH','no','left',10,12,'0000-00-00','2007-04-26 17:35:42','Quick Find','infobox','#000066'),
  (2,37,'shopping_cart.php','BOX_HEADING_SHOPPING_CART','yes','right',2,13,'0000-00-00','2007-04-26 17:35:42','Shopping Cart','infobox','#FF3366'),
  (2,38,'specials.php','BOX_HEADING_SPECIALS','yes','left',12,14,'0000-00-00','2007-04-26 17:35:42','Specials','infobox','#000066'),
  (2,39,'tell_a_friend.php','BOX_HEADING_TELL_A_FRIEND','no','left',4,15,'0000-00-00','2007-04-26 17:35:42','Tell A Friend','infobox','#FFFF00'),
  (2,40,'whats_new.php','BOX_HEADING_WHATS_NEW','yes','left',7,16,'0000-00-00','2007-04-26 17:35:42','Latest products','infobox','#FF0000'),
  (2,41,'newsbox.php','BOX_HEADING_NEWSBOX','no','left',20,17,'0000-00-00','2007-04-26 17:35:42','News Box','infobox','#000066'),
  (2,42,'theme_select.php','BOX_HEADING_TEMPLATE_SELECT','no','left',4,18,'0000-00-00','2007-04-26 17:35:42','Select Template','infobox','#000066'),
  (2,43,'featured.php','BOX_HEADING_FEATURED','yes','left',11,19,'0000-00-00','2007-04-26 17:35:42','featured','infobox','#669966'),
  (2,44,'affiliate.php','BOX_HEADING_AFFILIATE','yes','left',18,20,'0000-00-00','2007-04-26 17:35:42','Affiliate Info','infobox','#000000'),
  (2,45,'newsdesk.php','BOX_HEADING_NEWSDESK_CATEGORIES','no','left',13,21,'0000-00-00','2007-04-26 17:35:42','NewsDesk','infobox','#660000'),
  (2,46,'newsdesk_latest.php','BOX_HEADING_NEWSDESK_LATEST','no','left',15,21,'0000-00-00','2007-04-26 17:35:42','NewsDesk Latest','infobox','#660000'),
  (2,47,'faqdesk.php','BOX_HEADING_FAQDESK_CATEGORIES','no','left',16,21,'0000-00-00','2007-04-26 17:35:42','FaqDesk','infobox','#660000'),
  (2,48,'faqdesk_latest.php','BOX_HEADING_FAQDESK_LATEST','yes','left',17,21,'0000-00-00','2007-04-26 17:35:42','FaqDesk Latest','infobox','#660000'),
  (2,49,'best_sellers.php','BOX_HEADING_BESTSELLERS','no','left',19,1,'0000-00-00','2007-04-26 17:35:42','Best Sellers','infobox','#000066'),
  (2,50,'categories.php','BOX_HEADING_CATEGORIES','yes','left',4,20,'0000-00-00','2007-04-26 17:35:42','Products','infobox','#000066'),
  (2,51,'currencies.php','BOX_HEADING_CURRENCIES','no','left',21,3,'0000-00-00','2007-04-26 17:35:42','Currencies','infobox','#000066'),
  (2,52,'information.php','BOX_HEADING_INFORMATION','yes','left',14,5,'0000-00-00','2007-04-26 17:35:42','Information','infobox','#990000'),
  (2,53,'loginbox.php','BOX_HEADING_LOGIN','yes','',1,22,'0000-00-00','2007-04-26 17:35:42','Login','infobox','#FFCCFF'),
  (2,54,'polls.php','BOX_HEADING_EXAMPLE','no','left',24,23,'0000-00-00','2007-04-26 17:35:42','Details','example.tpl.php','#FF99FF'),
  (2,55,'events.php','BOX_HEADING_EVENTS_CATEGORIES','yes','left',4,4,'0000-00-00','2007-04-26 17:35:42','Classes','infobox','#000066'),
  (2,57,'subscription.php','BOX_HEADING_SUBSCRIPTION','yes','left',5,2,'0000-00-00','2007-04-26 17:35:43','Subscription','infobox','#000066'),
  (2,59,'wallet.php','BOX_HEADING_WALLET','yes','left',6,6,'0000-00-00','2007-04-26 17:36:00','My Wallet','infobox','#000066'),
  (2,61,'services.php','BOX_HEADING_SERVICES','yes','left',5,2,'0000-00-00','2007-04-26 17:36:07','Services','infobox','#000000');

#
# Data for the `languages` table  
#

INSERT INTO `languages` (`languages_id`, `name`, `code`, `image`, `directory`, `sort_order`) VALUES 
  (1,'English','en','icon.gif','english',1);

#
# Data for the `latest_news` table  
#

INSERT INTO `latest_news` (`news_id`, `headline`, `content`, `date_added`, `status`) VALUES 
  (2,'Coming Soon!!!!','Watch this space for details on how you can customise your Freeway solutions using exciting templates and tools available only from this site.\r\n<br>In addition we will be offering advice on how to get the most from Freeway and will include regular articles on customisation options including fully detailed examples\r\n<br>Within the next month we will have an exciting range of templates and buttons available for download, so call back.\r\n<br>We have include a few examples of what can be done by customising Freeway in this Demo. Any accounts created or orders made from this demonstration will obviously not be fulfilled.','2007-04-26 17:35:43',1);

#
# Data for the `main_page_description` table  
#

INSERT INTO `main_page_description` (`page_id`, `page_name`, `description`, `language_id`) VALUES 
  (1,'Shipping & Returns','<html><head><title>&nbsp;</title></head><body><strong>Shipping</strong> <br />\r\n  Shipping costs for orders from freeway.com depend upon the method and option \r\n  you choose. All items in an order are grouped together by total weight. There \r\n  are no shipping costs associated with Classes, workshops or courses.\r\n<p><strong>Delivery Time</strong> <br />\r\n  When you place an order, we will estimate shipping and delivery dates for you \r\n  based on the availability of your items and the shipping options you choose. \r\n  Shipping date estimates will appear in the order form. </p>\r\n<p><strong>Returns</strong> <br />\r\n  You may return most items sold by freeway.com within 30 days of delivery \r\n  for a full refund. We will also pay the return shipping cost if the return is \r\n  a result of our error. Please note that we are unable to exchange items (however, \r\n  if you received a damaged, defective, or incorrect item, see below). </p>\r\n<p>We cannot accept returns of certain items, including:</p>\r\n<p> Any product missing the serial number or shipping code. </p>\r\n<p>In addition, we will only issue partial refunds for the return of certain items, \r\n  including:</p>\r\n<p> Any item that is returned more than 30 days after delivery. <br />\r\n  Any book that has obvious signs of use. <br />\r\n  Any CD, DVD or VHS tape that has been opened (taken out of its plastic wrap). \r\n  <br />\r\n  Any item that is not in its original condition, is damaged, or is missing parts.</p>\r\n<p><strong>Damaged or Defective Items</strong>\r\n<br />\r\n  Did you receive a damaged or defective item? If the item has a damaged or defective \r\n  part, we recommend that you contact the manufacturer to see if they can have \r\n  this part shipped directly to you. You can usually find contact information \r\n  listed in the product manual that came with the item. We will ask you to indicate \r\n  the number of items you are returning, the reason for return, and whether you \r\n  would like a refund or a replacement item sent to you.</p></body></html>',1),
  (2,'Privacy Notice','<html><head><title>&nbsp;</title></head><body>Freeway is strongly committed to protecting your privacy while\r\ninteracting with our content, products and services. Please see our\r\nexample Privacy Policy in the Freeway documentation. This is intended\r\nas an example policy only. Seek legal advice regarding your own\r\nbusiness privacy policy.</body></html>',1),
  (3,'Conditions of Use','<html><head><title>&nbsp;</title></head><body><p><strong>Shopping Cart</strong>\r\n<br />All the items that you have in your shopping cart appear in your order during \r\n  Checkout. If you do not want to order all the items, simply edit your shopping \r\n  cart first and click &quot;Update&quot;. When you click &quot;Submit Order&quot; we verify your \r\n  credit card. Your order will not be placed and your credit card will not be \r\n  charged if you do not click &quot;Order Now.&quot; </p>\r\n<p><strong>Methods of payment</strong>\r\n<br /> We accept cheques and money orders but these orders will be classes as pending \r\n  until we receive cheque or money order funds into our account. Freeway Online \r\n  Shop accepts the following credit cards: Visa, MasterCard and BankCard. If we \r\n  are unable to process your credit card, please check to ensure you entered the \r\n  correct card number and expiration date, and that the billing name and address \r\n  you entered match your credit card statement exactly. Please refer to your credit \r\n  card company if the problem persists.</p>\r\n<p> <strong>Tax policy</strong>\r\n<br /> We are required to collect GST on service items sold to customers in Australia. \r\n</p>\r\n<p><strong>Returns and Exchanges</strong>\r\n<br /> Event fees are not transferable or refundable except where noted in the individual event conditions.</p> \r\n<p><strong>Credit Card Safeguard</strong> <br />\r\n  Freeway uses a Secure Internet Payment Gateway to provide a secure environment \r\n  for the authorisation of credit card transactions over the Internet. Confidential \r\n  information including client credit card details are encrypted the moment they \r\n  are transmitted from the clients browser to the banking network using industry \r\n  standard SSL 128-bit RC4 encryption technology. Client credit card details are \r\n  not stored anywhere on the Internet and the only company who has access to this \r\n  data is the merchants bank. The bank also sends confirmation information via \r\n  the same encryption technology back to the clients browser. These secure processes \r\n  provide clients with peace of mind when purchasing online. </p>\r\n<p><strong>Privacy</strong> <br />\r\n  We collect customer information in an effort to improve your shopping experience \r\n  and to communicate with you about our products, services, contests, and promotions. \r\n  For more information, see our privacy\r\npolicy. </p></body></html>',1),
  (4,'About us','<html><head><title>&nbsp;</title></head><body>\r\n\r\n\r\n<table width=\"100%\" cellspacing=\"0\" cellpadding=\"1\" border=\"0\"><tbody><tr>\r\n<td valign=\"top\">\r\n\r\n<!--Lango Added for Template MOD: EOF-->\r\n<br /></td></tr><tr>\r\n   <td class=\"main\">Freeway\r\nis strongly committed to protecting your privacy while interacting with\r\nour content, products and services. Please see our example Privacy\r\nPolicy in the Freeway documentation. This is intended as an example\r\npolicy only. Seek legal advice regarding your own business privacy\r\npolicy</td></tr></tbody></table></body></html>',1);

#
# Data for the `main_pages` table  
#

INSERT INTO `main_pages` (`page_id`, `parent_id`, `date_created`, `date_modified`, `sort_order`, `page_status`) VALUES 
  (1,0,'2007-04-26 17:36:31','0000-00-00',1,1),
  (2,0,'2007-04-26 17:36:31','0000-00-00',2,1),
  (3,0,'2007-04-26 17:36:31','0000-00-00',3,1),
  (4,0,'2007-04-26 17:36:31','0000-00-00',4,1);


#
# Data for the `newsdesk_configuration` table  
#

INSERT INTO `newsdesk_configuration` (`configuration_id`, `configuration_title`, `configuration_key`, `configuration_value`, `configuration_description`, `configuration_group_id`, `sort_order`, `last_modified`, `date_added`, `use_function`, `set_function`) VALUES 
  (1,'Search Results','MAX_DISPLAY_NEWSDESK_SEARCH_RESULTS','20','How many articles do you want to list?',1,1,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (2,'Page Links','MAX_DISPLAY_NEWSDESK_PAGE_LINKS','5','Number of links to use for page-sets',1,2,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (3,'Display Headline','NEWSDESK_ARTICLE_NAME','1','Do you want to display the headline? (0=disable; 1=enable)',1,3,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (4,'Display Summary','NEWSDESK_ARTICLE_SHORTTEXT','1','Do you want to display the summary? (0=disable; 1=enable)',1,4,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (5,'Display Content','NEWSDESK_ARTICLE_DESCRIPTION','1','Do you want to display the content? (0=disable; 1=enable)',1,5,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (6,'Display Date','NEWSDESK_DATE_AVAILABLE','1','Do you want to display the date? (0=disable; 1=enable)',1,6,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (7,'Display URL','NEWSDESK_ARTICLE_URL','1','Do you want to display the outside resource URL? (0=disable; 1=enable)',1,7,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (8,'Display Status','NEWSDESK_STATUS','1','Do you want to display the status for the article? (0=disable; 1=enable)',1,8,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (9,'Display Image 1','NEWSDESK_IMAGE','1','Do you want to display image \"1\" for the article? (0=disable; 1=enable)',1,9,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (10,'Display Image 2','NEWSDESK_IMAGE_TWO','1','Do you want to display image \"2\" for the article? (0=disable; 1=enable)',1,10,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (11,'Display Image 3','NEWSDESK_IMAGE_THREE','1','Do you want to display image \"3\" for the article? (0=disable; 1=enable)',1,11,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (12,'Location of Prev/Next Navigation Bar','NEWSDESK_PREV_NEXT_BAR_LOCATION','3','Sets the location of the Prev/Next Navigation Bar (1-top, 2-bottom, 3-both)',1,12,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (14,'Display Main News Items','MAX_DISPLAY_NEWSDESK_NEWS','3','How many articles do you want to display on the top page?',2,1,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (15,'Latest News Box Counts','LATEST_DISPLAY_NEWSDESK_NEWS','5','How many articles do you want to display in the Latest News Box?',2,2,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (16,'Display Latest News Box','DISPLAY_LATEST_NEWS_BOX','1','Do you want to display the Latest News Box? (0=disable; 1=enable)',2,3,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (17,'Display News Catagory Box','DISPLAY_NEWS_CATAGORY_BOX','1','Do you want to display the News Catagory Box? (0=disable; 1=enable)',2,4,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (18,'Display View Counts','DISPLAY_NEWSDESK_VIEWCOUNT','1','Do you want to display View Counts? (0=disable; 1=enable)',2,5,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (19,'Display Read More','DISPLAY_NEWSDESK_READMORE','1','Do you want to display Read More? (0=disable; 1=enable)',2,6,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (20,'Display Summary','DISPLAY_NEWSDESK_SUMMARY','1','Do you want to display the News Summary? (0=disable; 1=enable)',2,7,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (21,'Display Headline','DISPLAY_NEWSDESK_HEADLINE','1','Do you want to display the News Headline? (0=disable; 1=enable)',2,8,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (22,'Display Date','DISPLAY_NEWSDESK_DATE','1','Do you want to display the News Date? (0=disable; 1=enable)',2,9,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (23,'Display Image 1','DISPLAY_NEWSDESK_IMAGE','1','Do you want to display image \"1\" for the article? (0=disable; 1=enable)',2,10,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (24,'Display Image 2','DISPLAY_NEWSDESK_IMAGE_TWO','1','Do you want to display image \"2\" for the article? (0=disable; 1=enable)',2,11,'2003-03-03 12:08:55','2007-04-26 17:35:43',NULL,NULL),
  (25,'Display Image 3','DISPLAY_NEWSDESK_IMAGE_THREE','1','Do you want to display image \"3\" for the article? (0=disable; 1=enable)',2,12,'2003-03-03 12:09:16','2007-04-26 17:35:43',NULL,NULL),
  (26,'Display Reviews','DISPLAY_NEWSDESK_REVIEWS','1','Do you want to display News Reviews? (0=disable; 1=enable)',3,1,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (27,'New Reviews','MAX_DISPLAY_NEW_REVIEWS','10','Maximum number of new reviews to display',3,2,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (28,'Display Headline','STICKY_ARTICLE_NAME','1','Do you want to display the headline? (0=disable; 1=enable)',4,1,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (29,'Display Summary','STICKY_ARTICLE_SHORTTEXT','1','Do you want to display the summary? (0=disable; 1=enable)',4,2,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (30,'Display Content','STICKY_ARTICLE_DESCRIPTION','1','Do you want to display the content? (0=disable; 1=enable)',4,3,'2003-03-02 00:49:34','2007-04-26 17:35:43',NULL,NULL),
  (31,'Display View Counts','STICKY_NEWSDESK_VIEWCOUNT','1','Do you want to display View Counts? (0=disable; 1=enable)',4,4,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (32,'Display Read More','STICKY_NEWSDESK_READMORE','1','Do you want to display Read More? (0=disable; 1=enable)',4,5,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (33,'Display Date','STICKY_DATE_ADDED','1','Do you want to display the date? (0=disable; 1=enable)',4,6,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (34,'Display URL','STICKY_ARTICLE_URL','1','Do you want to display the outside resource URL? (0=disable; 1=enable)',4,7,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (35,'Display Image','STICKY_IMAGE','1','Do you want to display image \"1\" for the article? (0=disable; 1=enable)',4,8,'0000-00-00','2007-04-26 17:35:43',NULL,NULL),
  (36,'Display Image 2','STICKY_IMAGE_TWO','1','Do you want to display image \"2\"for the article? (0=disable; 1=enable)',4,9,'0000-00-00','2007-04-26 17:35:44',NULL,NULL),
  (37,'Display Image 3','STICKY_IMAGE_THREE','1','Do you want to display image \"3\" for the article? (0=disable; 1=enable)',4,10,'0000-00-00','2007-04-26 17:35:44',NULL,NULL);

#
# Data for the `newsdesk_configuration_group` table  
#

INSERT INTO `newsdesk_configuration_group` (`configuration_group_id`, `configuration_group_title`, `configuration_group_description`, `sort_order`, `visible`) VALUES 
  (1,'Listing Settings','Listing Page configuration options',1,1),
  (2,'Frontpage Settings','Front Page configuration options',1,1),
  (3,'Reviews Settings','Reviews configuration options',1,1),
  (4,'Sticky Settings','Reviews configuration options',1,1);

#
# Data for the `orders_status` table  
#

INSERT INTO `orders_status` (`orders_status_id`, `language_id`, `orders_status_name`) VALUES 
  (4,1,'Backorder'),
  (3,1,'Delivered'),
  (1,1,'Pending'),
  (2,1,'Processing');


#
# Data for the `products_options` table  
#

INSERT INTO `products_options` (`products_options_id`, `language_id`, `products_options_name`, `products_options_sort_order`) VALUES 
  (1,1,'Size',1),
  (2,1,'Special Edition CD',2);

#
# Data for the `products_options_values` table  
#

INSERT INTO `products_options_values` (`products_options_values_id`, `language_id`, `products_options_values_name`) VALUES 
  (1,1,'Small'),
  (2,1,'Medium'),
  (3,1,'Large'),
  (4,1,'Extra Large'),
  (5,1,'Upgrade'),
  (6,1,'Not Required');

#
# Data for the `resources` table  
#

INSERT INTO `resources` (`resource_id`, `resource_date_added`, `resource_last_modified`, `resource_tax_class_id`, `resource_costs`, `sort_order`) VALUES 
  (1,'2007-04-26 17:36:30','0000-00-00',2,14,1),
  (2,'2007-04-26 17:36:30','0000-00-00',2,25,2);

#
# Data for the `resources_description` table  
#

INSERT INTO `resources_description` (`resource_id`, `language_id`, `resource_name`, `resource_description`) VALUES 
  (1,1,'Court A','<html><head></head><body>This is a great Rebound Ace surface with high quality lighting.<br /></body></html>'),
  (2,1,'Court B','<html><head></head><body>This is one of the best maintained grass ourts in Brisbane and has quality lighting.<br /></body></html>');


#
# Data for the `services_locations` table  
#

INSERT INTO `services_locations` (`service_location_id`, `service_location_name`, `service_location_details`, `service_location_travel_directions`, `service_location_equipment`, `service_location_contact_person`, `service_location_seats`) VALUES 
  (1,'Sunnyside Tennis Club','24 Riverside Drive \r\nKelvin Grove','Along Kelvin Grove Road and turn off at Pine Street.','','',0);

#
# Data for the `services_options` table  
#

INSERT INTO `services_options` (`services_options_id`, `language_id`, `services_options_name`, `services_options_sort_order`) VALUES 
  (1,1,'Willson',1),
  (2,1,'Penn',2),
  (3,1,'Wils',3),
  (4,1,'Part2',4);

#
# Data for the `services_options_values` table  
#

INSERT INTO `services_options_values` (`services_options_values_id`, `language_id`, `services_options_values_name`) VALUES 
  (1,1,'Wilson 3 pack'),
  (2,1,'Wilson 4 pack'),
  (3,1,'Penn 3 pack'),
  (4,1,'Not required');

#
# Data for the `sources` table  
#

INSERT INTO `sources` (`sources_id`, `sources_name`) VALUES 
  (5,'Advertisement'),
  (1,'Friend'),
  (6,'Magazine'),
  (2,'Promotion'),
  (8,'Radio'),
  (4,'Search Engine'),
  (7,'Television'),
  (3,'Website');


#
# Data for the `tax_class` table  
#

INSERT INTO `tax_class` (`tax_class_id`, `tax_class_title`, `tax_class_description`, `last_modified`, `date_added`) VALUES 
  (2,'GST','Australian Goods and Services Tax','0000-00-00','2007-04-26 17:35:28'),
  (3,'CST','California Services Tax','0000-00-00','2007-04-26 17:35:28');

#
# Data for the `tax_rates` table  
#

INSERT INTO `tax_rates` (`tax_rates_id`, `tax_zone_id`, `tax_class_id`, `tax_priority`, `tax_rate`, `tax_description`, `last_modified`, `date_added`) VALUES 
  (2,3,2,0,10,'Australian Goods and Services Tax','0000-00-00','2007-04-26 17:35:28');

#
# Data for the `template` table  
#

INSERT INTO `template` (`template_id`, `template_name`, `date_added`, `last_modified`, `template_image`, `template_cellpadding_main`, `template_cellpadding_left`, `template_cellpadding_right`, `template_cellpadding_sub`, `site_width`, `side_box_left_width`, `side_box_right_width`, `include_column_left`, `include_column_right`, `box_width_left`, `box_width_right`, `main_table_border`, `active`, `show_heading_title_original`, `languages_in_header`, `cart_in_header`, `show_header_link_buttons`, `show_page_descriptions`, `module_one`, `module_two`, `module_three`, `module_four`, `module_five`, `module_six`, `customer_greeting`, `edit_customer_greeting_personal`, `edit_customer_greeting_personal_relogon`, `edit_greeting_guest`, `show_shipping_estimator`) VALUES 
  (2,'Freeway','2007-04-26 17:35:49','0000-00-00','freeway.gif','0','2','6','0','796','1','1','yes','no','125','125','yes','0','true','no','yes','no','no','mainpage.php','','','upcoming_products.php','','','yes','Welcome back <span class=\\\"greetUser\\\">%s!</span> Would you like to see which <a href=\\\"%s\\\"><u>new products</u></a> are available to purchase?','<small>If you are not %s, please <a href=\\\"%s\\\"><u>log yourself in</u></a> with your account information.</small>','Welcome <span class=\\\"greetUser\\\">Guest!</span> Would you like to <a href=\\\"%s\\\"><u>log yourself in</u></a>? Or would you prefer to <a href=\\\"%s\\\"><u>create an account</u></a>?','false');

#
# Data for the `zones` table  
#

INSERT INTO `zones` (`zone_id`, `zone_country_id`, `zone_code`, `zone_name`) VALUES 
  (1,223,'AL','Alabama'),
  (2,223,'AK','Alaska'),
  (3,223,'AS','American Samoa'),
  (4,223,'AZ','Arizona'),
  (5,223,'AR','Arkansas'),
  (6,223,'AF','Armed Forces Africa'),
  (7,223,'AA','Armed Forces Americas'),
  (8,223,'AC','Armed Forces Canada'),
  (9,223,'AE','Armed Forces Europe'),
  (10,223,'AM','Armed Forces Middle East'),
  (11,223,'AP','Armed Forces Pacific'),
  (12,223,'CA','California'),
  (13,223,'CO','Colorado'),
  (14,223,'CT','Connecticut'),
  (15,223,'DE','Delaware'),
  (16,223,'DC','District of Columbia'),
  (17,223,'FM','Federated States Of Micronesia'),
  (18,223,'FL','Florida'),
  (19,223,'GA','Georgia'),
  (20,223,'GU','Guam'),
  (21,223,'HI','Hawaii'),
  (22,223,'ID','Idaho'),
  (23,223,'IL','Illinois'),
  (24,223,'IN','Indiana'),
  (25,223,'IA','Iowa'),
  (26,223,'KS','Kansas'),
  (27,223,'KY','Kentucky'),
  (28,223,'LA','Louisiana'),
  (29,223,'ME','Maine'),
  (30,223,'MH','Marshall Islands'),
  (31,223,'MD','Maryland'),
  (32,223,'MA','Massachusetts'),
  (33,223,'MI','Michigan'),
  (34,223,'MN','Minnesota'),
  (35,223,'MS','Mississippi'),
  (36,223,'MO','Missouri'),
  (37,223,'MT','Montana'),
  (38,223,'NE','Nebraska'),
  (39,223,'NV','Nevada'),
  (40,223,'NH','New Hampshire'),
  (41,223,'NJ','New Jersey'),
  (42,223,'NM','New Mexico'),
  (43,223,'NY','New York'),
  (44,223,'NC','North Carolina'),
  (45,223,'ND','North Dakota'),
  (46,223,'MP','Northern Mariana Islands'),
  (47,223,'OH','Ohio'),
  (48,223,'OK','Oklahoma'),
  (49,223,'OR','Oregon'),
  (50,223,'PW','Palau'),
  (51,223,'PA','Pennsylvania'),
  (52,223,'PR','Puerto Rico'),
  (53,223,'RI','Rhode Island'),
  (54,223,'SC','South Carolina'),
  (55,223,'SD','South Dakota'),
  (56,223,'TN','Tennessee'),
  (57,223,'TX','Texas'),
  (58,223,'UT','Utah'),
  (59,223,'VT','Vermont'),
  (60,223,'VI','Virgin Islands'),
  (61,223,'VA','Virginia'),
  (62,223,'WA','Washington'),
  (63,223,'WV','West Virginia'),
  (64,223,'WI','Wisconsin'),
  (65,223,'WY','Wyoming'),
  (66,38,'AB','Alberta'),
  (67,38,'BC','British Columbia'),
  (68,38,'MB','Manitoba'),
  (69,38,'NF','Newfoundland'),
  (70,38,'NB','New Brunswick'),
  (71,38,'NS','Nova Scotia'),
  (72,38,'NT','Northwest Territories'),
  (73,38,'NU','Nunavut'),
  (74,38,'ON','Ontario'),
  (75,38,'PE','Prince Edward Island'),
  (76,38,'QC','Quebec'),
  (77,38,'SK','Saskatchewan'),
  (78,38,'YT','Yukon Territory'),
  (79,81,'NDS','Niedersachsen'),
  (80,81,'BAW','Baden-W?rttemberg'),
  (81,81,'BAY','Bayern'),
  (82,81,'BER','Berlin'),
  (83,81,'BRG','Brandenburg'),
  (84,81,'BRE','Bremen'),
  (85,81,'HAM','Hamburg'),
  (86,81,'HES','Hessen'),
  (87,81,'MEC','Mecklenburg-Vorpommern'),
  (88,81,'NRW','Nordrhein-Westfalen'),
  (89,81,'RHE','Rheinland-Pfalz'),
  (90,81,'SAR','Saarland'),
  (91,81,'SAS','Sachsen'),
  (92,81,'SAC','Sachsen-Anhalt'),
  (93,81,'SCN','Schleswig-Holstein'),
  (94,81,'THE','Th?ringen'),
  (95,14,'WI','Wien'),
  (96,14,'NO','Nieder?sterreich'),
  (97,14,'OO','Ober?sterreich'),
  (98,14,'SB','Salzburg'),
  (99,14,'KN','K?rnten'),
  (100,14,'ST','Steiermark'),
  (101,14,'TI','Tirol'),
  (102,14,'BL','Burgenland'),
  (103,14,'VB','Voralberg'),
  (104,204,'AG','Aargau'),
  (105,204,'AI','Appenzell Innerrhoden'),
  (106,204,'AR','Appenzell Ausserrhoden'),
  (107,204,'BE','Bern'),
  (108,204,'BL','Basel-Landschaft'),
  (109,204,'BS','Basel-Stadt'),
  (110,204,'FR','Freiburg'),
  (111,204,'GE','Genf'),
  (112,204,'GL','Glarus'),
  (113,204,'JU','Graub?nden'),
  (114,204,'JU','Jura'),
  (115,204,'LU','Luzern'),
  (116,204,'NE','Neuenburg'),
  (117,204,'NW','Nidwalden'),
  (118,204,'OW','Obwalden'),
  (119,204,'SG','St. Gallen'),
  (120,204,'SH','Schaffhausen'),
  (121,204,'SO','Solothurn'),
  (122,204,'SZ','Schwyz'),
  (123,204,'TG','Thurgau'),
  (124,204,'TI','Tessin'),
  (125,204,'UR','Uri'),
  (126,204,'VD','Waadt'),
  (127,204,'VS','Wallis'),
  (128,204,'ZG','Zug'),
  (129,204,'ZH','Z?rich'),
  (130,195,'A Coru?a','A Coru?a'),
  (131,195,'Alava','Alava'),
  (132,195,'Albacete','Albacete'),
  (133,195,'Alicante','Alicante'),
  (134,195,'Almeria','Almeria'),
  (135,195,'Asturias','Asturias'),
  (136,195,'Avila','Avila'),
  (137,195,'Badajoz','Badajoz'),
  (138,195,'Baleares','Baleares'),
  (139,195,'Barcelona','Barcelona'),
  (140,195,'Burgos','Burgos'),
  (141,195,'Caceres','Caceres'),
  (142,195,'Cadiz','Cadiz'),
  (143,195,'Cantabria','Cantabria'),
  (144,195,'Castellon','Castellon'),
  (145,195,'Ceuta','Ceuta'),
  (146,195,'Ciudad Real','Ciudad Real'),
  (147,195,'Cordoba','Cordoba'),
  (148,195,'Cuenca','Cuenca'),
  (149,195,'Girona','Girona'),
  (150,195,'Granada','Granada'),
  (151,195,'Guadalajara','Guadalajara'),
  (152,195,'Guipuzcoa','Guipuzcoa'),
  (153,195,'Huelva','Huelva'),
  (154,195,'Huesca','Huesca'),
  (155,195,'Jaen','Jaen'),
  (156,195,'La Rioja','La Rioja'),
  (157,195,'Las Palmas','Las Palmas'),
  (158,195,'Leon','Leon'),
  (159,195,'Lleida','Lleida'),
  (160,195,'Lugo','Lugo'),
  (161,195,'Madrid','Madrid'),
  (162,195,'Malaga','Malaga'),
  (163,195,'Melilla','Melilla'),
  (164,195,'Murcia','Murcia'),
  (165,195,'Navarra','Navarra'),
  (166,195,'Ourense','Ourense'),
  (167,195,'Palencia','Palencia'),
  (168,195,'Pontevedra','Pontevedra'),
  (169,195,'Salamanca','Salamanca'),
  (170,195,'Santa Cruz de Tenerife','Santa Cruz de Tenerife'),
  (171,195,'Segovia','Segovia'),
  (172,195,'Sevilla','Sevilla'),
  (173,195,'Soria','Soria'),
  (174,195,'Tarragona','Tarragona'),
  (175,195,'Teruel','Teruel'),
  (176,195,'Toledo','Toledo'),
  (177,195,'Valencia','Valencia'),
  (178,195,'Valladolid','Valladolid'),
  (179,195,'Vizcaya','Vizcaya'),
  (180,195,'Zamora','Zamora'),
  (181,195,'Zaragoza','Zaragoza'),
  (191,13,'NSW','New South Wales'),
  (192,13,'VIC','Victoria'),
  (193,13,'QLD','Queensland'),
  (194,13,'NT','Northern Territory'),
  (195,13,'WA','Western Australia'),
  (196,13,'SA','South Australia'),
  (197,13,'TAS','Tasmania'),
  (198,13,'ACT','Australian Capital Territory');

#
# Data for the `zones_to_geo_zones` table  
#

INSERT INTO `zones_to_geo_zones` (`association_id`, `zone_country_id`, `zone_id`, `geo_zone_id`, `last_modified`, `date_added`) VALUES 
  (1,1,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (2,2,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (3,3,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (4,4,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (5,5,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (6,6,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (7,7,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (8,8,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (9,9,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (10,10,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (11,11,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (12,12,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (13,223,0,1,'0000-00-00','2007-04-26 17:35:32'),
  (14,14,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (15,15,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (16,16,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (17,17,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (18,18,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (19,19,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (20,20,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (21,21,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (22,22,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (23,23,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (24,24,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (25,25,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (26,26,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (27,27,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (28,28,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (29,29,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (30,30,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (31,31,0,2,'0000-00-00','2007-04-26 17:35:32'),
  (32,32,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (33,33,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (34,34,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (35,35,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (36,36,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (37,37,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (38,38,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (39,39,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (40,40,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (41,41,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (42,42,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (43,43,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (44,44,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (45,45,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (46,46,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (47,47,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (48,48,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (49,49,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (50,50,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (51,51,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (52,52,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (53,53,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (54,54,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (55,55,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (56,56,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (57,57,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (58,58,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (59,59,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (60,60,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (61,61,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (62,62,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (63,63,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (64,64,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (65,65,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (66,66,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (67,67,0,2,'0000-00-00','2007-04-26 17:35:33'),
  (68,68,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (69,69,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (70,70,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (71,71,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (72,72,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (73,73,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (74,74,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (75,75,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (76,76,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (77,77,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (78,78,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (79,79,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (80,80,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (81,81,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (82,82,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (83,83,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (84,84,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (85,85,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (86,86,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (87,87,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (88,88,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (89,89,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (90,90,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (91,91,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (92,92,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (93,93,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (94,94,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (95,95,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (96,96,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (97,97,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (98,98,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (99,99,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (100,100,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (101,101,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (102,102,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (103,103,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (104,104,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (105,105,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (106,106,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (107,107,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (108,108,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (109,109,0,2,'0000-00-00','2007-04-26 17:35:34'),
  (110,110,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (111,111,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (112,112,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (113,113,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (114,114,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (115,115,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (116,116,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (117,117,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (118,118,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (119,119,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (120,120,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (121,121,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (122,122,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (123,123,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (124,124,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (125,125,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (126,126,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (127,127,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (128,128,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (129,129,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (130,130,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (131,131,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (132,132,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (133,133,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (134,134,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (135,135,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (136,136,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (137,137,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (138,138,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (139,139,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (140,140,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (141,141,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (142,142,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (143,143,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (144,144,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (145,145,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (146,146,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (147,147,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (148,148,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (149,149,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (150,150,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (151,151,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (152,152,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (153,153,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (154,154,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (155,155,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (156,156,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (157,157,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (158,158,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (159,159,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (160,160,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (161,161,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (162,162,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (163,163,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (164,164,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (165,165,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (166,166,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (167,167,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (168,168,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (169,169,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (170,170,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (171,171,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (172,172,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (173,173,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (174,174,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (175,175,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (176,176,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (177,177,0,2,'0000-00-00','2007-04-26 17:35:35'),
  (178,178,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (179,179,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (180,180,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (181,181,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (182,182,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (183,183,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (184,184,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (185,185,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (186,186,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (187,187,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (188,188,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (189,189,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (190,190,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (191,191,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (192,192,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (193,193,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (194,194,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (195,195,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (196,196,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (197,197,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (198,198,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (199,199,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (200,200,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (201,201,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (202,202,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (203,203,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (204,204,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (205,205,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (206,206,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (207,207,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (208,208,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (209,209,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (210,210,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (211,211,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (212,212,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (213,213,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (214,214,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (215,215,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (216,216,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (217,217,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (218,218,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (219,219,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (220,220,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (221,221,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (222,222,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (223,223,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (224,224,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (225,225,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (226,226,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (227,227,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (228,228,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (229,229,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (230,230,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (231,231,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (232,232,0,2,'0000-00-00','2007-04-26 17:35:36'),
  (233,233,0,2,'0000-00-00','2007-04-26 17:35:37'),
  (234,234,0,2,'0000-00-00','2007-04-26 17:35:37'),
  (235,235,0,2,'0000-00-00','2007-04-26 17:35:37'),
  (236,236,0,2,'0000-00-00','2007-04-26 17:35:37'),
  (237,237,0,2,'0000-00-00','2007-04-26 17:35:37'),
  (238,238,0,2,'0000-00-00','2007-04-26 17:35:37'),
  (239,239,0,2,'0000-00-00','2007-04-26 17:35:37'),
  (240,13,0,2,'0000-00-00','2007-04-26 17:35:37'),
  (241,13,0,3,'0000-00-00','2007-04-26 17:35:37');

#
# Structure for the `wallet_history` table : 
#
DROP TABLE IF EXISTS `wallet_history`;
CREATE TABLE `wallet_history` (
  `wallet_history_id` int(11) unsigned NOT NULL auto_increment,
  `customers_id` int(11) unsigned NOT NULL default '0',
  `drawn_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `orders_id` int(11) unsigned NOT NULL default '0',
  `amount` decimal(15,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`wallet_history_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `wallet_messages_history` table : 
#
DROP TABLE IF EXISTS `wallet_messages_history`;
CREATE TABLE `wallet_messages_history` (
  `wallet_history_id` int(11) unsigned NOT NULL auto_increment,
  `send_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `customers_id` int(11) unsigned NOT NULL default '0',
  `message_mode` char(1) NOT NULL default 'E',
  `message_type` char(3) NOT NULL default 'WFU',
  PRIMARY KEY  (`wallet_history_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

#
# Structure for the `wallet_uploads` table : 
#
DROP TABLE IF EXISTS `wallet_uploads`;
CREATE TABLE `wallet_uploads` (
  `wallet_id` int(11) unsigned NOT NULL auto_increment,
  `customers_id` int(11) unsigned NOT NULL default '0',
  `payment_date` datetime NOT NULL default '0000-00-00 00:00:00',
  `payment_method` text,
  `payment_info` text,
  `payment_status` mediumint(3) unsigned NOT NULL default '1',
  `comments` text,
  `amount` decimal(15,4) NOT NULL default '0.0000',
  PRIMARY KEY  (`wallet_id`)
) ENGINE=MyISAM DEFAULT CHARSET=latin1;

INSERT into sql_queries values('freeway_v1_0_0.sql',now());
